/*
@@@BUILDINFO@@@ Dr. Brown's 1-2-3 Process.jsx 2.0.4
*/

// 03/02/2010 15:50
// c2007 Adobe Systems, Inc. All rights reserved.
// Produced and Directed by Dr. Brown ( a.k.a Russell Preston Brown )
// Written by Tom Ruark and Mike Shaw
// UI Design by Dr. Brown

/*
<javascriptresource>
<about>$$$/JavaScripts/DrBrown123Process/About=Dr. Brown's 1-2-3 Process^r^rCopyright 2010 Adobe Systems Incorporated. All rights reserved.^r^rProcesses multiple input and output files.^rNOTE:It's better than the Image Processor!</about>
<category>DrBrown</category>
</javascriptresource>
*/

// 1-2-3 Process is copied from 1-2-3 JPEG
// For this version of Process 1-2-3 we made some major changes
// 1. Allow any combination of output files via dropdown
// 2. Set output profile and action to run on each file output
// 3. Supports PNG

// TODO: if number of history states are less than what we do then we could error trying
// to go BACK IN TIME, Huey Lewis bug.
//    a. force the number of states to a large number
//    b. use a snapshot
//    c. catch the error and modify just for those users
//    d. Russell will explain this issue in the movie
// We are currently going with plan D as the show is about a week away.

// TODO: TIF files could be camera raw or normal tif's. If you open first image to apply
// camera raw settings and then you run into a TIF file that is not a camera raw file.
// You will get a 'no such element' because the opening of the TIF file did not work.
// Work around is to NOT have any TIF files that are not camera raw files or not use
// open first image option.

// enable double clicking from the Macintosh Finder or the Windows Explorer
#target photoshop

// in case we double clicked the file
app.bringToFront();

// debug level: 0-2 (0:disable, 1:break on error, 2:break at beginning)
// $.level = 1;
// debugger; // launch debugger on next line

// on localized builds we pull the $$$/Strings from a .dat file, see documentation for more details
$.localize = true;

// the main routine
// the ImageProcessor object does most of the work
try { 

	GlobalVariables();

	CheckVersion();
	
	if ( IsWindowsOS() ) {
		gShortFileNameLength = gShortFileNameLengthWin;
	}

	var gIP = new ImageProcessor();

	gIP.LoadParamsFromDisk( GetDefaultParamsFile() );

	gIP.CreateDialog();
	
	if ( gIP.RunDialog() == 1 ) { // run is 1, cancel is 2, little red button (windows) is 2 as well

		gIP.Execute();
		
		gIP.SaveParamsToDisk( GetDefaultParamsFile() );

	}

	gIP.ReportErrors();

	$.gc();
}

// Lot's of things can go wrong
// Give a generic alert and see if they want the details
catch( e ) {
	if ( confirm( strSorry ) ) {
		alert( e + " : " + e.line );
	}
}

// restore the units
app.preferences.rulerUnits = gStartRulerUnits;

// restore the dialog modes
app.displayDialogs = gSaveDialogMode;

// restore the history states
app.preferences.numberOfHistoryStates = gNumberOfHistoryStates;


//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////
// Function: GlobalVariables
// Usage: all of my globals
// Input: <none>
// Return: <none>
///////////////////////////////////////////////////////////////////////////////
function GlobalVariables() {

	// a version for possible expansion issues
	gVersion = 1;
	
	// A list of file extensions I will skip, keep them lower case
	gFilesToSkip = Array( "db", "xmp", "thm", "txt", "doc", "md0", "tb0", "adobebridgedb", "adobebridgedbt", "bc", "bct", "atn" );

	// A list of camera raw extensions, keep them lower case
	gFilesForCameraRaw = Array( "tif", "crw", "nef", "raf", "orf", "mrw", "dcr", "mos", "srf", "pef", "dcr", "cr2", "dng", "erf", "x3f", "raw" );

	// limit the length of text in edit boxes by this length
	gShortFileNameLengthWin = 360;
	gShortFileNameLengthMac = gShortFileNameLengthWin - 4;
	gShortFileNameLength = gShortFileNameLengthMac;

	// remember the dialog modes
	gSaveDialogMode = app.displayDialogs;
	app.displayDialogs = DialogModes.NO;

    // remember the units
    gStartRulerUnits = app.preferences.rulerUnits;
	app.preferences.rulerUnits = Units.PIXELS;
	
	// remember the number of history states
	gNumberOfHistoryStates = app.preferences.numberOfHistoryStates;
	app.preferences.numberOfHistoryStates = 40;

	gClassActionSet = charIDToTypeID( 'ASet' );
	gClassAction = charIDToTypeID( 'Actn' );
	gKeyName = charIDToTypeID( 'Nm  ' );
	gKeyNumberOfChildren = charIDToTypeID( 'NmbC' );

	gStrTitle = "Dr. Brown's 1-2-3 Process";

    // I pulled a lot of the localization strings to make the dialog resource easier to read and manage	
	strNoImagesSelected = localize( "$$$/JavaScripts/ImageProcessor/NoImagesSelected=No images have been selected" );
	strNoFolderSelected = localize( "$$$/JavaScripts/ImageProcessor/NoFolderSelected=No folder has been selected" );
	strPickXML = localize( "$$$/JavaScripts/ImageProcessor/PickXML=Pick a XML file to load" );
	strPickXMLWin = localize( "$$$/JavaScripts/ImageProcessor/PickXMLWin=XML Files: *.xml" );
	strPickXMLSave = localize( "$$$/JavaScripts/ImageProcessor/PickXMLSave=Pick a XML file to save" );
	strPickSource = localize( "$$$/JavaScripts/ImageProcessor/PickSource=Pick a source folder" );
	strPickDest = localize( "$$$/JavaScripts/ImageProcessor/PickDest=Pick a destination folder" );
	strSpecifySource = localize( "$$$/JavaScripts/ImageProcessor/SpecifySource=Please specify a source folder." );
	strSpecifyDest = localize( "$$$/JavaScripts/ImageProcessor/SpecifyDest=Please specify a destination folder." );
	strJPEGQuality = localize( "$$$/JavaScripts/ImageProcessor/JPEGQuality=JPEG Quality must be between 0 and 12." );
	strWandH = localize( "$$$/JavaScripts/ImageProcessor/WandH=You must specify width and/or height when using resize image options." );
	strOneType = localize( "$$$/JavaScripts/ImageProcessor/OneType=You must save to at least one file type." );
	strNotaRAW = localize( "$$$/JavaScripts/ImageProcessor/NotARAW=This is not a camera raw file according to my list of extensions, " );
	strWidthAndHeight = localize( "$$$/JavaScripts/ImageProcessor/WidthAndHeight=Width and Height must be defined to use FitImage function!" );
	strMustUse = localize( "$$$/JavaScripts/ImageProcessor/MustUse=You must use Photoshop CS 2 or later to run this script!" );
	strCouldNotProcess = localize( "$$$/JavaScripts/ImageProcessor/CouldNotProcessSkipped=Sorry, the following files could not be processed and were skipped:\r" );
	strSorry = localize( "$$$/JavaScripts/ImageProcessor/Sorry=Sorry, something major happened and I can't continue! Would you like to see more info?" );
	strMustSaveOpen = localize( "$$$/JavaScripts/ImageProcessor/MustSaveOpen=Open files must be saved before they can be used by the Image Processor." );
	strFollowing = localize( "$$$/JavaScripts/ImageProcessor/Following=The following files will not be saved." );
	strBadColors = localize( "$$$/JavaScripts/ImageProcessor/BadColors=GIF colors must be a number from 2 to 256 inclusive." );
	strKeepStructure = localize( "$$$/JavaScripts/ImageProcessor/KeepStructure=Keep folder structure" );
}

///////////////////////////////////////////////////////////////////////////////
// Function:
// Usage: given a file name and a list of extensions determine if this file is
//        in the list of extensions
// Input: full file name with extension
//        array of extensions to test against
// Return: true or false if the extension matches
///////////////////////////////////////////////////////////////////////////////
function IsFileOneOfThese( inFileName, inArrayOfFileExtensions ) {
	var lastDot = inFileName.toString().lastIndexOf( "." );
	if ( lastDot == -1 ) {
		return false;
	}
	var strLength = inFileName.toString().length;
	var extension = inFileName.toString().substr( lastDot + 1, strLength - lastDot );
	extension = extension.toLowerCase();
	for (var i = 0; i < inArrayOfFileExtensions.length; i++ ) {
		if ( extension == inArrayOfFileExtensions[i] ) {
			return true;
		}
	}
	return false;
}

///////////////////////////////////////////////////////////////////////////////
// Function: ImageProcessor object
// Usage: the main object, this is the work horse
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function ImageProcessor() {

	///////////////////////////////////////////////////////////////////////////////
	// Function: LoadParamsFromDisk
	// Usage: load my params from the xml file on disk if it exists 
	//        this.params["myoptionname"] = myoptionvalue
	//        I wrote a very simple xml parser, I'm sure it needs work the main 
	//        object, this is the work horse
	// Input: file to open and scan
	// Return: this.params options set
	///////////////////////////////////////////////////////////////////////////////
	this.LoadParamsFromDisk = function( loadFile ) {
		try {
		if ( loadFile.exists ) {
			loadFile.open( "r" );
			var projectSpace = ReadHeader( loadFile );
			if ( projectSpace == GetScriptNameForXML() ) {
				while ( ! loadFile.eof ) {
					var starter = ReadHeader( loadFile );
					var data = ReadData( loadFile );
					var ender = ReadHeader( loadFile );
					if ( ( "/" + starter ) == ender ) {
						this.params[starter] = data;
					}
					// force boolean values to boolean types
					if ( data == "true" || data == "false" ) {
						this.params[starter] = data == "true";
					}
				}
			}
			loadFile.close();
			if ( this.params["version"] != gVersion ) {
				// do something here to fix version conflicts
				// this should do it
				this.params["version"] = gVersion;
			}
		} 
		}
		catch(e) {
			alert( e + ":" + e.line );
		}
	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: SaveParamsToDisk
	// Usage: save out my params, this is much easier
	// Input: file to save off my params
	// Return: <none>
	///////////////////////////////////////////////////////////////////////////////
	this.SaveParamsToDisk = function( saveFile ) {
		saveFile.encoding = "UTF8";
		saveFile.open( "w", "TEXT", "????" );
		// unicode signature, this is UTF16 but will convert to UTF8 "EF BB BF"
		saveFile.write("\uFEFF"); 
		var scriptNameForXML = GetScriptNameForXML();
		saveFile.writeln( "<" + scriptNameForXML + ">" );
		for ( var p in this.params ) {
			saveFile.writeln( "\t<" + p + ">" + this.params[p] + "</" + p + ">" );
		}
		saveFile.writeln( "</" + scriptNameForXML + ">" );
		saveFile.close();
	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: CreateDialog
	// Usage: from a string resource create the dialog
	// Input: <none>
	// Return: dialog with all controls set up
	///////////////////////////////////////////////////////////////////////////////
	this.CreateDialog = function() {
	
		var dlgResource = "dialog { orientation: 'column', alignChildren: 'fill', spacing: 5, \
		                    grpTop: Group { \
		                      grpLeft: Group { orientation: 'column', alignChildren: 'fill', spacing: 5, \
		                        grp1: Group { orientation: 'row', alignChildren: 'center', \
		                          icnOne: Image { icon: 'Step1Icon', helpTip: 'Select the images to process' }, \
                                  stSourceLabel: StaticText { text: 'Select the images to process', helpTip: 'Select the images to process' } \
		                        }, \
		                        grp1Info: Group { orientation: 'row', alignChildren: 'fill', \
		                          grpLeft: Group { orientation: 'row', alignChildren: 'fill', \
		                            icnSource: Image { icon: 'SourceFolderIcon', helpTip: 'Select the images to process' } \
		                          }, \
		                          grpRight: Group { orientation: 'column', alignChildren: 'left' } \
		                        }, \
		                        line1: Panel { bounds: [ 15, 0, 0, 0], properties: { borderStyle: 'sunken' } }, \
		                        grp2: Group { orientation: 'row', alignChildren: 'center', spacing: 10, \
		                          icnTwo: Image { icon: 'Step2Icon', helpTip: 'Select location to save processed images' }, \
		                          stDestination: StaticText { text: 'Select location to save processed images', helpTip: 'Select location to save processed images', properties: { idString: 'stDestination' } } \
		                        }, \
		                        grp2Info: Group { orientation: 'row', alignChildren: 'fill', margins: [ 15, 0, 0, 0 ], \
		                          grpLeft: Group { orientation: 'row', alignChildren: 'left', \
		                            icnDest: Image { icon: 'DestinationFolderIcon', helpTip: 'Select location to save processed images' } \
		                          }, \
		                          grpRight: Group { orientation: 'column', alignChildren: 'left', \
		                            grpSaveIn: Group { orientation: 'row', \
		                              rbSaveInSame: RadioButton { text: 'S&ave in Same Location', helpTip: 'Save the new documents next to the original documents', properties: { idString: 'rbSaveInSame' } }, \
		                              cbMakeFolders: Checkbox { text: 'Save in sub-folder', helpTip: 'Create a sub folder for output files (Set 1, Set 2, Set 3)', properties: { idString: 'cbMakeFolders' } }, \
		                            }, \
		                            grpDestBrowse: Group { orientation: 'row', alignChildren: 'center', \
		                              rbSaveInNew: RadioButton { helpTip: 'Select location to save processed images', properties: { idString: 'rbSaveInNew' } }, \
		                              btnDest: Button { text: 'Sele&ct Folder...', helpTip: 'Select location to save processed images', properties: { idString: 'btnDest' } }, \
		                              stDest: StaticText { text: 'No folder has been selected', helpTip: 'Select location to save processed images', properties: { idString: 'stDest' } } \
		                            } \
		                          } \
		                        } \
  		                      }, \
  		                      grpRight: Group { orientation: 'column', alignChildren: 'right', margins: [ 15, 0, 0, 0 ], \
							    btnRun: Button { text: 'Run', properties: { name: 'ok', idString: 'btnRun' } }, \
                                btnCancel: Button { text: 'Cancel', properties: { name: 'cancel', idString: 'btnCancel' } }, \
								stFake: StaticText { }, \
                                btnLoad: Button { text: '&Load...', helpTip: 'Load a settings file from disk', properties: { idString: 'btnLoad' } }, \
                                btnSave: Button { text: '&Save...', helpTip: 'Save the current dialog settings to disk', properties: { idString: 'btnSave' } } \
		                      } \
		                    }, \
		                    line2: Panel { bounds: [ 0, 0, 0, 0], properties: { borderStyle: 'sunken' } }, \
		                    grp3: Group { orientation: 'row', alignChildren: 'center', spacing: 10, \
		                      icnThree: Image { icon: 'Step3Icon', helpTip: 'File Types' }, \
		                      stFileType: StaticText { text: 'File Types', helpTip: 'File Types' } \
		                    }, \
		                    grp3Info: Group { orientation: 'row', alignChildren:['left', 'top'], margins: [ 15, 0, 0, 0 ], \
		                      grpLeft: Group { orientation: 'column', alignChildren: 'left', \
		                        icnDrBrown: Image { icon: 'DestinationFolderIcon', properties: { idString: 'icnDrBrown' } } \
		                      }, \
		                      grpRight: Group { orientation: 'column', alignChildren: 'left', \
		                        grpFileType: Group { orientation: 'column', alignChildren: 'fill', \
		                          grpFile1: Group { orientation: 'row', alignChildren: 'fill', \
		                            grpLeft: Group { orientation: 'column', alignChildren: 'fill', \
		                              grpFileDrop: Group { orientation: 'row', alignChildren: 'center', \
		                                icnOne: Image { icon: 'Step1Icon', enabled: false }, \
									    cbSaveImageAs1: Checkbox { text: 'Save as:', helpTip: 'Select the output file type', properties: { idString: 'cbSaveImageAs1' } }, \
		                                ddFile1: DropDownList { properties: { idString: 'ddFile1', items: [ 'JPEG', 'TIFF', 'PSD', 'GIF' ,'PNG'] } }, \
		                                stFolder1: StaticText { text: 'Set sub-folder name:', helpTip: 'Enter the name for the first sub folder', properties: { idString: 'stFolder1' }  }, \
										etFolder1: EditText { text: 'Set 1', properties: { idString: 'etFolder1' } }, \
		                              }, \
		                              grpJPEG: Group { orientation: 'column', alignChildren: 'left', margins: [ 15, 0, 0, 0], spacing: 5, \
		                                grpStack: Group { orientation: 'stack', alignChildren: 'left', \
		                                  grpQ: Group { orientation: 'row', alignChildren: 'center', \
		                                    stQuality1: StaticText { text: 'Quality:', properties: { idString: 'stQuality1' } }, \
		                                    etQuality1: EditText {  properties: { idString: 'etQuality1' } }, \
		                                    stFaker1: StaticText {  text: 'funsp', visible: false, properties: { idString: 'stFaker1' } }, \
											cbUseSFW1: Checkbox { text: 'Remove preview and metadata for reduced file size', properties: { idString: 'cbUseSFW1' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
		                                  grpLace: Group { orientation: 'row', alignChildren: 'center', \
		                                    cbLace1: Checkbox { text: 'Interlace', helpTip: 'Interlace rows', properties: { idString: 'cbLace1' } }, \
		                                    stFaker1: StaticText {  text: 'funsp', visible: false, properties: { idString: 'stFaker1' } }, \
											cbUseSFW1: Checkbox { text: 'Save for Web', properties: { idString: 'cbSFW1' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
		                                  grpMax: Group { orientation: 'row', alignChildren: 'center', \
		                                    cbMaximize1: Checkbox { text: 'Maximize Compatibility', properties: { idString: 'cbMax1' } }, \
		                                    cbFlattenImagePSD1: Checkbox { text: 'Flatten Images', properties: { idString: 'cbFlattenImagePSD1' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
		                                  grpLZW: Group { orientation: 'row', alignChildren: 'center', \
		                                    cbLZW1: Checkbox { text: 'LZW Compression', properties: { idString: 'cbLZW1' } }, \
		                                    cbFlattenImageTIFF1: Checkbox { text: 'Flatten Images', properties: { idString: 'cbFlattenImageTIFF1' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
 		                                  grpColors: Group { orientation: 'row', alignChildren: 'center', \
		                                    stColors1: StaticText { text: 'Colors:', properties: { idString: 'stColors1' } }, \
		                                    etColors1: EditText { properties: { idString: 'etColors1' } } \
		                                  }, \
		                                }, \
		                                grpBottom: Group { orientation: 'row', alignChildren: 'fill', \
		                                  grpLeft: Group { orientation: 'column', alignChildren: 'left', \
		                                    grpFaker1: Group { orientation: 'row', alignChildren: 'center', spacing: 1, \
		                                      stOutputProfile1: StaticText { text: 'Output Profile:', helpTip: 'Select the profile for the output file', properties: { idString: 'stOutputProfile1' } },\
		                                      ddFaker1: DropDownList { visible: false, properties: { idString: 'ddFaker1' } } \
		                                    }, \
		                                    grpFaker2: Group { orientation: 'row', alignChildren: 'center', spacing: 1, \
										      cbRunAction1: Checkbox { text: 'Run Action:', helpTip: 'Select an action set and an action', properties: { idString: 'cbRunAction1' } }, \
		                                      ddFaker2: DropDownList { visible: false, properties: { idString: 'ddFaker2' } } \
										    }, \
		                                    grpFaker3: Group { orientation: 'row', alignChildren: 'center', spacing: 1, \
										      stSelectAction1: StaticText { text: 'Select Action:', helpTip: 'Select when to run the action', properties: { idString: 'stSelectAction1' } },\
		                                      ddFaker3: DropDownList { visible: false, properties: { idString: 'ddFaker3' } } \
										    }, \
   		                                  }, \
	                                      grpRight: Group { orientation: 'column', alignChildren: 'left', spacing: 11, \
		                                    ddConvertICC1: DropDownList { properties: { idString: 'ddConvertICC1', items: [ 'Untagged RGB', 'Same as Source', 'Working RGB', 'Working CMYK', 'sRGB IEC61966-2.1', 'Adobe RGB (1998)', 'ProPhoto RGB', 'ColorMatch RGB' ] } }, \
										    ddWhenAction1: DropDownList { properties: { idString: 'ddWhenAction1', items: [ 'After Image Resize', 'Before Image Resize' ] } }, \
										    grpRunAction: Group { orientation: 'row', alignChildren: 'fill', \
										      ddSet1: DropDownList { helpTip: 'Select an action set and an action', properties: { idString: 'ddSet1' } }, \
										      ddAction1: DropDownList { helpTip: 'Select an action set and an action', properties: { idString: 'ddAction1' } } \
										    }, \
										  }, \
									    }, \
		                              } \
		                            }, \
   	                                hidden6: EditText { visible: false }, \
		                            grpRight: Group { orientation: 'column', alignChildren: 'center', \
		                              grpTop: Group { orientation: 'column', alignChildren: 'center', \
		                                cbResizeFile: Checkbox { text: '&Resize to Fit', helpTip: 'Select to resize for this format', properties: { idString: 'cbResizeFile1' } }, \
		                              }, \
		                              grpBottom: Group { orientation: 'row', \
		                                grpSt: Group { orientation: 'column', alignChildren: 'right', spacing: 14, \
		                                  stResizeFileW: StaticText { text: 'W:', helpTip: 'Type in a width to resize image', properties: { idString: 'stResizeFileW1' } }, \
		                                  stResizeFileH: StaticText { text: 'H:', helpTip: 'Type in a height to resize image', properties: { idString: 'stResizeFileH1' } }, \
		                                  stResizeFileR: StaticText { text: 'Resolution:', helpTip: 'Type in the resolution of the final image', properties: { idString: 'stResizeFileR1' } }, \
		                                }, \
		                                grpEt: Group { orientation: 'column', alignChildren: 'fill', spacing: 8, \
		                                  etResizeFileW: EditText { properties: { idString: 'etResizeFileW1' } }, \
		                                  etResizeFileH: EditText { properties: { idString: 'etResizeFileH1' } }, \
		                                  etResizeFileR: EditText { properties: { idString: 'etResizeFileR1' }  }, \
		                                }, \
		                                grpDd: Group { orientation: 'column', alignChildren: 'fill', spacing: 5, \
		                                  ddResizeFileW: DropDownList { properties: { idString: 'ddResizeFileW1', items: [ 'pixels', 'percent', 'inches', 'cm', 'mm', 'points', 'picas' ] } }, \
		                                  ddResizeFileH: DropDownList { properties: { idString: 'ddResizeFileH1', items: [ 'pixels', 'percent', 'inches', 'cm', 'mm', 'points', 'picas' ] } }, \
		                                  ddResizeFileR: DropDownList { properties: { idString: 'ddResizeFileR1', items: [ 'pixels/inch', 'pixels/cm' ] } }, \
		                                } \
		                              } \
									  ddInterpolate1: DropDownList { properties: { idString: 'ddInterpolate1', items: [ 'Nearest Neighbor', 'Bilinear', 'Bicubic', 'Bicubic Smoother', 'Bicubic Sharper' ] } }, \
		                            } \
		                          }, \
		                          line3: Panel { bounds: [ 0, 0, 0, 0], properties: { borderStyle: 'sunken' } }, \
		                          grpFile2: Group { orientation: 'row', alignChildren: 'fill', \
		                            grpLeft: Group { orientation: 'column', alignChildren: 'fill', \
		                              grpFileDrop: Group { orientation: 'row', alignChildren: 'center', \
										icnTwo: Image { icon: 'Step2Icon', enabled: false }, \
									    cbSaveImageAs2: Checkbox { text: 'Save as:', helpTip: 'Select the output file type', properties: { idString: 'cbSaveImageAs2' } }, \
		                                ddFile2: DropDownList { properties: { idString: 'ddFile2', items: [ 'JPEG', 'TIFF', 'PSD', 'GIF' ,'PNG'] } }, \
		                                stFolder2: StaticText { text: 'Set sub-folder name:', helpTip: 'Enter the name for the second sub folder', properties: { idString: 'stFolder2' }  }, \
										etFolder2: EditText { text: 'Set 2', properties: { idString: 'etFolder2' } }, \
		                              }, \
		                              grpJPEG: Group { orientation: 'column', alignChildren: 'left', margins: [ 15, 0, 0, 0], spacing: 5, \
		                                grpStack: Group { orientation: 'stack', alignChildren: 'left', \
		                                  grpQ: Group { orientation: 'row', alignChildren: 'center', \
		                                    stQuality2: StaticText { text: 'Quality:', properties: { idString: 'stQuality2' } }, \
		                                    etQuality2: EditText {  properties: { idString: 'etQuality2' } }, \
		                                    stFaker2: StaticText {  text: 'funsp', visible: false, properties: { idString: 'stFaker2' } }, \
											cbUseSFW2: Checkbox { text: 'Remove preview and metadata for reduced file size', properties: { idString: 'cbUseSFW2' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
		                                  grpLace: Group { orientation: 'row', alignChildren: 'center', \
		                                    cbLace2: Checkbox { text: 'Interlace', helpTip: 'Interlace rows', properties: { idString: 'cbLace2' } }, \
		                                    stFaker2: StaticText {  text: 'funsp', visible: false, properties: { idString: 'stFaker2' } }, \
											cbUseSFW2: Checkbox { text: 'Save for Web', properties: { idString: 'cbSFW2' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
		                                  grpMax: Group { orientation: 'row', alignChildren: 'center', \
		                                    cbMaximize2: Checkbox { text: 'Maximize Compatibility', properties: { idString: 'cbMax2' } }, \
		                                    cbFlattenImagePSD2: Checkbox { text: 'Flatten Images', properties: { idString: 'cbFlattenImagePSD2' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
		                                  grpLZW: Group { orientation: 'row', alignChildren: 'center', \
		                                    cbLZW2: Checkbox { text: 'LZW Compression', properties: { idString: 'cbLZW2' } }, \
		                                    cbFlattenImageTIFF2: Checkbox { text: 'Flatten Images', properties: { idString: 'cbFlattenImageTIFF2' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
 		                                  grpColors: Group { orientation: 'row', alignChildren: 'center', \
		                                    stColors2: StaticText { text: 'Colors:', properties: { idString: 'stColors2' } }, \
		                                    etColors2: EditText { properties: { idString: 'etColors2' } } \
		                                  }, \
		                                }, \
		                                grpBottom: Group { orientation: 'row', alignChildren: 'fill', \
		                                  grpLeft: Group { orientation: 'column', alignChildren: 'left', \
		                                    grpFaker1: Group { orientation: 'row', alignChildren: 'center', spacing: 1, \
		                                      stOutputProfile2: StaticText { text: 'Output Profile:', helpTip: 'Select the profile for the output file', properties: { idString: 'stOutputProfile2' } },\
		                                      ddFaker1: DropDownList { visible: false, properties: { idString: 'ddFaker4' } } \
		                                    }, \
		                                    grpFaker2: Group { orientation: 'row', alignChildren: 'center', spacing: 1, \
										      cbRunAction2: Checkbox { text: 'Run Action:', helpTip: 'Select an action set and an action', properties: { idString: 'cbRunAction2' } }, \
		                                      ddFaker2: DropDownList { visible: false, properties: { idString: 'ddFaker5' } } \
										    }, \
		                                    grpFaker3: Group { orientation: 'row', alignChildren: 'center', spacing: 1, \
										      stSelectAction2: StaticText { text: 'Select Action:', helpTip: 'Select when to run the action', properties: { idString: 'stSelectAction2' } },\
		                                      ddFaker3: DropDownList { visible: false, properties: { idString: 'ddFaker6' } } \
										    }, \
   		                                  }, \
	                                      grpRight: Group { orientation: 'column', alignChildren: 'left', \
		                                    ddConvertICC2: DropDownList { properties: { idString: 'ddConvertICC2', items: [ 'Untagged RGB', 'Same as Source', 'Working RGB', 'Working CMYK', 'sRGB IEC61966-2.1', 'Adobe RGB (1998)', 'ProPhoto RGB', 'ColorMatch RGB' ] } }, \
										    ddWhenAction2: DropDownList { properties: { idString: 'ddWhenAction2', items: [ 'After Image Resize', 'Before Image Resize' ] } }, \
										    grpRunAction: Group { orientation: 'row', alignChildren: 'fill', \
										      ddSet2: DropDownList { helpTip: 'Select an action set and an action', properties: { idString: 'ddSet2' } }, \
										      ddAction2: DropDownList { helpTip: 'Select an action set and an action', properties: { idString: 'ddAction2' } } \
										    }, \
										  }, \
									    }, \
		                              } \
		                            }, \
   	                                hidden6: EditText { visible: false }, \
		                            grpRight: Group { orientation: 'column', alignChildren: 'center', \
		                              grpTop: Group { orientation: 'column', alignChildren: 'center', \
		                                cbResizeFile: Checkbox { text: '&Resize to Fit', helpTip: 'Select to resize for this format', properties: { idString: 'cbResizeFile2' } }, \
		                              }, \
		                              grpBottom: Group { orientation: 'row', \
		                                grpSt: Group { orientation: 'column', alignChildren: 'right', spacing: 14, \
		                                  stResizeFileW: StaticText { text: 'W:', helpTip: 'Type in a width to resize image', properties: { idString: 'stResizeFileW2' } }, \
		                                  stResizeFileH: StaticText { text: 'H:', helpTip: 'Type in a height to resize image', properties: { idString: 'stResizeFileH2' } }, \
		                                  stResizeFileR: StaticText { text: 'Resolution:', helpTip: 'Type in the resolution of the final image', properties: { idString: 'stResizeFileR2' } }, \
		                                }, \
		                                grpEt: Group { orientation: 'column', alignChildren: 'fill', spacing: 8, \
		                                  etResizeFileW: EditText { properties: { idString: 'etResizeFileW2' } }, \
		                                  etResizeFileH: EditText { properties: { idString: 'etResizeFileH2' } }, \
		                                  etResizeFileR: EditText { properties: { idString: 'etResizeFileR2' }  }, \
		                                }, \
		                                grpDd: Group { orientation: 'column', alignChildren: 'fill', spacing: 5, \
		                                  ddResizeFileW: DropDownList { properties: { idString: 'ddResizeFileW2', items: [ 'pixels', 'percent', 'inches', 'cm', 'mm', 'points', 'picas' ] } }, \
		                                  ddResizeFileH: DropDownList { properties: { idString: 'ddResizeFileH2', items: [ 'pixels', 'percent', 'inches', 'cm', 'mm', 'points', 'picas' ] } }, \
		                                  ddResizeFileR: DropDownList { properties: { idString: 'ddResizeFileR2', items: [ 'pixels/inch', 'pixels/cm' ] } }, \
		                                } \
		                              } \
  									  ddInterpolate2: DropDownList { properties: { idString: 'ddInterpolate2', items: [ 'Nearest Neighbor', 'Bilinear', 'Bicubic', 'Bicubic Smoother', 'Bicubic Sharper' ] } }, \
		                            } \
		                          }, \
		                          line4: Panel { bounds: [ 0, 0, 0, 0], properties: { borderStyle: 'sunken' } }, \
		                          grpFile3: Group { orientation: 'row', alignChildren: 'fill', \
		                            grpLeft: Group { orientation: 'column', alignChildren: 'fill', \
		                              grpFileDrop: Group { orientation: 'row', alignChildren: 'center', \
										icnThree: Image { icon: 'Step3Icon', enabled: false }, \
									    cbSaveImageAs3: Checkbox { text: 'Save as:', helpTip: 'Select the output file type', properties: { idString: 'cbSaveImageAs3' } }, \
		                                ddFile3: DropDownList { properties: { idString: 'ddFile3', items: [ 'JPEG', 'TIFF', 'PSD', 'GIF' ,'PNG'] } }, \
		                                stFolder3: StaticText { text: 'Set sub-folder name:', helpTip: 'Enter the name for the third sub folder', properties: { idString: 'stFolder3' }  }, \
										etFolder3: EditText { text: 'Set 3', properties: { idString: 'etFolder3' } }, \
		                              }, \
		                              grpJPEG: Group { orientation: 'column', alignChildren: 'left', margins: [ 15, 0, 0, 0], spacing: 5, \
		                                grpStack: Group { orientation: 'stack', alignChildren: 'left', \
		                                  grpQ: Group { orientation: 'row', alignChildren: 'center', \
		                                    stQuality3: StaticText { text: 'Quality:', properties: { idString: 'stQuality3' } }, \
		                                    etQuality3: EditText {  properties: { idString: 'etQuality3' } }, \
		                                    stFaker3: StaticText {  text: 'funsp', visible: false, properties: { idString: 'stFaker3' } }, \
											cbUseSFW3: Checkbox { text: 'Remove preview and metadata for reduced file size', properties: { idString: 'cbUseSFW3' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
		                                  grpLace: Group { orientation: 'row', alignChildren: 'center', \
		                                    cbLace3: Checkbox { text: 'Interlace', helpTip: 'Interlace rows', properties: { idString: 'cbLace3' } }, \
		                                    stFaker3: StaticText {  text: 'funsp', visible: false, properties: { idString: 'stFaker3' } }, \
											cbUseSFW3: Checkbox { text: 'Save for Web', properties: { idString: 'cbSFW3' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
		                                  grpMax: Group { orientation: 'row', alignChildren: 'center', \
		                                    cbMaximize3: Checkbox { text: 'Maximize Compatibility', properties: { idString: 'cbMax3' } }, \
		                                    cbFlattenImagePSD3: Checkbox { text: 'Flatten Images', properties: { idString: 'cbFlattenImagePSD3' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
		                                  grpLZW: Group { orientation: 'row', alignChildren: 'center', \
		                                    cbLZW3: Checkbox { text: 'LZW Compression', properties: { idString: 'cbLZW3' } }, \
		                                    cbFlattenImageTIFF3: Checkbox { text: 'Flatten Images', properties: { idString: 'cbFlattenImageTIFF3' } }, \
		                                    ddFaker: DropDownList { visible: false, properties: { idString: 'ddFaker12' } } \
		                                  }, \
 		                                  grpColors: Group { orientation: 'row', alignChildren: 'center', \
		                                    stColors3: StaticText { text: 'Colors:', properties: { idString: 'stColors3' } }, \
		                                    etColors3: EditText { properties: { idString: 'etColors3' } } \
		                                  }, \
		                                }, \
		                                grpBottom: Group { orientation: 'row', alignChildren: 'fill', \
		                                  grpLeft: Group { orientation: 'column', alignChildren: 'left', \
		                                    grpFaker1: Group { orientation: 'row', alignChildren: 'center', spacing: 1, \
		                                      stOutputProfile3: StaticText { text: 'Output Profile:', helpTip: 'Select the profile for the output file', properties: { idString: 'stOutputProfile3' } },\
		                                      ddFaker1: DropDownList { visible: false, properties: { idString: 'ddFaker7' } } \
		                                    }, \
		                                    grpFaker2: Group { orientation: 'row', alignChildren: 'center', spacing: 1, \
										      cbRunAction3: Checkbox { text: 'Run Action:', helpTip: 'Select an action set and an action', properties: { idString: 'cbRunAction3' } }, \
		                                      ddFaker2: DropDownList { visible: false, properties: { idString: 'ddFaker8' } } \
										    }, \
		                                    grpFaker3: Group { orientation: 'row', alignChildren: 'center', spacing: 1, \
										      stSelectAction3: StaticText { text: 'Select Action:', helpTip: 'Select when to run the action', properties: { idString: 'stSelectAction3' } },\
		                                      ddFaker3: DropDownList { visible: false, properties: { idString: 'ddFaker9' } } \
										    }, \
   		                                  }, \
	                                      grpRight: Group { orientation: 'column', alignChildren: 'left', spacing: 11, \
		                                    ddConvertICC3: DropDownList { properties: { idString: 'ddConvertICC3', items: [ 'Untagged RGB', 'Same as Source', 'Working RGB', 'Working CMYK', 'sRGB IEC61966-2.1', 'Adobe RGB (1998)', 'ProPhoto RGB', 'ColorMatch RGB' ] } }, \
										    ddWhenAction3: DropDownList { properties: { idString: 'ddWhenAction3', items: [ 'After Image Resize', 'Before Image Resize' ] } }, \
										    grpRunAction: Group { orientation: 'row', alignChildren: 'fill', \
										      ddSet3: DropDownList { helpTip: 'Select an action set and an action', properties: { idString: 'ddSet3' } }, \
										      ddAction3: DropDownList { helpTip: 'Select an action set and an action', properties: { idString: 'ddAction3' } } \
										    }, \
										  }, \
									    }, \
		                              } \
		                            }, \
   	                                hidden6: EditText { visible: false }, \
		                            grpRight: Group { orientation: 'column', alignChildren: 'center', \
		                              grpTop: Group { orientation: 'column', alignChildren: 'center', \
		                                cbResizeFile: Checkbox { text: '&Resize to Fit', helpTip: 'Select to resize for this format', properties: { idString: 'cbResizeFile3' } }, \
		                              }, \
		                              grpBottom: Group { orientation: 'row', \
		                                grpSt: Group { orientation: 'column', alignChildren: 'right', spacing: 14, \
		                                  stResizeFileW: StaticText { text: 'W:', helpTip: 'Type in a width to resize image', properties: { idString: 'stResizeFileW3' } }, \
		                                  stResizeFileH: StaticText { text: 'H:', helpTip: 'Type in a height to resize image', properties: { idString: 'stResizeFileH3' } }, \
		                                  stResizeFileR: StaticText { text: 'Resolution:', helpTip: 'Type in the resolution of the final image', properties: { idString: 'stResizeFileR3' } }, \
		                                }, \
		                                grpEt: Group { orientation: 'column', alignChildren: 'fill', spacing: 8, \
		                                  etResizeFileW: EditText { properties: { idString: 'etResizeFileW3' } }, \
		                                  etResizeFileH: EditText { properties: { idString: 'etResizeFileH3' }  }, \
		                                  etResizeFileR: EditText { properties: { idString: 'etResizeFileR3' }  }, \
		                                }, \
		                                grpDd: Group { orientation: 'column', alignChildren: 'fill', spacing: 5, \
		                                  ddResizeFileW: DropDownList { properties: { idString: 'ddResizeFileW3', items: [ 'pixels', 'percent', 'inches', 'cm', 'mm', 'points', 'picas' ] } }, \
		                                  ddResizeFileH: DropDownList { properties: { idString: 'ddResizeFileH3', items: [ 'pixels', 'percent', 'inches', 'cm', 'mm', 'points', 'picas' ] } }, \
		                                  ddResizeFileR: DropDownList { properties: { idString: 'ddResizeFileR3', items: [ 'pixels/inch', 'pixels/cm' ] } }, \
		                                } \
		                              } \
  									  ddInterpolate3: DropDownList { properties: { idString: 'ddInterpolate3', items: [ 'Nearest Neighbor', 'Bilinear', 'Bicubic', 'Bicubic Smoother', 'Bicubic Sharper' ] } }, \
		                            } \
		                          } \
		                        } \
		                      }, \
		                    }, \
		                    line5: Panel { bounds: [ 0, 0, 0, 0], properties: { borderStyle: 'sunken' } }, \
		                    grp4: Group { orientation: 'row', alignChildren: 'top', spacing: 10, \
		                      icnFour: Image { icon: 'Step4Icon', helpTip: 'Preferences' }, \
		                      stFileType: StaticText { text: 'Preferences', helpTip: 'Preferences' } \
		                    }, \
		                    grp4Info: Group { orientation: 'column', alignChildren: 'left', margins: [ 145, 0, 0, 0 ], \
		                      grpTop: Group { orientation: 'row', alignChildren: 'top', spacing: 1, \
		                        grpLeft: Group { orientation: 'column', alignChildren: 'left', spacing: 1, \
		                          grpCopyright: Group { orientation: 'row', \
		                            stCopyrightInfo: StaticText { text: 'Copyright Info:', helpTip: 'Add text to copyright your images' }, \
		                            hidden5: EditText { visible: false } \
		                          }, \
		                        }, \
		                        grpRight: Group { orientation: 'column', alignChildren: 'left', spacing: 1, \
		                          etCopyrightInfo: EditText { helpTip: 'Add text to copyright your images', alignment: 'fill', properties: { idString: 'etCopyrightInfo' } } \
		                        }, \
		                      }, \
                            }, \
		                  }";
		                
		// alert( dlgResource.length + " bytes of dialog resource!" );
		
        this.dlgMain = new Window( dlgResource );
        
        // i get two onChange calls during init, use these counters to block them
        this.dlgMain.initisover1 = 0;
        this.dlgMain.initisover2 = 0;
        this.dlgMain.initisover3 = 0;

		// some interesting numbers to help the auto layout
		var wAndhEtLength = 40;
		var folderEtLength = 150;
		var qEtLength = 30;
		var bridgeLength = 300;
		var topGrpMargin = 85;
		 
	 	if ( IsWindowsOS() ) {
		    var sourceLength = 473;
		    var actionDdLength = 150;
		} else {
		    var sourceLength = 573;
		    var actionDdLength = 175;
		}
		
		// We removed the "Open first image to apply settings" option because it was causing confusion
		// See // OFIREMOVE tag to add that back in if you want
		
        // some runtime creation
        if ( this.runningFromBridge ) {
            this.dlgMain.stBridge = this.dlgMain.grpTop.grpLeft.grp1Info.grpRight.add( 'statictext', undefined, "Process files from Bridge only (" + this.filesFromBridge.length + ")" );
            this.dlgMain.stBridge.helpTip = 'Selected files from Bridge will be processed';
            this.dlgMain.stBridge.preferredSize.width = bridgeLength;
	        // OFIREMOVE this.dlgMain.cbOpenFirst = this.dlgMain.grpTop.grpLeft.grp1Info.grpRight.add( 'checkbox', undefined, "&Open first image to apply settings (RAW IMAGES ONLY)" );
			// OFIREMOVE this.dlgMain.cbOpenFirst.helpTip = "Show the Camera RAW dialog on the first image to apply settings";
        } else {
			var grpUseOpen  = this.dlgMain.grpTop.grpLeft.grp1Info.grpRight.add( 'group', undefined, { orientation: 'row', alignChildren: 'fill' } );
	        this.dlgMain.rbUseOpen = grpUseOpen.add( 'radiobutton', undefined, 'Use Open &Images' );
	        this.dlgMain.rbUseOpen.helpTip = 'Use all open images';
	        this.dlgMain.cbIncludeSubFolders = grpUseOpen.add( 'checkbox', undefined, 'Include All sub-folders' );
	        this.dlgMain.cbIncludeSubFolders.helpTip = 'Process all the folders within the source folder';
			this.dlgMain.cbKeepStructure = this.dlgMain.grpTop.grpLeft.grp2Info.grpRight.grpSaveIn.add( 'checkbox', undefined, strKeepStructure );
			this.dlgMain.cbKeepStructure.helpTip = strKeepStructure;
	        // OFIREMOVE this.dlgMain.cbOpenFirst = grpUseOpen.add( 'checkbox', undefined, "&Open first image to apply settings (RAW IMAGES ONLY)" );
			// OFIREMOVE this.dlgMain.cbOpenFirst.helpTip = "Show the Camera RAW dialog on the first image to apply settings";
	        var grpSelect = this.dlgMain.grpTop.grpLeft.grp1Info.grpRight.add( 'group', undefined, { orientation: 'row', alignChildren: 'fill' } );
	        this.dlgMain.rbUseFolder = grpSelect.add( 'radiobutton', undefined, '');
	        this.dlgMain.rbUseFolder.helpTip = 'Use the images that are currently open';
	        this.dlgMain.btnSource = grpSelect.add( 'button', undefined, 'Select &Folder...' );
	        this.dlgMain.btnSource.helpTip = 'Select the images to process';
	        this.dlgMain.stSource = grpSelect.add( 'statictext', undefined, 'No images have been selected' );
	        this.dlgMain.stSource.helpTip = 'Location of files to process';
	        this.dlgMain.stSource.preferredSize.width = sourceLength;
			this.dlgMain.grpTop.grpLeft.grp1Info.margins = [topGrpMargin,0,0,0]
			this.dlgMain.grpTop.grpLeft.grp2Info.margins = [topGrpMargin,0,0,0]
        }
        
        this.dlgMain.text = gStrTitle;

        FlattenDialog( this.dlgMain, this.dlgMain );
		
		this.dlgMain.icnDrBrown.image = File(app.path+"/Presets/Scripts/icons/DrBrownImageRight.png");

        this.dlgMain.etFolder1.preferredSize.width = folderEtLength;
        this.dlgMain.etFolder2.preferredSize.width = folderEtLength;
        this.dlgMain.etFolder3.preferredSize.width = folderEtLength;

        this.dlgMain.etQuality1.preferredSize.width = qEtLength;
        this.dlgMain.etQuality2.preferredSize.width = qEtLength;
        this.dlgMain.etQuality3.preferredSize.width = qEtLength;
        
        this.dlgMain.etColors1.preferredSize.width = qEtLength;
        this.dlgMain.etColors2.preferredSize.width = qEtLength;
        this.dlgMain.etColors3.preferredSize.width = qEtLength;

		this.dlgMain.stDest.preferredSize.width = sourceLength;

        this.dlgMain.etResizeFileW1.preferredSize.width = wAndhEtLength;
        this.dlgMain.etResizeFileW2.preferredSize.width = wAndhEtLength;
        this.dlgMain.etResizeFileW3.preferredSize.width = wAndhEtLength;
        this.dlgMain.etResizeFileH1.preferredSize.width = wAndhEtLength;
        this.dlgMain.etResizeFileH2.preferredSize.width = wAndhEtLength;
        this.dlgMain.etResizeFileH3.preferredSize.width = wAndhEtLength;
        this.dlgMain.etResizeFileR1.preferredSize.width = wAndhEtLength;
        this.dlgMain.etResizeFileR2.preferredSize.width = wAndhEtLength;
        this.dlgMain.etResizeFileR3.preferredSize.width = wAndhEtLength;

        this.dlgMain.ddSet1.preferredSize.width = actionDdLength;
        this.dlgMain.ddAction1.preferredSize.width = actionDdLength;
        this.dlgMain.ddSet2.preferredSize.width = actionDdLength;
        this.dlgMain.ddAction2.preferredSize.width = actionDdLength;
        this.dlgMain.ddSet3.preferredSize.width = actionDdLength;
        this.dlgMain.ddAction3.preferredSize.width = actionDdLength;

        this.dlgMain.ddConvertICC1.preferredSize.width = actionDdLength;
        this.dlgMain.ddConvertICC2.preferredSize.width = actionDdLength;
        this.dlgMain.ddConvertICC3.preferredSize.width = actionDdLength;
        
        this.dlgMain.ddWhenAction1.preferredSize.width = actionDdLength;
        this.dlgMain.ddWhenAction2.preferredSize.width = actionDdLength;
        this.dlgMain.ddWhenAction3.preferredSize.width = actionDdLength;
		
		// how is this for f&*&#$ with a layout!!!!
		if ( ! IsWindowsOS() ) {
			this.dlgMain.stFaker1.text = this.dlgMain.stFaker1.text + 'a';
			this.dlgMain.stFaker2.text = this.dlgMain.stFaker2.text + 'a';
			this.dlgMain.stFaker3.text = this.dlgMain.stFaker3.text + 'a';
		}

        this.dlgMain.etCopyrightInfo.preferredSize.width = actionDdLength + actionDdLength;
		
		this.dlgMain.defaultElement = this.dlgMain.btnRun;
		this.dlgMain.cancelElement = this.dlgMain.btnCancel;
        
	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: InitParams
	// Usage: params set to default
	// Input: <none>
	// Return: defaults set up
	///////////////////////////////////////////////////////////////////////////////
	this.InitParams = function() {
		var params = new Object();
		params["version"] = gVersion;
		params["useopen"] = false;
		params["keepstructure"] = false;
		params["includesub"] = false;
		params["open"] = false;
		params["source"] = "";
		params["saveinsame"] = true;
		params["makefolders"] = true;
		params["folder1"] = "Set 1";
		params["folder2"] = "Set 2";
		params["folder3"] = "Set 3";
		params["dest"] = "";
		params["outfile1"] = true;
		params["outfile2"] = true;
		params["outfile3"] = true;
		params["file1"] = "PSD";
		params["file2"] = "TIFF";
		params["file3"] = "JPEG";
		params["q1"] = 8;
		params["q2"] = 8;
		params["q3"] = 8;
		params["lace1"] = false;
		params["lace2"] = false;
		params["lace3"] = false;
		params["sfw1"] = false;
		params["sfw2"] = false;
		params["sfw3"] = false;
		params["lzw1"] = true;
		params["lzw2"] = true;
		params["lzw3"] = true;
		params["flattenTIFF1"] = true;
		params["flattenTIFF2"] = true;
		params["flattenTIFF3"] = true;
		params["max1"] = true;
		params["max2"] = true;
		params["max3"] = true;
		params["flattenPSD1"] = true;
		params["flattenPSD2"] = true;
		params["flattenPSD3"] = true;
		params["c1"] = 256;
		params["c2"] = 256;
		params["c3"] = 256;
		params["converticc1"] = "Same as Source";
		params["converticc2"] = "Same as Source";
		params["converticc3"] = "Same as Source";
		params["fileresize1"] = false;
		params["filew1"] = "";
		params["fileh1"] = "";
		params["filer1"] = 72;
		params["filewu1"] = "pixels";
		params["filehu1"] = "pixels";
		params["fileru1"] = "pixels/inch";
		params["interpolate1"] = "Bicubic";
		params["fileresize2"] = false;
		params["filew2"] = "";
		params["fileh2"] = "";
		params["filer2"] = 72;
		params["filewu2"] = "pixels";
		params["filehu2"] = "pixels";
		params["fileru2"] = "pixels/inch";
		params["interpolate2"] = "Bicubic";
		params["fileresize3"] = false;
		params["filew3"] = "";
		params["fileh3"] = "";
		params["filer3"] = 72;
		params["filewu3"] = "pixels";
		params["filehu3"] = "pixels";
		params["fileru3"] = "pixels/inch";
		params["interpolate3"] = "Bicubic";
		params["runaction1"] = false;
		params["runaction2"] = false;
		params["runaction3"] = false;
		params["whenaction1"] = "After Image Resize";
		params["whenaction2"] = "After Image Resize";
		params["whenaction3"] = "After Image Resize";
		params["actionset1"] = "";
		params["action1"] = "";
		params["actionset2"] = "";
		params["action2"] = "";
		params["actionset3"] = "";
		params["action3"] = "";
		params["info"] = "";

		return params;
	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: InitDialog
	// Usage: transfer from the default settings or settings I read off disk to 
	//        the dialog widgets
	// Input: <none>
	// Return: items in dialog set via params object
	///////////////////////////////////////////////////////////////////////////////
	this.InitDialog = function() {

		var d = this.dlgMain;
		var p = this.params;
		
		this.dlgMain.ip = this;
		d.loadFromDisk = true;
		
		if ( ! this.runningFromBridge ) {

			if ( app.documents.length > 0 ) {
				d.rbUseOpen.value = p["useopen"];
			} else {
				d.rbUseOpen.enabled = false;
				d.rbUseOpen.value = false;
			}
			
			d.rbUseFolder.value = ! d.rbUseOpen.value;

			d.cbIncludeSubFolders.value = p["includesub"];
			
			d.cbKeepStructure.value = p["keepstructure"];
			
			d.stSource.text = CreateShortFileName( p["source"] );
			if ( d.stSource.text == "" ) {
				d.stSource.text = strNoImagesSelected;
			}
		}
		d.sourceLongText = p["source"];

		d.rbSaveInSame.value = p["saveinsame"];
		d.rbSaveInNew.value = ! d.rbSaveInSame.value;		
		// OFIREMOVE  d.cbOpenFirst.value = p["open"];
		d.stDest.text = CreateShortFileName( p["dest"] );
		if ( d.stDest.text == "" ) {
			d.stDest.text = strNoFolderSelected;
		}
		d.destLongText = p["dest"];
		d.cbMakeFolders.value = p["makefolders"];
		d.etFolder1.text = p["folder1"];
		d.etFolder2.text = p["folder2"];
		d.etFolder3.text = p["folder3"];
		d.cbSaveImageAs1.value = p["outfile1"];
		d.cbSaveImageAs2.value = p["outfile2"];
		d.cbSaveImageAs3.value = p["outfile3"];
		d.cbRunAction1.value = p["runaction1"];
		d.cbRunAction2.value = p["runaction2"];
		d.cbRunAction3.value = p["runaction3"];
		d.etQuality1.text = p["q1"];
		d.etQuality2.text = p["q2"];
		d.etQuality3.text = p["q3"];
		d.cbLace1.value = p["lace1"];
		d.cbLace2.value = p["lace2"];
		d.cbLace3.value = p["lace3"];
		d.cbSFW1.value = p["sfw1"];
		d.cbSFW2.value = p["sfw2"];
		d.cbSFW3.value = p["sfw3"];
		d.cbUseSFW1.value = p["crazy1"];
		d.cbUseSFW2.value = p["crazy2"];
		d.cbUseSFW3.value = p["crazy3"];
		d.cbLZW1.value = p["lzw1"];
		d.cbLZW2.value = p["lzw2"];
		d.cbLZW3.value = p["lzw3"];
		d.cbFlattenImageTIFF1.value = p["flattenTIFF1"];
		d.cbFlattenImageTIFF2.value = p["flattenTIFF2"];
		d.cbFlattenImageTIFF3.value = p["flattenTIFF3"];
		d.cbMax1.value = p["max1"];
		d.cbMax2.value = p["max2"];
		d.cbMax3.value = p["max3"];
		d.cbFlattenImagePSD1.value = p["flattenPSD1"];
		d.cbFlattenImagePSD2.value = p["flattenPSD2"];
		d.cbFlattenImagePSD3.value = p["flattenPSD3"];
		d.etColors1.text = p["c1"];
		d.etColors2.text = p["c2"];
		d.etColors3.text = p["c3"];
		d.cbResizeFile1.value = p["fileresize1"];
		d.etResizeFileH1.text = p["fileh1"];
		d.etResizeFileW1.text = p["filew1"];
		d.etResizeFileR1.text = p["filer1"];
		d.cbResizeFile2.value = p["fileresize2"];
		d.etResizeFileH2.text = p["fileh2"];
		d.etResizeFileW2.text = p["filew2"];
		d.etResizeFileR2.text = p["filer2"];
		d.cbResizeFile3.value = p["fileresize3"];
		d.etResizeFileH3.text = p["fileh3"];
		d.etResizeFileW3.text = p["filew3"];
		d.etResizeFileR3.text = p["filer3"];
		d.etCopyrightInfo.text = p["info"];
				 
	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: ForceDialogUpdate
	// Usage: pretend like i clicked it to get the other items to respond to the 
	//        current settings
	// Input: <none> params must be set
	// Return: <none> dialog is set from the latest params, used for load and save
	///////////////////////////////////////////////////////////////////////////////
	this.ForceDialogUpdate = function() {	
		try {
		if ( ! this.runningFromBridge ) {
			this.dlgMain.rbUseOpen.onClick();
			this.dlgMain.cbKeepStructure.onClick();
		}
		
		this.dlgMain.rbSaveInSame.onClick();

		this.dlgMain.cbSaveImageAs1.onClick();
		this.dlgMain.cbSaveImageAs2.onClick();
		this.dlgMain.cbSaveImageAs3.onClick();
		this.dlgMain.SetDropDown( this.dlgMain.ddFile1, this.params["file1"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddFile2, this.params["file2"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddFile3, this.params["file3"] );
		this.dlgMain.cbMakeFolders.onClick();
		this.dlgMain.SetDropDown( this.dlgMain.ddConvertICC1, this.params["converticc1"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddConvertICC2, this.params["converticc2"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddConvertICC3, this.params["converticc3"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddWhenAction1, this.params["whenaction1"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddWhenAction2, this.params["whenaction2"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddWhenAction3, this.params["whenaction3"] );
		this.dlgMain.cbResizeFile1.onClick();
		this.dlgMain.cbResizeFile2.onClick();
		this.dlgMain.cbResizeFile3.onClick();

		this.dlgMain.cbRunAction1.onClick();
		this.dlgMain.cbRunAction2.onClick();
		this.dlgMain.cbRunAction3.onClick();
		var index = this.dlgMain.SetDropDown( this.dlgMain.ddSet1, this.params["actionset1"] );
		if ( this.actionInfo.length > 0 ) {
			this.dlgMain.ddSet1.onChange( index );
			this.actionIndex1 = this.dlgMain.SetDropDown( this.dlgMain.ddAction1, this.params["action1"] );
		}
		index = this.dlgMain.SetDropDown( this.dlgMain.ddSet2, this.params["actionset2"] );
		if ( this.actionInfo.length > 0 ) {
			this.dlgMain.ddSet2.onChange( index );
			this.actionIndex2 = this.dlgMain.SetDropDown( this.dlgMain.ddAction2, this.params["action2"] );
		}
		index = this.dlgMain.SetDropDown( this.dlgMain.ddSet3, this.params["actionset3"] );
		if ( this.actionInfo.length > 0 ) {
			this.dlgMain.ddSet3.onChange( index );
			this.actionIndex3 = this.dlgMain.SetDropDown( this.dlgMain.ddAction3, this.params["action3"] );
		}
		this.dlgMain.SetDropDown( this.dlgMain.ddResizeFileW1, this.params["filewu1"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddResizeFileH1, this.params["filehu1"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddResizeFileR1, this.params["fileru1"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddResizeFileW2, this.params["filewu2"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddResizeFileH2, this.params["filehu2"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddResizeFileR2, this.params["fileru2"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddResizeFileW3, this.params["filewu3"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddResizeFileH3, this.params["filehu3"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddResizeFileR3, this.params["fileru3"] );
		
		this.dlgMain.SetDropDown( this.dlgMain.ddInterpolate1, this.params["interpolate1"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddInterpolate2, this.params["interpolate2"] );
		this.dlgMain.SetDropDown( this.dlgMain.ddInterpolate3, this.params["interpolate3"] );

		this.dlgMain.lastFile1Units = this.params["filewu1"];
		this.dlgMain.lastFile2Units = this.params["filewu2"];
		this.dlgMain.lastFile3Units = this.params["filewu3"];
		}
		catch(e) {
			alert(e + ":" + e.line);
		}

	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: GetParamsFromDialog
	// Usage: transfer from the dialog widgets to my internal params
	// Input: <none> 
	// Return: <none>
	///////////////////////////////////////////////////////////////////////////////
	this.GetParamsFromDialog = function() {
		try {
		var p = this.params;
		var d = this.dlgMain;
		
		if ( ! this.runningFromBridge ) {
			p["useopen"] = d.rbUseOpen.value;
			p["source"] = d.sourceLongText;
			p["includesub"] = d.cbIncludeSubFolders.value;
			p["keepstructure"] = d.cbKeepStructure.value;
		}

		p["saveinsame"] = d.rbSaveInSame.value;
		// OFIREMOVE p["open"] = d.cbOpenFirst.value;
		p["dest"] = d.destLongText;
		p["makefolders"] = d.cbMakeFolders.value;
		p["folder1"] = d.etFolder1.text;
		p["folder2"] = d.etFolder2.text;
		p["folder3"] = d.etFolder3.text;
		p["outfile1"] = d.cbSaveImageAs1.value;
		p["outfile2"] = d.cbSaveImageAs2.value;
		p["outfile3"] = d.cbSaveImageAs3.value;
		p["file1"] = d.ddFile1.selection.text;
		p["file2"] = d.ddFile2.selection.text;
		p["file3"] = d.ddFile3.selection.text;
		p["converticc1"] = d.ddConvertICC1.selection.text;
		p["converticc2"] = d.ddConvertICC2.selection.text;
		p["converticc3"] = d.ddConvertICC3.selection.text;
		p["q1"] = d.etQuality1.text;
		p["q2"] = d.etQuality2.text;
		p["q3"] = d.etQuality3.text;
		p["lace1"] = d.cbLace1.value;
		p["lace2"] = d.cbLace2.value;
		p["lace3"] = d.cbLace3.value;
		p["sfw1"] = d.cbSFW1.value;
		p["sfw2"] = d.cbSFW2.value;
		p["sfw3"] = d.cbSFW3.value;
		p["crazy1"] = d.cbUseSFW1.value;
		p["crazy2"] = d.cbUseSFW2.value;
		p["crazy3"] = d.cbUseSFW3.value;
		p["lzw1"] = d.cbLZW1.value;
		p["lzw2"] = d.cbLZW2.value;
		p["lzw3"] = d.cbLZW3.value;
		p["flattenTIFF1"] = d.cbFlattenImageTIFF1.value;
		p["flattenTIFF2"] = d.cbFlattenImageTIFF2.value;
		p["flattenTIFF3"] = d.cbFlattenImageTIFF3.value;
		p["max1"] = d.cbMax1.value;
		p["max2"] = d.cbMax2.value;
		p["max3"] = d.cbMax3.value;
		p["flattenPSD1"] = d.cbFlattenImagePSD1.value;
		p["flattenPSD2"] = d.cbFlattenImagePSD2.value;
		p["flattenPSD3"] = d.cbFlattenImagePSD3.value;
		p["c1"] = d.etColors1.text;
		p["c2"] = d.etColors2.text;
		p["c3"] = d.etColors3.text;
		p["runaction1"] = d.cbRunAction1.value;
		p["runaction2"] = d.cbRunAction2.value;
		p["runaction3"] = d.cbRunAction3.value;
		p["whenaction1"] = d.ddWhenAction1.selection.text;
		p["whenaction2"] = d.ddWhenAction2.selection.text;
		p["whenaction3"] = d.ddWhenAction3.selection.text;
		p["fileresize1"] = d.cbResizeFile1.value;
		p["fileh1"] = d.etResizeFileH1.text;
		p["filew1"] = d.etResizeFileW1.text;
		p["filer1"] = d.etResizeFileR1.text;
		p["filehu1"] = d.ddResizeFileH1.selection.text;
		p["filewu1"] = d.ddResizeFileW1.selection.text;
		p["fileru1"] = d.ddResizeFileR1.selection.text;
		p["interpolate1"] = d.ddInterpolate1.selection.text;
		p["fileresize2"] = d.cbResizeFile2.value;
		p["fileh2"] = d.etResizeFileH2.text;
		p["filew2"] = d.etResizeFileW2.text;
		p["filer2"] = d.etResizeFileR2.text;
		p["filehu2"] = d.ddResizeFileH2.selection.text;
		p["filewu2"] = d.ddResizeFileW2.selection.text;
		p["fileru2"] = d.ddResizeFileR2.selection.text;
		p["interpolate2"] = d.ddInterpolate2.selection.text;
		p["fileresize3"] = d.cbResizeFile3.value;
		p["fileh3"] = d.etResizeFileH3.text;
		p["filew3"] = d.etResizeFileW3.text;
		p["filer3"] = d.etResizeFileR3.text;
		p["filehu3"] = d.ddResizeFileH3.selection.text;
		p["filewu3"] = d.ddResizeFileW3.selection.text;
		p["fileru3"] = d.ddResizeFileR3.selection.text;
		p["interpolate3"] = d.ddInterpolate3.selection.text;
		p["actionset1"] = d.ddSet1.selection.text;
		p["action1"] = d.ddAction1.selection.text;
		p["actionset2"] = d.ddSet2.selection.text;
		p["action2"] = d.ddAction2.selection.text;
		p["actionset3"] = d.ddSet3.selection.text;
		p["action3"] = d.ddAction3.selection.text;
		p["info"] = d.etCopyrightInfo.text;
		}
		catch(e) {
			alert( e + ":" + e.line);
		}
	}
	
	///////////////////////////////////////////////////////////////////////////////
	// Function: RunDialog
	// Usage: routine for running the dialog and it's interactions
	// Input: <none>
	// Return: <none>
	///////////////////////////////////////////////////////////////////////////////
	this.RunDialog = function () {

		this.dlgMain.btnCancel.onClick = function() { 
			var d = FindDialog( this );
			d.close( 2 );
		}

		if ( ! this.runningFromBridge ) {
			this.dlgMain.rbUseOpen.onClick = function() {
				var d = FindDialog( this );
				d.rbUseFolder.value = ! this.value;
				d.btnSource.enabled = ! this.value;
				d.stSource.enabled = ! this.value;
			}

			this.dlgMain.rbUseFolder.onClick = function() {
				var d = FindDialog( this );
				d.rbUseOpen.value = ! this.value;
				d.btnSource.enabled = this.value;
				d.stSource.enabled = this.value;
			}

			this.dlgMain.btnSource.onClick = function() { 
				var d = FindDialog( this );
				var selFolder = Folder.selectDialog( strPickSource, this.parent.parent.sourceLongText );
				if ( selFolder != null ) {
					d.sourceLongText = selFolder.fsName.toString()
					d.stSource.text = CreateShortFileName( d.sourceLongText );
				}
				d.defaultElement.active = true;
			}
			
			this.dlgMain.cbKeepStructure.onClick = function() {
		    	var d = FindDialog( this );
				d.cbMakeFolders.value = ! this.value;
				d.cbMakeFolders.onClick();
			}

		}

		this.dlgMain.rbSaveInSame.onClick = function() {
			var d = FindDialog( this );
			d.rbSaveInNew.value = ! this.value;
			d.btnDest.enabled = ! this.value;
			d.stDest.enabled = ! this.value;
			if ( ! d.ip.runningFromBridge ) {
				d.cbKeepStructure.enabled = ! this.value;
			}
		}
		
		this.dlgMain.rbSaveInNew.onClick = function() {
			var d = FindDialog( this );
			d.rbSaveInSame.value = ! this.value;
			d.btnDest.enabled = this.value;
			d.stDest.enabled = this.value;
			if ( ! d.ip.runningFromBridge ) {
				d.cbKeepStructure.enabled = this.value;
			}
		}

		this.dlgMain.SetDropDown = function ( dd, strSet ) {
			var index = 0;
			for ( var i = 0; i < dd.items.length; i++ ) {
				if ( dd.items[ i ].toString() == strSet ) {
					index = i;
					break;
				}
			}
			if ( dd.items.length > 0 && index < dd.items.length ) {
				dd.items[ index ].selected = true;
			}
			return index;
		}

		this.dlgMain.btnLoad.onClick = function() { 
			var d = FindDialog( this );
			var loadFile = null;
			Folder.current = Folder( "~/" );
			if ( File.fs == "Windows" ) {
				loadFile = File.openDialog( strPickXML, strPickXMLWin );
			} else {
				loadFile = File.openDialog( strPickXML, MacXMLFilter );
			}
			if ( loadFile != null ) {
				d.ip.LoadParamsFromDisk( loadFile );
				d.ip.InitDialog();
				d.loadFromDisk = true;
				d.ip.ForceDialogUpdate();
			}
			d.defaultElement.active = true;
		}
		
		this.dlgMain.btnSave.onClick = function() { 
			var d = FindDialog( this );
			var saveFile = null;
			Folder.current = Folder( "~/" );
			if ( File.fs == "Windows" ) {
				saveFile = File.saveDialog( strPickXMLSave, strPickXMLWin );
			} else {
				saveFile = File.saveDialog( strPickXMLSave, MacXMLFilter );
			}
			if ( saveFile != null ) {
				d.ip.GetParamsFromDialog();
				d.ip.SaveParamsToDisk( saveFile );
			}
			d.defaultElement.active = true;
		}

		this.dlgMain.btnDest.onClick = function() { 
			var d = FindDialog( this );
			var selFolder = Folder.selectDialog( strPickDest, this.parent.parent.destLongText );
			if ( selFolder != null ) {
				d.destLongText = selFolder.fsName.toString()
				d.stDest.text = CreateShortFileName( d.destLongText );
			}
			d.defaultElement.active = true;
		}
		
		this.dlgMain.cbMakeFolders.onClick = function() { 
			try { 
		    var d = FindDialog( this );
		    var realValue = this.value;
		    if ( ! d.cbSaveImageAs1.value ) {
				realValue = false;
			}
		    d.stFolder1.enabled = realValue;
		    d.etFolder1.enabled = realValue;
		    var realValue = this.value;
		    if ( ! d.cbSaveImageAs2.value ) {
				realValue = false;
			}
		    d.stFolder2.enabled = realValue;
		    d.etFolder2.enabled = realValue;
		    var realValue = this.value;
		    if ( ! d.cbSaveImageAs3.value ) {
				realValue = false;
			}
		    d.stFolder3.enabled = realValue;
		    d.etFolder3.enabled = realValue;
			if ( ! d.ip.runningFromBridge ) {
				d.cbKeepStructure.value = ! this.value;
			}
		    }
		    catch(e) {
				alert( e + ":" + e.line );
			}
		}
	
		this.dlgMain.cbSaveImageAs1.onClick = function() {
		try {
			var d = FindDialog( this );
			var realValue = this.value;
			d.ddFile1.enabled = this.value;
			d.ddFile1.onChange();
			d.ddConvertICC1.enabled = realValue;
			d.stOutputProfile1.enabled = realValue;
			d.cbResizeFile1.enabled = realValue;
			d.cbResizeFile1.onClick();
			if ( d.ip.actionInfo.length == 0 ) {
				realValue = false;
			}
			d.cbRunAction1.enabled = realValue;
			d.ddWhenAction1.enabled = realValue;
			d.stSelectAction1.enabled = realValue;
			d.ddSet1.enabled = realValue;
			d.ddAction1.enabled = realValue;
			d.cbRunAction1.onClick();
			d.cbMakeFolders.onClick();
			if ( ! d.ip.runningFromBridge ) {
				d.cbKeepStructure.onClick();
			}
			}
			catch(e) {
				alert( e + ":" + e.line );
			}
		
		}
		
		this.dlgMain.cbSaveImageAs2.onClick = function() {
		try {
			var d = FindDialog( this );
			var realValue = this.value;
			d.ddFile2.enabled = this.value;
			d.ddFile2.onChange();
			d.ddConvertICC2.enabled = realValue;
			d.stOutputProfile2.enabled = realValue;
			d.cbResizeFile2.enabled = realValue;
			d.cbResizeFile2.onClick();
			if ( d.ip.actionInfo.length == 0 ) {
				realValue = false;
			}
			d.cbRunAction2.enabled = realValue;
			d.ddWhenAction2.enabled = realValue;
			d.stSelectAction2.enabled = realValue;
			d.ddSet2.enabled = realValue;
			d.ddAction2.enabled = realValue;
			d.cbRunAction2.onClick();
			d.cbMakeFolders.onClick();
			if ( ! d.ip.runningFromBridge ) {
				d.cbKeepStructure.onClick();
			}
			}
			catch(e) {
				alert( e + ":" + e.line );
			}
		
		}
		
		this.dlgMain.cbSaveImageAs3.onClick = function() {
		try {
			var d = FindDialog( this );
			var realValue = this.value;
			d.ddFile3.enabled = this.value;
			d.ddFile3.onChange();
			d.ddConvertICC3.enabled = realValue;
			d.stOutputProfile3.enabled = realValue;
			d.cbResizeFile3.enabled = realValue;
			d.cbResizeFile3.onClick();
			if ( d.ip.actionInfo.length == 0 ) {
				realValue = false;
			}
			d.cbRunAction3.enabled = realValue;
			d.ddWhenAction3.enabled = realValue;
			d.stSelectAction3.enabled = realValue;
			d.ddSet3.enabled = realValue;
			d.ddAction3.enabled = realValue;
			d.cbRunAction3.onClick();
			d.cbMakeFolders.onClick();
			if ( ! d.ip.runningFromBridge ) {
				d.cbKeepStructure.onClick();
			}
			}
			catch(e) {
				alert( e + ":" + e.line );
			}
		
		}
		
		this.dlgMain.ddFile1.onChange = function() {
			try {
				var d = FindDialog( this );
					if ( this.selection != null ) {
						if ( this.selection.text == "JPEG" ) {
							d.cbLZW1.parent.hide();
							d.cbMax1.parent.hide();
							d.stColors1.parent.hide();
							d.stQuality1.parent.show();
							d.cbLace1.parent.hide();
						}
						if ( this.selection.text == "PNG" ) {
							d.cbLZW1.parent.hide();
							d.cbMax1.parent.hide();
							d.stColors1.parent.hide();
							d.stQuality1.parent.hide();
							d.cbLace1.parent.show()
						}
						if ( this.selection.text == "TIFF" ) {
							d.cbMax1.parent.hide();
							d.stQuality1.parent.hide();
							d.stColors1.parent.hide();
							d.cbLZW1.parent.show();
							d.cbLace1.parent.hide();
						}
						if ( this.selection.text == "PSD" ) {
							d.cbLZW1.parent.hide();
							d.stQuality1.parent.hide();
							d.stColors1.parent.hide();
							d.cbMax1.parent.show();
							d.cbLace1.parent.hide();
						}
						if ( this.selection.text == "GIF" ) {
							d.cbLZW1.parent.hide();
							d.stQuality1.parent.hide();
							d.cbMax1.parent.hide();
							d.stColors1.parent.show();
							d.cbLace1.parent.hide();
						}
					} else {
						d.cbLZW1.parent.hide();
						d.stQuality1.parent.hide();
						d.cbMax1.parent.hide();
						d.stColors1.parent.hide();
					}
					if ( ! d.cbSaveImageAs1.value ) {
						d.cbLZW1.parent.hide();
						d.stQuality1.parent.hide();
						d.cbMax1.parent.hide();
						d.stColors1.parent.hide();
					}
				}
			catch(e) {
				alert( e + ":" + e.line );
			}
		}

		this.dlgMain.ddFile2.onChange = function() {
			try {
				var d = FindDialog( this );
					if ( this.selection != null ) {
						if ( this.selection.text == "JPEG" ) {
							d.cbLZW2.parent.hide();
							d.cbMax2.parent.hide();
							d.stColors2.parent.hide();
							d.stQuality2.parent.show();
							d.cbLace2.parent.hide();
						}
						if ( this.selection.text == "PNG" ) {
							d.cbLace2.parent.show();
							d.cbLZW2.parent.hide();
							d.cbMax2.parent.hide();
							d.stColors2.parent.hide();
							d.stQuality2.parent.hide();
						}
						if ( this.selection.text == "TIFF" ) {
							d.cbMax2.parent.hide();
							d.stQuality2.parent.hide();
							d.stColors2.parent.hide();
							d.cbLZW2.parent.show();
							d.cbLace2.parent.hide();
						}
						if ( this.selection.text == "PSD" ) {
							d.cbLZW2.parent.hide();
							d.stQuality2.parent.hide();
							d.stColors2.parent.hide();
							d.cbMax2.parent.show();
							d.cbLace2.parent.hide();
						}
						if ( this.selection.text == "GIF" ) {
							d.cbLZW2.parent.hide();
							d.stQuality2.parent.hide();
							d.cbMax2.parent.hide();
							d.stColors2.parent.show();
							d.cbLace2.parent.hide();
						}
					} else {
						d.cbLZW2.parent.hide();
						d.stQuality2.parent.hide();
						d.cbMax2.parent.hide();
						d.stColors2.parent.hide();
					}
					if ( ! d.cbSaveImageAs2.value ) {
						d.cbLZW2.parent.hide();
						d.stQuality2.parent.hide();
						d.cbMax2.parent.hide();
						d.stColors2.parent.hide();
					}
				}
			catch(e) {
				alert( e + ":" + e.line );
			}
		}

		this.dlgMain.ddFile3.onChange = function() {
			try {
				var d = FindDialog( this );
					if ( this.selection != null ) {
						if ( this.selection.text == "JPEG" ) {
							d.cbLZW3.parent.hide();
							d.cbMax3.parent.hide();
							d.stColors3.parent.hide();
							d.stQuality3.parent.show();
							d.cbLace3.parent.hide();
						}
						if ( this.selection.text == "PNG" ) {
							d.cbLace3.parent.show();
							d.cbLZW3.parent.hide();
							d.cbMax3.parent.hide();
							d.stColors3.parent.hide();
							d.stQuality3.parent.hide();
						}
						if ( this.selection.text == "TIFF" ) {
							d.cbMax3.parent.hide();
							d.stQuality3.parent.hide();
							d.stColors3.parent.hide();
							d.cbLZW3.parent.show();
							d.cbLace3.parent.hide();
						}
						if ( this.selection.text == "PSD" ) {
							d.cbLZW3.parent.hide();
							d.stQuality3.parent.hide();
							d.stColors3.parent.hide();
							d.cbMax3.parent.show();
							d.cbLace3.parent.hide();
						}
						if ( this.selection.text == "GIF" ) {
							d.cbLZW3.parent.hide();
							d.stQuality3.parent.hide();
							d.cbMax3.parent.hide();
							d.stColors3.parent.show();
							d.cbLace3.parent.hide();
						}
					} else {
						d.cbLZW3.parent.hide();
						d.stQuality3.parent.hide();
						d.cbMax3.parent.hide();
						d.stColors3.parent.hide();
					}
					if ( ! d.cbSaveImageAs3.value ) {
						d.cbLZW3.parent.hide();
						d.stQuality3.parent.hide();
						d.cbMax3.parent.hide();
						d.stColors3.parent.hide();
					}
				}
			catch(e) {
				alert( e + ":" + e.line );
			}
		}

		this.dlgMain.cbRunAction1.onClick = function( ) {
		try {
			var d = FindDialog( this );
			var realValue = this.value;
			if ( ! d.cbSaveImageAs1.value ) {
				realValue = false;
			}
			d.ddWhenAction1.enabled = realValue;
			d.stSelectAction1.enabled = realValue;
			d.ddSet1.enabled = realValue;
			d.ddAction1.enabled = realValue;
		}
		catch(e) {
			alert(e + ":" + e.line);
		}
		}
		
		this.dlgMain.cbRunAction2.onClick = function( ) {
			var d = FindDialog( this );
			var realValue = this.value;
			if ( ! d.cbSaveImageAs2.value ) {
				realValue = false;
			}
			d.ddWhenAction2.enabled = realValue;
			d.stSelectAction2.enabled = realValue;
			d.ddSet2.enabled = realValue;
			d.ddAction2.enabled = realValue;
		}
		
		this.dlgMain.cbRunAction3.onClick = function( ) {
			var d = FindDialog( this );
			var realValue = this.value;
			if ( ! d.cbSaveImageAs3.value ) {
				realValue = false;
			}
			d.ddWhenAction3.enabled = realValue;
			d.stSelectAction3.enabled = realValue;
			d.ddSet3.enabled = realValue;
			d.ddAction3.enabled = realValue;
		}
		
		
		this.dlgMain.cbResizeFile1.onClick = function( inValue ) {
			try {
			var d = FindDialog( this );
			var realValue = this.value;
			if ( ! d.cbSaveImageAs1.value ) {
				realValue = false;
			}
			d.stResizeFileW1.enabled = realValue;
			d.etResizeFileW1.enabled = realValue;
			d.ddResizeFileW1.enabled = realValue;
			d.stResizeFileH1.enabled = realValue;
			d.etResizeFileH1.enabled = realValue;
			d.ddResizeFileH1.enabled = realValue;
			d.stResizeFileR1.enabled = realValue;
			d.etResizeFileR1.enabled = realValue;
			d.ddResizeFileR1.enabled = realValue;
			d.ddInterpolate1.enabled = realValue;
			}
			catch(e) {
				alert( e + ":" + e.line );
			}
		}
		
		this.dlgMain.cbResizeFile2.onClick = function( inValue ) {
			try {
			var d = FindDialog( this );
			var realValue = this.value;
			if ( ! d.cbSaveImageAs2.value ) {
				realValue = false;
			}
			d.stResizeFileW2.enabled = realValue;
			d.etResizeFileW2.enabled = realValue;
			d.ddResizeFileW2.enabled = realValue;
			d.stResizeFileH2.enabled = realValue;
			d.etResizeFileH2.enabled = realValue;
			d.ddResizeFileH2.enabled = realValue;
			d.stResizeFileR2.enabled = realValue;
			d.etResizeFileR2.enabled = realValue;
			d.ddResizeFileR2.enabled = realValue;
			d.ddInterpolate2.enabled = realValue;
			}
			catch(e) {
				alert( e + ":" + e.line );
			}
		}
		
		this.dlgMain.cbResizeFile3.onClick = function( inValue ) {
			try {
			var d = FindDialog( this );
			var realValue = this.value;
			if ( ! d.cbSaveImageAs3.value ) {
				realValue = false;
			}
			d.stResizeFileW3.enabled = realValue;
			d.etResizeFileW3.enabled = realValue;
			d.ddResizeFileW3.enabled = realValue;
			d.stResizeFileH3.enabled = realValue;
			d.etResizeFileH3.enabled = realValue;
			d.ddResizeFileH3.enabled = realValue;
			d.stResizeFileR3.enabled = realValue;
			d.etResizeFileR3.enabled = realValue;
			d.ddResizeFileR3.enabled = realValue;
			d.ddInterpolate3.enabled = realValue;
			}
			catch(e) {
				alert( e + ":" + e.line );
			}
		}
		
		this.dlgMain.ddResizeFileW1.onChange = function() {
		    var d = FindDialog( this );
		    if ( d.lastFile1Units != this.selection.text ) {
		        if ( ( d.lastFile1Units != 'percent' ) && ( this.selection.text != 'percent' ) ) {
			        var nu = UnitsToUnits( d.etResizeFileW1.text, d.lastFile1Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR1.text, d.ddResizeFileR1.selection.text ), undefined );
			        d.etResizeFileW1.text = nu.toString();
			        nu = UnitsToUnits( d.etResizeFileH1.text, d.lastFile1Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR1.text, d.ddResizeFileR1.selection.text ), undefined );
		 	        d.etResizeFileH1.text = nu.toString();
		 	    } 
		        d.lastFile1Units = this.selection.text;
		    }
		    d.SetDropDown( d.ddResizeFileH1, this.selection.text );
		}

		this.dlgMain.ddResizeFileH1.onChange = function() {
		    var d = FindDialog( this );
		    if ( d.lastFile1Units != this.selection.text ) {
		        if ( ( d.lastFile1Units != 'percent' ) && ( this.selection.text != 'percent' ) ) {
    		        var nu = UnitsToUnits( d.etResizeFileW1.text, d.lastFile1Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR1.text, d.ddResizeFileR1.selection.text ), undefined );
	    	        d.etResizeFileW1.text = nu.toString();
		            nu = UnitsToUnits( d.etResizeFileH1.text, d.lastFile1Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR1.text, d.ddResizeFileR1.selection.text ), undefined );
		            d.etResizeFileH1.text = nu.toString();
		        }
		        d.lastFile1Units = this.selection.text;
		    }
		    d.SetDropDown( d.ddResizeFileW1, this.selection.text );
		}

		this.dlgMain.ddResizeFileR1.onChange = function() {
           var d = FindDialog( this );
		   if ( d.initisover1 > 1 ) {
		        var n = Number( d.etResizeFileR1.text );
		        if ( this.selection.text.search( "inch" ) != -1 ) {
    		        n = n * 2.54;
		        } else {
    		        n = n / 2.54;
		        }
		        d.etResizeFileR1.text = n.toString();
		    } else {
		    	d.initisover1++;
		    }
		}

		this.dlgMain.ddResizeFileW2.onChange = function() {
		    var d = FindDialog( this );
		    if ( d.lastFile2Units != this.selection.text ) {
		        if ( ( d.lastFile2Units != 'percent' ) && ( this.selection.text != 'percent' ) ) {
    		        var nu = UnitsToUnits( d.etResizeFileW2.text, d.lastFile2Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR2.text, d.ddResizeFileR2.selection.text ), undefined );
	    	        d.etResizeFileW2.text = nu.toString();
		            nu = UnitsToUnits( d.etResizeFileH2.text, d.lastFile2Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR2.text, d.ddResizeFileR2.selection.text ), undefined );
		            d.etResizeFileH2.text = nu.toString();
		        }
		        d.lastFile2Units = this.selection.text;
		    }
		    d.SetDropDown( d.ddResizeFileH2, this.selection.text );
		}

		this.dlgMain.ddResizeFileH2.onChange = function() {
		    var d = FindDialog( this );
		    if ( d.lastFile2Units != this.selection.text ) {
		        if ( ( d.lastFile2Units != 'percent' ) && ( this.selection.text != 'percent' ) ) {
    		        var nu = UnitsToUnits( d.etResizeFileW2.text, d.lastFile2Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR2.text, d.ddResizeFileR2.selection.text ), undefined );
	    	        d.etResizeFileW2.text = nu.toString();
		            nu = UnitsToUnits( d.etResizeFileH2.text, d.lastFile2Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR2.text, d.ddResizeFileR2.selection.text ), undefined );
		            d.etResizeFileH2.text = nu.toString();
		        }
		        d.lastFile2Units = this.selection.text;
		    }
		    d.SetDropDown( d.ddResizeFileW2, this.selection.text );
		}

		this.dlgMain.ddResizeFileR2.onChange = function() {
           var d = FindDialog( this );
		    if ( d.initisover2 > 1 ) {
		        var d = FindDialog( this );
		        var n = Number( d.etResizeFileR2.text );
		        if ( this.selection.text.search( "inch" ) != -1 ) {
		            n = n * 2.54;
		        } else {
		            n = n / 2.54;
		        }
		        d.etResizeFileR2.text = n.toString();
		    } else {
		    	d.initisover2++;
		    }
		}

		this.dlgMain.ddResizeFileW3.onChange = function() {
		    var d = FindDialog( this );
		    if ( d.lastFile3Units != this.selection.text ) {
		        if ( ( d.lastFile3Units != 'percent' ) && ( this.selection.text != 'percent' ) ) {
    		        var nu = UnitsToUnits( d.etResizeFileW3.text, d.lastFile3Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR3.text, d.ddResizeFileR3.selection.text ), undefined );
	    	        d.etResizeFileW3.text = nu.toString();
		            nu = UnitsToUnits( d.etResizeFileH3.text, d.lastFile3Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR3.text, d.ddResizeFileR3.selection.text ), undefined );
		            d.etResizeFileH3.text = nu.toString();
		        }
		        d.lastFile3Units = this.selection.text;
		    }
		    d.SetDropDown( d.ddResizeFileH3, this.selection.text );
		}

		this.dlgMain.ddResizeFileH3.onChange = function() {
		    var d = FindDialog( this );
		    if ( d.lastFile3Units != this.selection.text ) {
		        if ( ( d.lastFile3Units != 'percent' ) && ( this.selection.text != 'percent' ) ) {
    		        var nu = UnitsToUnits( d.etResizeFileW3.text, d.lastFile3Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR3.text, d.ddResizeFileR3.selection.text ), undefined );
	    	        d.etResizeFileW3.text = nu.toString();
		            nu = UnitsToUnits( d.etResizeFileH3.text, d.lastFile3Units, this.selection.text, ResolutionInPixelsPerInch( d.etResizeFileR3.text, d.ddResizeFileR3.selection.text ), undefined );
		            d.etResizeFileH3.text = nu.toString();
		        }
		        d.lastFile3Units = this.selection.text;
		    }
		    d.SetDropDown( d.ddResizeFileW3, this.selection.text );
		}

		this.dlgMain.ddResizeFileR3.onChange = function() {
           var d = FindDialog( this );
		    if ( d.initisover3 > 1 ) {
		        var d = FindDialog( this );
		        var n = Number( d.etResizeFileR3.text );
		        if ( this.selection.text.search( "inch" ) != -1 ) {
		            n = n * 2.54;
		        } else {
		            n = n / 2.54;
		        }
		        d.etResizeFileR3.text = n.toString();
		    } else {
		    	d.initisover3++;
		    }
		}

		if ( this.actionInfo.length > 0 ) {
			for ( var i = 0; i < this.actionInfo.length; i++ ) {
				this.dlgMain.ddSet1.add( "item", this.actionInfo[i].name );
				this.dlgMain.ddSet2.add( "item", this.actionInfo[i].name );
				this.dlgMain.ddSet3.add( "item", this.actionInfo[i].name );
			}
			this.dlgMain.ddSet1.items[0].selected = true;
			this.dlgMain.ddSet2.items[0].selected = true;
			this.dlgMain.ddSet3.items[0].selected = true;
			this.dlgMain.ddSet1.onChange = function( forcedSelectionIndex ) {
				var index = 0;
				var d = FindDialog( this );
				d.ddAction1.removeAll();
				if ( undefined == forcedSelectionIndex ) {
					forcedSelectionIndex = this.selection.index;
					if ( undefined != d.ip.actionIndex1 ) {
						index = d.ip.actionIndex1;
						d.ip.actionIndex1 = undefined;
					}
				}
				for ( var i = 0; i < d.ip.actionInfo[ forcedSelectionIndex ].children.length; i++ ) {
					d.ddAction1.add( "item", d.ip.actionInfo[ forcedSelectionIndex ].children[ i ].name );
				}
				if ( d.ddAction1.items.length > 0 ) {
					d.ddAction1.items[ index ].selected = true;
				}
				if ( null != this.selection ) {
					this.helpTip = this.selection.text;
				}
			}
			this.dlgMain.ddSet2.onChange = function( forcedSelectionIndex ) {
				var index = 0;
				var d = FindDialog( this );
				d.ddAction2.removeAll();
				if ( undefined == forcedSelectionIndex ) {
					forcedSelectionIndex = this.selection.index;
					if ( undefined != d.ip.actionIndex2 ) {
						index = d.ip.actionIndex2;
						d.ip.actionIndex2 = undefined;
					}
				}
				for ( var i = 0; i < d.ip.actionInfo[ forcedSelectionIndex ].children.length; i++ ) {
					d.ddAction2.add( "item", d.ip.actionInfo[ forcedSelectionIndex ].children[ i ].name );
				}
				if ( d.ddAction2.items.length > 0 ) {
					d.ddAction2.items[ index ].selected = true;
				}
				if ( null != this.selection ) {
					this.helpTip = this.selection.text;
				}
			}
			this.dlgMain.ddSet3.onChange = function( forcedSelectionIndex ) {
				var index = 0;
				var d = FindDialog( this );
				d.ddAction3.removeAll();
				if ( undefined == forcedSelectionIndex ) {
					forcedSelectionIndex = this.selection.index;
					if ( undefined != d.ip.actionIndex3 ) {
						index = d.ip.actionIndex3;
						d.ip.actionIndex3 = undefined;
					}
				}
				for ( var i = 0; i < d.ip.actionInfo[ forcedSelectionIndex ].children.length; i++ ) {
					d.ddAction3.add( "item", d.ip.actionInfo[ forcedSelectionIndex ].children[ i ].name );
				}
				if ( d.ddAction3.items.length > 0 ) {
					d.ddAction3.items[ index ].selected = true;
				}
				if ( null != this.selection ) {
					this.helpTip = this.selection.text;
				}
			}
		}
	
		this.dlgMain.ddAction1.onChange = function() {
			this.helpTip = this.selection.text;
		}
		this.dlgMain.ddAction2.onChange = function() {
			this.helpTip = this.selection.text;
		}
		this.dlgMain.ddAction3.onChange = function() {
			this.helpTip = this.selection.text;
		}

		this.dlgMain.onShow = function() {
			this.ip.ForceDialogUpdate();
		}
		
		this.dlgMain.btnRun.onClick = function () {
			try {
			var testFolder = null;
			var d = FindDialog( this );
			if ( ! d.ip.runningFromBridge ) {
				if ( d.rbUseFolder.value ) {
					if ( d.sourceLongText.length > 0 && d.sourceLongText[0] != '.' ) {
						testFolder = new Folder( d.sourceLongText );
						if ( ! testFolder.exists ) {
							d.btnDest.active = true;
							alert( strSpecifySource );
							return;
						}
					} else {
						d.btnDest.active = true;
						alert( strSpecifySource );
						return;
					}
				}
			}

			if ( d.rbSaveInNew.value ) {
				if ( d.destLongText.length > 0 && d.destLongText[0] != '.' ) {
					testFolder = new Folder( d.destLongText );
					if ( ! testFolder.exists ) {
						alert( strSpecifyDest );
						return;
					}
				} else {
					alert( strSpecifyDest );
					return;
				}
			}

			if ( d.cbSaveImageAs1.value ) {
				
				if ( d.ddFile1.selection.text == "JPEG" ) {
					var q = Number( d.etQuality1.text );
					if ( q < 0 || q > 12 || isNaN( q ) ) {
						d.etQuality1.active = true;
						alert( strJPEGQuality );
						return;
					}
				}

				if ( d.ddFile1.selection.text == "GIF" ) {
					var c = Number( d.etColors1.text );
					if ( c < 0 || c > 256 || isNaN( c ) ) {
						d.etColors1.active = true;
						alert( strBadColors );
						return;
					}
				}
			
				if ( d.cbResizeFile1.value ) {
					var whcount = 2;
					var w = Number( d.etResizeFileW1.text );
					var h = Number( d.etResizeFileH1.text );
					if ( w == 0 || isNaN( w ) ) {
						whcount--;
					}
					if ( h == 0 || isNaN( h ) ) {
						whcount--;
					}
					if ( whcount == 0 ) {
						d.etResizeFileW1.active = true;
						alert( strWandH );
						return;
					}
				}

			}

			if ( d.cbSaveImageAs2.value ) {
				
				if ( d.ddFile2.selection.text == "JPEG" ) {
					var q = Number( d.etQuality2.text );
					if ( q < 0 || q > 12 || isNaN( q ) ) {
						d.etQuality2.active = true;
						alert( strJPEGQuality );
						return;
					}
				}
			
				if ( d.ddFile2.selection.text == "GIF" ) {
					var c = Number( d.etColors2.text );
					if ( c < 0 || c > 256 || isNaN( c ) ) {
						d.etColors2.active = true;
						alert( strBadColors );
						return;
					}
				}

				if ( d.cbResizeFile2.value ) {
					var whcount = 2;
					var w = Number( d.etResizeFileW2.text );
					var h = Number( d.etResizeFileH2.text );
					if ( w == 0 || isNaN( w ) ) {
						whcount--;
					}
					if ( h == 0 || isNaN( h ) ) {
						whcount--;
					}
					if ( whcount == 0 ) {
						d.etResizeFileW2.active = true;
						alert( strWandH );
						return;
					}
				}
			
			}
		
			if ( d.cbSaveImageAs3.value ) {
				
				if ( d.ddFile3.selection.text == "JPEG" ) {
					var q = Number( d.etQuality3.text );
					if ( q < 0 || q > 12 || isNaN( q ) ) {
						d.etQuality3.active = true;
						alert( strJPEGQuality );
						return;
					}
				}

				if ( d.ddFile3.selection.text == "GIF" ) {
					var c = Number( d.etColors3.text );
					if ( c < 0 || c > 256 || isNaN( c ) ) {
						d.etColors3.active = true;
						alert( strBadColors );
						return;
					}
				}

				if ( d.cbResizeFile3.value ) {
					var whcount = 2;
					var w = Number( d.etResizeFileW3.text );
					var h = Number( d.etResizeFileH3.text );
					if ( w == 0 || isNaN( w ) ) {
						whcount--;
					}
					if ( h == 0 || isNaN( h ) ) {
						whcount--;
					}
					if ( whcount == 0 ) {
						d.etResizeFileW3.active = true;
						alert( strWandH );
						return;
					}
				}

			}
		

			// make sure they have at least one file format specified for output
			var outputCount = 0;
			if ( d.cbSaveImageAs1.value ) {
				outputCount++;
			}
			if ( d.cbSaveImageAs2.value ) {
				outputCount++;
			}
			if ( d.cbSaveImageAs3.value ) {
				outputCount++;
			}

			if ( outputCount == 0 ) {
				alert( strOneType );
				return;
			}

			d.ip.GetParamsFromDialog()
			
			d.close( 1 );
			
			} catch(e) { alert( e + ":" + e.line ); }
		}

		this.InitDialog();

		this.dlgMain.center();
		
		return this.dlgMain.show();

	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: Execute
	// Usage: if I get here then the dialog params are ok and it is time to do what
	//        they want
	// Input: <none>
	// Return: <none>
	///////////////////////////////////////////////////////////////////////////////
	this.Execute = function()  {
		var cameraRawParams = new Object();
		cameraRawParams.desc = undefined;
		cameraRawParams.useDescriptor = false;
		cameraRawParams.fileName = this.params["source"] + "/x";
		if ( ( this.runningFromBridge || ! this.params["useopen"] ) && this.params["open"] ) {
			cameraRawParams.useDescriptor = true;
			cameraRawParams.fileName = this.GetFirstFile( this.params["source"] );
			if ( ! IsFileOneOfThese( cameraRawParams.fileName, gFilesToSkip ) ) {
				if ( this.OpenCameraRaw( cameraRawParams, true ) ) {
					this.AdjustFile( cameraRawParams );
					if ( this.params["saveinsame"] ) {
						var destFolder = File( cameraRawParams.fileName ).parent.toString();
					} else {
						var destFolder = this.params["dest"];
					}
					this.SaveFile( cameraRawParams.fileName, destFolder );
					app.activeDocument.close( SaveOptions.DONOTSAVECHANGES );
				} else {
					return;
				}
			} else {
				alert( strNotaRAW + cameraRawParams.fileName );
				return;
			}
		}
		this.OpenAdjustSaveTheRest( cameraRawParams );
	}
	
	///////////////////////////////////////////////////////////////////////////////
	// Function: OpenAdjustSaveTheRest
	// Usage: the heart of the script is this routine and Execute loop through all 
	//        the files and save accordingly
	// Input: <none>
	// Return: <none>
	///////////////////////////////////////////////////////////////////////////////
	this.OpenAdjustSaveTheRest = function( inCameraRawParams ) {
		var firstFileAsLowerCaseString = "";
		if ( inCameraRawParams.fileName != undefined ) {
			firstFileAsLowerCaseString = inCameraRawParams.fileName.toString().toLowerCase();
		}
		var inputFiles;
		if ( this.runningFromBridge ) {
			inputFiles = this.filesFromBridge;
		} else if ( this.params["useopen"] ) {
			inputFiles = OpenDocs();
		} else if ( this.params["includesub"] ) {
			inputFiles = new Array();
			inputFiles = FindAllFiles( this.params["source"], inputFiles );
		} else {
			inputFiles = Folder ( this.params["source"] ).getFiles ();
		}

		var filesProcessed = 0;
		
		for (var i = 0; i < inputFiles.length; i++) {

			try {
				var thisFileAsLowerCaseString = inputFiles[i].toString().toLowerCase();

				if ( ( inputFiles[i] instanceof File && 
					   ! inputFiles[i].hidden && 
					   firstFileAsLowerCaseString != thisFileAsLowerCaseString ) || 
					  this.params["useopen"] ) {

					inCameraRawParams.fileName = inputFiles[i].fullName.toString();

					if ( ! IsFileOneOfThese( inCameraRawParams.fileName, gFilesToSkip ) ) {
						if ( ! this.runningFromBridge && this.params["useopen"] ) {
							app.activeDocument = inputFiles[ i ];
							app.activeDocument.duplicate();
						} else {
							this.OpenCameraRaw( inCameraRawParams, false, DialogModes.NO );
						}

						this.AdjustFile( inCameraRawParams );

						if ( this.params["saveinsame"] ) {
							var destFolder = inputFiles[i].parent.toString();
							if ( ! this.runningFromBridge && this.params["useopen"] ) {
								var destFolder = inputFiles[i].fullName.parent.toString();
								inCameraRawParams.fileName = app.activeDocument.name;
							}
						} else {
							var destFolder = this.params["dest"];
						}

						this.SaveFile( inCameraRawParams.fileName, destFolder  );
						app.activeDocument.close( SaveOptions.DONOTSAVECHANGES );
						filesProcessed++;
					}
				}
			}

			// don't let one file spoil the party!
			catch( e ) {
				this.fileErrors.push( inputFiles[i] );
			}

		}
		if ( 0 == filesProcessed ) {
			alert( 'No files processed. Did you point me at an empty folder?' );
		}
	}
	
	///////////////////////////////////////////////////////////////////////////////
	// Function: AdjustFile
	// Usage: using the dialog adjust the active document
	// Input: <none>
	// Return: <none>
	///////////////////////////////////////////////////////////////////////////////
	this.AdjustFile = function ( inOutCameraRawParams ) {
		var docRef = app.activeDocument;

		if ( this.params["info"] != "" ) {
			docRef.info.copyrightNotice = this.params["info"];
			docRef.info.copyrighted = CopyrightedType.COPYRIGHTEDWORK;
		}
	}
	
	///////////////////////////////////////////////////////////////////////////////
	// Function: SaveFile
	// Usage: I can save in three formats, JPEG, JPEG, and JPEG you can save it in 
	//        any file type you like as long as it is JPEG 
	//        ( Henry Ford reference here. )
	// Input: <none>
	// Return: <none>
	///////////////////////////////////////////////////////////////////////////////
	this.SaveFile = function ( inFileName, inFolderLocation ) {
		var lastDot = inFileName.lastIndexOf( "." );
		if ( lastDot == -1 ) {
			lastDot = inFileName.length;
		}
		var fileNameNoPath = inFileName.substr( 0, lastDot );
		var lastSlash = fileNameNoPath.lastIndexOf( "/" );
		fileNameNoPath = fileNameNoPath.substr( lastSlash + 1, fileNameNoPath.length );
		
		// these are all the same, I didn't make a routine because the param list is huge
		// any modifications in the if need to be copy pasted
		if ( this.params["outfile1"] ) {
		    var subFolderText = inFolderLocation + "/";
		    if ( this.params["makefolders"] ) {
		        subFolderText = subFolderText + this.params["folder1"] + "/";
		    }
			if ( ! this.runningFromBridge && this.params["keepstructure"] && ! this.params["saveinsame"] ) {
				subFolderText = activeDocument.path.fsName.toString();
				subFolderText = subFolderText.replace( this.params["source"], this.params["dest"] );
				subFolderText += "/";
			}
			Folder( subFolderText ).create();
			var historyState = app.activeDocument.activeHistoryState;
			if ( this.params["runaction1"] && this.params["whenaction1"] == "Before Image Resize" ) {
				app.doAction( this.params["action1"], this.params["actionset1"] );
			}
			if ( ( this.params["file1"] == "TIFF" && this.params["flattenTIFF1"] ) ||
			     ( this.params["file1"] == "PSD" && this.params["flattenPSD1"] ) || 
				 this.params["file1"] == "JPEG" ||
				 this.params["file1"] == "GIF" ) {
				app.activeDocument.flatten();
			}
			if ( this.params["file1"] == "JPEG" || this.params["file1"] == "GIF" || this.params["file1"] == "PNG"  ) { 
				app.activeDocument.bitsPerChannel = BitsPerChannelType.EIGHT;
			}
			RemoveAlphaChannels();
			// if ( DocumentMode.RGB != app.activeDocument.mode ) {
			//	ConditionalModeChangeToRGB();
			//}
			ConvertToProfile( this.params["converticc1"] );
			if ( this.params["fileresize1"] ) {
			    var r = ResolutionInPixelsPerInch( this.params["filer1"], this.params["fileru1"] )
			    if ( r == 0 || isNaN( r ) ) {
			        r = app.activeDocument.resolution;
			    }
			    if ( app.activeDocument.resolution != r ) {
			        app.activeDocument.resizeImage( undefined, undefined, r, ResampleMethod.NONE );
			    }
			    var w = Number( this.params["filew1"] );
			    var h = Number( this.params["fileh1"] );
			    if ( w == 0 || isNaN( w ) ) {
			        w = h;
			    }
			    if ( h == 0 || isNaN( h ) ) {
			        h = w;
			    }    
                w = UnitsToPixels( w, this.params["filewu1"], r, app.activeDocument.width.as( 'px' ) );
                h = UnitsToPixels( h, this.params["filehu1"], r, app.activeDocument.height.as( 'px' ) );
				FitImage( w, h, this.params["interpolate1"] ); 
			}
			if ( this.params["runaction1"] && this.params["whenaction1"] == "After Image Resize" ) {
				app.doAction( this.params["action1"], this.params["actionset1"] );
			}
			if ( this.params["file1"] == "JPEG" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".jpg" );
				SaveAsJPEG( uniqueFileName, this.params["q1"], this.params["crazy1"], this.params["converticc1"] != "Untagged RGB" );
			} else if ( this.params["file1"] == "PNG" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".png" );
				SaveAsPNG( uniqueFileName, this.params["lace1"], this.params["sfw1"] );
			} else if ( this.params["file1"] == "TIFF" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".tif" );
				SaveAsTIFF( uniqueFileName, this.params["converticc1"] != "Untagged RGB" , this.params["lzw1"] );
			} else if ( this.params["file1"] == "PSD" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".psd" );
				SaveAsPSD( uniqueFileName, this.params["max1"], this.params["converticc1"] != "Untagged RGB"  );
			} else if ( this.params["file1"] == "GIF" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".gif" );
				SaveAsGIForJPEG( uniqueFileName, "GIFf", this.params["converticc1"] != "Untagged RGB", this.params["c1"] );
 			}
			app.activeDocument.activeHistoryState = historyState;
		}
		
		if ( this.params["outfile2"] ) {
		    var subFolderText = inFolderLocation + "/";
		    if ( this.params["makefolders"] ) {
		        subFolderText = subFolderText + this.params["folder2"] + "/";
		    }
			if ( ! this.runningFromBridge && this.params["keepstructure"] && ! this.params["saveinsame"] ) {
				subFolderText = activeDocument.path.fsName.toString();
				subFolderText = subFolderText.replace( this.params["source"], this.params["dest"] );
				subFolderText += "/";
			}
			Folder( subFolderText ).create();
			var historyState = app.activeDocument.activeHistoryState;
			if ( this.params["runaction2"] && this.params["whenaction2"] == "Before Image Resize" ) {
				app.doAction( this.params["action2"], this.params["actionset2"] );
			}
			if ( ( this.params["file2"] == "TIFF" && this.params["flattenTIFF2"] ) ||
			     ( this.params["file2"] == "PSD" && this.params["flattenPSD2"] ) || 
				 this.params["file2"] == "JPEG" ||
				 this.params["file2"] == "GIF" ) {
				app.activeDocument.flatten();
			}
			if ( this.params["file2"] == "JPEG" || this.params["file2"] == "GIF" || this.params["file2"] == "PNG"  ) { 
				app.activeDocument.bitsPerChannel = BitsPerChannelType.EIGHT;
			}
			RemoveAlphaChannels();
			// if ( DocumentMode.RGB != app.activeDocument.mode ) {
			//	ConditionalModeChangeToRGB();
			// }
			ConvertToProfile( this.params["converticc2"] );
			if ( this.params["fileresize2"] ) {
			    var r = ResolutionInPixelsPerInch( this.params["filer2"], this.params["fileru2"] )
			    if ( r == 0 || isNaN( r ) ) {
			        r = app.activeDocument.resolution;
			    }
			    if ( app.activeDocument.resolution != r ) {
			        app.activeDocument.resizeImage( undefined, undefined, r, ResampleMethod.NONE );
			    }
			    var w = Number( this.params["filew2"] );
			    var h = Number( this.params["fileh2"] );
			    if ( w == 0 || isNaN( w ) ) {
			        w = h;
			    }
			    if ( h == 0 || isNaN( h ) ) {
			        h = w;
			    }    
                w = UnitsToPixels( w, this.params["filewu2"], r, app.activeDocument.width.as( 'px' ) );
                h = UnitsToPixels( h, this.params["filehu2"], r, app.activeDocument.height.as( 'px' ) );
				FitImage( w, h, this.params["interpolate2"]  ); 
			}
			if ( this.params["runaction2"] && this.params["whenaction2"] == "After Image Resize" ) {
				app.doAction( this.params["action2"], this.params["actionset2"] );
			}
			if ( this.params["file2"] == "JPEG" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".jpg" );
				SaveAsJPEG( uniqueFileName, this.params["q2"], this.params["crazy2"], this.params["converticc2"] != "Untagged RGB" );
			} else if ( this.params["file2"] == "PNG" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".png" );
				SaveAsPNG( uniqueFileName, this.params["lace2"], this.params["sfw2"] );
			} else if ( this.params["file2"] == "TIFF" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".tif" );
				SaveAsTIFF( uniqueFileName, this.params["converticc2"] != "Untagged RGB" , this.params["lzw2"] );
			} else if ( this.params["file2"] == "PSD" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".psd" );
				SaveAsPSD( uniqueFileName, this.params["max2"], this.params["converticc2"] != "Untagged RGB"  );
			} else if ( this.params["file2"] == "GIF" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".gif" );
				SaveAsGIForJPEG( uniqueFileName, "GIFf", this.params["converticc2"] != "Untagged RGB", this.params["c2"] );
 			}
			app.activeDocument.activeHistoryState = historyState;
		}
		
		if ( this.params["outfile3"] ) {
		    var subFolderText = inFolderLocation + "/";
		    if ( this.params["makefolders"] ) {
		        subFolderText = subFolderText + this.params["folder3"] + "/";
		    }
			if ( ! this.runningFromBridge && this.params["keepstructure"] && ! this.params["saveinsame"] ) {
				subFolderText = activeDocument.path.fsName.toString();
				subFolderText = subFolderText.replace( this.params["source"], this.params["dest"] );
				subFolderText += "/";
			}
			Folder( subFolderText ).create();
			var historyState = app.activeDocument.activeHistoryState;
			if ( this.params["runaction3"] && this.params["whenaction3"] == "Before Image Resize" ) {
				app.doAction( this.params["action3"], this.params["actionset3"] );
			}
			if ( ( this.params["file3"] == "TIFF" && this.params["flattenTIFF3"] ) ||
			     ( this.params["file3"] == "PSD" && this.params["flattenPSD3"] ) || 
				 this.params["file3"] == "JPEG" ||
				 this.params["file3"] == "GIF" ) {
				app.activeDocument.flatten();
			}
			if ( this.params["file3"] == "JPEG" || this.params["file3"] == "GIF" || this.params["file3"] == "PNG"  ) { 
				app.activeDocument.bitsPerChannel = BitsPerChannelType.EIGHT;
			}
			RemoveAlphaChannels();
			// if ( DocumentMode.RGB != app.activeDocument.mode ) {
			//	ConditionalModeChangeToRGB();
			// }
			ConvertToProfile( this.params["converticc3"] );
			if ( this.params["fileresize3"] ) {
			    var r = ResolutionInPixelsPerInch( this.params["filer3"], this.params["fileru3"] )
			    if ( r == 0 || isNaN( r ) ) {
			        r = app.activeDocument.resolution;
			    }
			    if ( app.activeDocument.resolution != r ) {
			        app.activeDocument.resizeImage( undefined, undefined, r, ResampleMethod.NONE );
			    }
			    var w = Number( this.params["filew3"] );
			    var h = Number( this.params["fileh3"] );
			    if ( w == 0 || isNaN( w ) ) {
			        w = h;
			    }
			    if ( h == 0 || isNaN( h ) ) {
			        h = w;
			    }    
                w = UnitsToPixels( w, this.params["filewu3"], r, app.activeDocument.width.as( 'px' ) );
                h = UnitsToPixels( h, this.params["filehu3"], r, app.activeDocument.height.as( 'px' ) );
				FitImage( w, h, this.params["interpolate3"]  ); 
			}
			if ( this.params["runaction3"] && this.params["whenaction3"] == "After Image Resize" ) {
				app.doAction( this.params["action3"], this.params["actionset3"] );
			}
			if ( this.params["file3"] == "JPEG" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".jpg" );
				SaveAsJPEG( uniqueFileName, this.params["q3"], this.params["crazy3"], this.params["converticc3"] != "Untagged RGB" );
			} else if ( this.params["file3"] == "PNG" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".png" );
				SaveAsPNG( uniqueFileName, this.params["lace3"], this.params["sfw3"] );
			} else if ( this.params["file3"] == "TIFF" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".tif" );
				SaveAsTIFF( uniqueFileName, this.params["converticc3"] != "Untagged RGB" , this.params["lzw3"] );
			} else if ( this.params["file3"] == "PSD" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".psd" );
				SaveAsPSD( uniqueFileName, this.params["max3"], this.params["converticc3"] != "Untagged RGB"  );
			} else if ( this.params["file3"] == "GIF" ) { 
				var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".gif" );
				SaveAsGIForJPEG( uniqueFileName, "GIFf", this.params["converticc3"] != "Untagged RGB", this.params["c3"] );
 			}
			app.activeDocument.activeHistoryState = historyState;
		}
	}
		
	///////////////////////////////////////////////////////////////////////////////
	// Function: OpenCameraRaw
	// Usage: open a camera raw file returning the camera raw action desc
	// Input: <none>
	// Return: <none>
	///////////////////////////////////////////////////////////////////////////////
	this.OpenCameraRaw = function( inOutCameraRawParams, updateCRDesc, inDialogMode ) {
		var keyNull = charIDToTypeID( 'null' );
		var keyAs = charIDToTypeID( 'As  ' );
		var adobeCameraRawID = stringIDToTypeID( "Adobe Camera Raw" );
		var desc = new ActionDescriptor();
		desc.putPath( keyNull, File( inOutCameraRawParams.fileName ) );
		if ( inOutCameraRawParams.desc != undefined && inOutCameraRawParams.useDescriptor &&
		     IsFileOneOfThese( inOutCameraRawParams.fileName, gFilesForCameraRaw ) ) {
			desc.putObject( keyAs, adobeCameraRawID, inOutCameraRawParams.desc );
		}
		if ( inDialogMode == undefined ) {
			inDialogMode = DialogModes.ALL;
		}
		var returnDesc = executeAction( charIDToTypeID( 'Opn ' ), desc, inDialogMode );
		if ( returnDesc.hasKey( keyAs ) ) {
			if (updateCRDesc)
				inOutCameraRawParams.desc = returnDesc.getObjectValue( keyAs, adobeCameraRawID );
			if ( returnDesc.hasKey( keyNull ) ) {
				inOutCameraRawParams.fileName = returnDesc.getPath( keyNull ).toString();
				desc = null;
				$.gc();
				return true;
			}
		}
		desc = null;
		$.gc();
		return false;
	}
	
	// given a folder return the first valid file in that folder
	this.GetFirstFile = function ( inFolder ) {
		if ( inFolder.length > 0 && inFolder[0] != '.' ) {
			var fileList = Folder( inFolder ).getFiles();
			for ( var i = 0; i < fileList.length; i++) {
				if ( fileList[i] instanceof File && ! fileList[i].hidden && ! IsFileOneOfThese( fileList[i], gFilesToSkip ) ) {
					return fileList[i].toString();
				}
			}
		}
		return "";
	}
	
	///////////////////////////////////////////////////////////////////////////
	// Function: ConfigForBridge
	// Usage: see if the Bridge app is running this script
	// Input: gFilesFromBridge is a variable that is defined in photoshop.jsx
	// Return: runningFromBridge and filesFromBridge are initialized
	///////////////////////////////////////////////////////////////////////////
	this.ConfigForBridge = function() {
		if ( typeof( gFilesFromBridge ) == "undefined" ) {
			this.runningFromBridge = false;
			this.filesFromBridge = undefined;
		} else {
			this.filesFromBridge = gFilesFromBridge;
			if ( this.filesFromBridge.length > 0 ) {
				this.runningFromBridge = true;
			} else {
				this.runningFromBridge = false;
			}
		}
	}

	///////////////////////////////////////////////////////////////////////////
	// Function: ReportErrors
	// Usage: pop the name of the files we had trouble with
	// Input:
	// Return:
	///////////////////////////////////////////////////////////////////////////
	this.ReportErrors = function() {
		if ( this.fileErrors.length ) {
			var message = strCouldNotProcess;
			for ( var i = 0; i < this.fileErrors.length; i++ ) {
				message += "\r" + File( this.fileErrors[i] ).fsName + "\r";
			}
			alert( message );
		}
	}

	// initialize properties

	this.fileErrors = new Array();

	this.params = this.InitParams();

	this.actionInfo = GetActionSetInfo();
	
	this.ConfigForBridge();
	
}


///////////////////////////////////////////////////////////////////////////////
// Function: SaveAsJPEG
// Usage:
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function SaveAsJPEG( inFileName, inQuality, inCrazySmall, inEmbedICC ) {
	if ( inCrazySmall ) {
		SaveAsGIForJPEG( inFileName, "JPEG", inEmbedICC, inQuality );
	} else {
		var jpegOptions = new JPEGSaveOptions();
		jpegOptions.quality = inQuality;
		jpegOptions.embedColorProfile = inEmbedICC;
		app.activeDocument.saveAs( File( inFileName ), jpegOptions );
	}
}


///////////////////////////////////////////////////////////////////////////////
// Function: SaveAsPNG
// Usage:
// Input: inFileName:String-full path to file, inLaced:Boolean,
//             inSFW:Boolean
// Return:
///////////////////////////////////////////////////////////////////////////////
function SaveAsPNG( inFileName, inLaced, inSFW ){
	if ( inSFW) {
		sfwPNG( inFileName, inLaced );
	} else {
		pngSaveOptions = new PNGSaveOptions(); 
		pngSaveOptions.interlaced = inLaced;
		app.activeDocument.saveAs( File( inFileName ), pngSaveOptions ); 
	}
}


///////////////////////////////////////////////////////////////////////////////
// Function: sfwPNG
// Usage:
// Input: inFileName:String-full path to file, inLaced:Boolean
// Return:
///////////////////////////////////////////////////////////////////////////////
function sfwPNG( inFileName, inLaced ){	
	var sfwOptns = new ExportOptionsSaveForWeb();
	sfwOptns.format = SaveDocumentType.PNG;
	sfwOptns.PNG8 = false;
	sfwOptns.transparency = true;
	sfwOptns.interlaced = inLaced;
	var inFile = new File( inFileName );
	if( inFile.exists ) inFile.remove();
	app.activeDocument.exportDocument( inFile, ExportType.SAVEFORWEB, sfwOptns );
}


///////////////////////////////////////////////////////////////////////////////
// Function: SaveAsPSD
// Usage:
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function SaveAsPSD( inFileName, inMaximizeCompatibility, inEmbedICC ) {
    var rememberMaximize;
    var needMaximize = inMaximizeCompatibility ? QueryStateType.ALWAYS : QueryStateType.NEVER;
    if ( app.preferences.maximizeCompatibility != needMaximize ) {
        rememberMaximize = app.preferences.maximizeCompatibility;
        app.preferences.maximizeCompatibility = needMaximize;
    }
	var psdSaveOptions = new PhotoshopSaveOptions();
    psdSaveOptions.embedColorProfile = inEmbedICC;
	app.activeDocument.saveAs( File( inFileName ), psdSaveOptions );
	if ( rememberMaximize != undefined ) {
        app.preferences.maximizeCompatibility = rememberMaximize;
    }
}
	
///////////////////////////////////////////////////////////////////////////////
// Function: SaveAsTIFF
// Usage:
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function SaveAsTIFF( inFileName, inEmbedICC, inLZW ) {
	var tiffSaveOptions = new TiffSaveOptions();
    tiffSaveOptions.embedColorProfile = inEmbedICC;
    if ( inLZW ) {
		tiffSaveOptions.imageCompression = TIFFEncoding.TIFFLZW;
	} else {
		tiffSaveOptions.imageCompression = TIFFEncoding.NONE;
	}	
	app.activeDocument.saveAs( File( inFileName ), tiffSaveOptions );
}

///////////////////////////////////////////////////////////////////////////////
// Function: SaveAsGIForJPEG
// Usage: Safe a GIF or JPEG file via Save For Web, makes them really small
// Input: file, format, options for each format 'GIFf' "colors" or 'JPEG' "quality"
// Return:
///////////////////////////////////////////////////////////////////////////////
function SaveAsGIForJPEG( inFileName, inFormat, includeICC, inColorsOrQuality ) {
	try {
	var id124 = charIDToTypeID( "Expr" );
    var desc24 = new ActionDescriptor();
    var id125 = charIDToTypeID( "Usng" );
    var desc25 = new ActionDescriptor();
    var id126 = charIDToTypeID( "Op  " );
    var id127 = charIDToTypeID( "SWOp" );
    var id128 = charIDToTypeID( "OpSa" );
    desc25.putEnumerated( id126, id127, id128 );
    var id129 = charIDToTypeID( "Fmt " );
    var id130 = charIDToTypeID( "IRFm" );
    var id131 = charIDToTypeID( inFormat ); // "GIFf" or "JPEG" goes here
    desc25.putEnumerated( id129, id130, id131 );
    var id132 = charIDToTypeID( "Intr" );
    desc25.putBoolean( id132, inFormat == "GIFf" ); // true for GIFf false for JPEG
	
	if ( inFormat == "GIFf" ) { // only for GIF
		var id133 = charIDToTypeID( "RedA" );
		var id134 = charIDToTypeID( "IRRd" );
		var id135 = charIDToTypeID( "Sltv" );
		desc25.putEnumerated( id133, id134, id135 );
		var id136 = charIDToTypeID( "RChT" );
		desc25.putBoolean( id136, false );
		var id137 = charIDToTypeID( "RChV" );
		desc25.putBoolean( id137, false );
		var id138 = charIDToTypeID( "AuRd" );
		desc25.putBoolean( id138, false );
		var id139 = charIDToTypeID( "NCol" ); // this is the number of colors
		desc25.putInteger( id139, inColorsOrQuality );
		var id140 = charIDToTypeID( "Dthr" );
		var id141 = charIDToTypeID( "IRDt" );
		var id142 = charIDToTypeID( "None" );
		desc25.putEnumerated( id140, id141, id142 );
		var id143 = charIDToTypeID( "DthA" );
		desc25.putInteger( id143, 100 );
		var id144 = charIDToTypeID( "DChS" );
		desc25.putInteger( id144, 0 );
		var id145 = charIDToTypeID( "DCUI" );
		desc25.putInteger( id145, 0 );
		var id146 = charIDToTypeID( "DChT" );
		desc25.putBoolean( id146, false );
		var id147 = charIDToTypeID( "DChV" );
		desc25.putBoolean( id147, false );
		var id148 = charIDToTypeID( "WebS" );
		desc25.putInteger( id148, 0 );
		var id149 = charIDToTypeID( "TDth" );
		var id150 = charIDToTypeID( "IRDt" );
		var id151 = charIDToTypeID( "None" );
		desc25.putEnumerated( id149, id150, id151 );
		var id152 = charIDToTypeID( "TDtA" );
		desc25.putInteger( id152, 100 );
		var id153 = charIDToTypeID( "Loss" );
		desc25.putInteger( id153, 0 );
		var id154 = charIDToTypeID( "LChS" );
		desc25.putInteger( id154, 0 );
		var id155 = charIDToTypeID( "LCUI" );
		desc25.putInteger( id155, 100 );
		var id156 = charIDToTypeID( "LChT" );
		desc25.putBoolean( id156, false );
		var id157 = charIDToTypeID( "LChV" );
		desc25.putBoolean( id157, false );
		var id158 = charIDToTypeID( "Trns" );
		desc25.putBoolean( id158, true );
	} else { // only for JPEG
        var id75 = charIDToTypeID( "Qlty" );
        desc25.putInteger( id75, Math.round( inColorsOrQuality / 12 * 100 ) ); // we use the photoshop 0 to 12, this thing uses 0 to 100
        var id76 = charIDToTypeID( "QChS" );
        desc25.putInteger( id76, 0 );
        var id77 = charIDToTypeID( "QCUI" );
        desc25.putInteger( id77, 0 );
        var id78 = charIDToTypeID( "QChT" );
        desc25.putBoolean( id78, false );
        var id79 = charIDToTypeID( "QChV" );
        desc25.putBoolean( id79, false );
        var id80 = charIDToTypeID( "Optm" );
        desc25.putBoolean( id80, true );
        var id81 = charIDToTypeID( "Pass" );
        desc25.putInteger( id81, 1 );
        var id82 = charIDToTypeID( "blur" );
        desc25.putDouble( id82, 0.000000 );
        var id83 = charIDToTypeID( "EICC" );
        desc25.putBoolean( id83, includeICC );
	} // end only for GIF or JPEG

	var id159 = charIDToTypeID( "Mtt " );
	desc25.putBoolean( id159, true );
	var id160 = charIDToTypeID( "MttR" );
	desc25.putInteger( id160, 255 );
	var id161 = charIDToTypeID( "MttG" );
	desc25.putInteger( id161, 255 );
	var id162 = charIDToTypeID( "MttB" );
	desc25.putInteger( id162, 255 );
	var id163 = charIDToTypeID( "SHTM" );
	desc25.putBoolean( id163, false );
	var id164 = charIDToTypeID( "SImg" );
	desc25.putBoolean( id164, true );
	var id165 = charIDToTypeID( "SSSO" );
	desc25.putBoolean( id165, false );
	var id166 = charIDToTypeID( "SSLt" );
	var list3 = new ActionList();
	desc25.putList( id166, list3 );
	var id167 = charIDToTypeID( "DIDr" );
	desc25.putBoolean( id167, false );
	var id168 = charIDToTypeID( "In  " );
	desc25.putPath( id168, new File( inFileName ) ); // here goes the file name
	var id169 = stringIDToTypeID( "SaveForWeb" );
	desc24.putObject( id125, id169, desc25 );
	executeAction( id124, desc24, DialogModes.NO );
	} catch(e) { alert("Save problems: " + e + ":" + e.line); }
}

///////////////////////////////////////////////////////////////////////////////
// Function: FitImage
// Usage: copied and modified from FitImage.jsx
// Input: width height and interpolation method
// Return:
///////////////////////////////////////////////////////////////////////////////
function FitImage( inWidth, inHeight, inInterpolation ) {
	
	if ( inWidth == undefined || inHeight == undefined ) {
		alert( strWidthAndHeight );
		return;
	}

	var oldPref = app.preferences.rulerUnits;	
	var docWidth;
	var docHeight;
	var docRatio;
	var newWidth;
	var newHeight;
	var resolution = app.activeDocument.resolution;
	
    app.preferences.rulerUnits = Units.PIXELS; // save old preferences

	// original width, height
	docWidth = (1.0 * app.activeDocument.width * resolution) / 72.0; // decimal inches assuming 72 dpi (used in docRatio)
	docHeight = (1.0 * app.activeDocument.height * resolution) / 72.0; // ditto
	
	if (docWidth < 1.0 || docHeight < 1.0)
		return true; // error
	
	if (inWidth < 1 || inHeight < 1)
		return true; // error
	
	docRatio = docWidth / docHeight; // decimal ratio of original width/height
	
	// NOTE - ccox - 17 Aug 2004 - I added the rounding by 0.5
	// this should solve reported cases of fit image being off by 1 (always under)
	// NOTE - elr - 3 May 2006 - keep original aspect ratio
	// NOTE - mshaw- 16 Sept 2007 commenting out lines and adding lines to match fixed FitImage script
	newWidth = inWidth;
	/*newHeight = ((1.0 * inWidth) / docRatio) + 0.5; // decimal calc
	newHeight = 1 * newHeight; // make integer*/
	newHeight = ((1.0 * inWidth) / docRatio); // decimal calc

	
	if (newHeight > inHeight) {
		/*newWidth = 0.5 + docRatio * inHeight; // decimal calc
		newWidth = 1 * newWidth; // make integer*/
		newWidth = docRatio * inHeight; // decimal calc
		newHeight = inHeight;
	}
	
	if ( typeof( inInterpolation ) == "string" ) {
		var interpoArray = { NearestNeighbor:ResampleMethod.NEARESTNEIGHBOR, Bilinear:ResampleMethod.BILINEAR, Bicubic:ResampleMethod.BICUBIC, BicubicSmoother:ResampleMethod.BICUBICSMOOTHER, BicubicSharper:ResampleMethod.BICUBICSHARPER };
		var lookupstring = inInterpolation.replace(" ", "");
		inInterpolation = interpoArray[ lookupstring ];
	}

    // resize the image using a good conversion method while keeping the pixel resolution
    // and the aspect ratio the same
    app.activeDocument.resizeImage(newWidth, newHeight, resolution, inInterpolation);
    app.preferences.rulerUnits = oldPref; // restore old prefs

	return false; // no error
}

///////////////////////////////////////////////////////////////////////////////
// Function: ReadHeader
// Usage: a very crude xml parser, this reads the "Tag" of the <Tag>Data</Tag>
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function ReadHeader( inFile ) {
	var returnValue = "";
	if ( ! inFile.eof ) {
		var c = "";
		while ( c != "<" && ! inFile.eof ) {
			c = inFile.read( 1 );
		}
		while ( c != ">" && ! inFile.eof ) {
			c = inFile.read( 1 );
			if ( c != ">" ) {
				returnValue += c;
			}
		}
	} else {
		returnValue = "end of file";
	}
	return returnValue;
}

///////////////////////////////////////////////////////////////////////////////
// Function: ReadData
// Usage: very crude xml parser, this reads the "Data" of the <Tag>Data</Tag>
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function ReadData( inFile ) {
	var returnValue = "";
	if ( ! inFile.eof ) {
		var c = "";
		while ( c != "<" && ! inFile.eof ) {
			c = inFile.read( 1 );
			if ( c != "<" ) {
				returnValue += c;
			}
		}
		inFile.seek( -1, 1 );
	}
	return returnValue;
}

///////////////////////////////////////////////////////////////////////////////
// Function: CheckVersion
// Usage:
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function CheckVersion() {
	var numberArray = version.split(".");
	if ( numberArray[0] < 9 ) {
		alert( strMustUse );
		throw( strMustUse );
	}
}

///////////////////////////////////////////////////////////////////////////////
// Function: CreateUniqueFileName
// Usage:
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function CreateUniqueFileName( inFolder, inFileName, inExtension ) {
	inFileName = inFileName.replace(/[:\/\\*\?\"\<\>\|]/g, "_");  // '/\:*?"<>|' -> '_'
	var uniqueFileName = inFolder + inFileName + inExtension;
	var fileNumber = 1;
	while ( File( uniqueFileName ).exists ) {
		uniqueFileName = inFolder + inFileName + "_" + fileNumber + inExtension;
		fileNumber++;
	}
	return uniqueFileName;
}

///////////////////////////////////////////////////////////////////////////////
// Function: CreateShortFileName
// Usage:
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function CreateShortFileName( inFileName ) {
	if ( inFileName.length > gShortFileNameLength ) {
		return "..." + inFileName.substr( inFileName.length - gShortFileNameLength + 3, gShortFileNameLength - 3 );
	}
	return inFileName;
}

///////////////////////////////////////////////////////////////////////////////
// Function: IsWindowsOS
// Usage:
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function IsWindowsOS() {
	if ( $.os.search(/windows/i) != -1 ) {
		return true;
	} else {
		return false;
	}
}

///////////////////////////////////////////////////////////////////////////////
// Function: RemoveAlphaChannels
// Usage:
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function RemoveAlphaChannels() {
	var channels = app.activeDocument.channels;
	var channelCount = channels.length - 1;
	while ( channels[channelCount].kind != ChannelType.COMPONENT ) {
		channels[channelCount].remove();
		channelCount--;
	}
}

///////////////////////////////////////////////////////////////////////////////
// Function: ConvertToProfile
// Usage: convert to given profile
// Input: profile name as string
// Return: <none> active document converted to profile
///////////////////////////////////////////////////////////////////////////////
function ConvertToProfile( inProfile ) {
	if ( 'Untagged RGB' == inProfile || 'Same as Source' == inProfile ) {
		return;
	}
	try {
		app.activeDocument.convertProfile( inProfile, Intent.RELATIVECOLORIMETRIC, true, true );
	}
	catch(e) {
		// do nothing, if you convert to "Working RGB" and working rgb is the same as the current profile
		// you will get an error, this will catch the error and continue on
	}
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetScriptNameForXML
// Usage: you can't save certain characters in xml, strip them here this list 
//        is not complete
// Input: <none> some ugly globals here!
// Return: Name I can use for valid XML tag
///////////////////////////////////////////////////////////////////////////////
function GetScriptNameForXML () {
	var scriptNameForXML = new String( gStrTitle );
	var charsToStrip = Array( " ", "'", "." );
	for (var a = 0; a < charsToStrip.length; a++ )  {
		var nameArray = scriptNameForXML.split( charsToStrip[a] );
		scriptNameForXML = "";
		for ( var b = 0; b < nameArray.length; b++ ) {
			scriptNameForXML += nameArray[b];
		}
	}
	return scriptNameForXML;
}


/////////////////////////////////////////////////////////////////////
// Function: MacXMLFilter
// Input: f, file or folder to check
// Return: true or false, true if file or folder is to be displayed
/////////////////////////////////////////////////////////////////////
function MacXMLFilter( f )
{
	var xmlExtension = ".xml";
	var lCaseName = f.name;
	lCaseName.toLowerCase();
	if ( lCaseName.indexOf( xmlExtension ) == f.name.length - xmlExtension.length )
		return true;
	else if ( f.type == 'TEXT' )
		return true;
	else if ( f instanceof Folder )
		return true;
	else
		return false;
}

///////////////////////////////////////////////////////////////////////////////
// Function: GetDefaultParamsFile
// Usage: figure out what I call my params file
// Input: <none> global gStrTitle Ugh!
// Return: File to save my params to
///////////////////////////////////////////////////////////////////////////////
function GetDefaultParamsFile() {
	return ( new File( app.preferencesFolder + "/" + gStrTitle + ".xml" ) );
}

///////////////////////////////////////////////////////////////////////////////
// Function: FindDialog
// Usage: move up the from the given item to find the parent 'dialog'
// Input: a widget on a dialog
// Return: the first 'dialog' object
///////////////////////////////////////////////////////////////////////////////
function FindDialog( inItem ) {
	var w = inItem;
	while ( 'dialog' != w.type ) {
		if ( undefined == w.parent ) {
			w = null;
			break;
		}
		w = w.parent;
	}
	return w;
}

///////////////////////////////////////////////////////////////////////////////
// Function: GetFilesFromBridge
// Usage: Use this to retrieve the current files from the Bridge application
//        I don't use it as I run differently only when called from the Bridge
//        see photoshop.jsx
// Input: <none>
// Return: array of files from the current active bridge window
///////////////////////////////////////////////////////////////////////////////
function GetFilesFromBridge() {
	var fileList;
	if ( BridgeTalk.isRunning( "bridge" ) ) {
		var bt = new BridgeTalk();
		bt.target = "bridge";
		bt.body = "var theFiles = photoshop.getBridgeFileListForAutomateCommand();theFiles.toSource();";
		bt.onResult = function( inBT ) { fileList = eval( inBT.body ); }
		bt.onError = function( inBT ) { fileList = new Array(); }
		bt.send();
		bt.pump();
		$.sleep( 100 );
		var timeOutAt = ( new Date() ).getTime() + 5000;
		var currentTime = ( new Date() ).getTime();
		while ( ( currentTime < timeOutAt ) && ( undefined == fileList ) ) {
			bt.pump();
			$.sleep( 100 );
			currentTime = ( new Date() ).getTime();
		}
	}
	if ( undefined == fileList ) {
		fileList = new Array();
	}
	return fileList; 
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetActionSetInfo
// Usage: walk all the items in the action palette and record the action set
//        names and all the action children
// Input: <none>
// Return: the array of all the ActionData
// Note: This will throw an error during a normal execution. There is a bug
// in Photoshop that makes it impossible to get an acurate count of the number
// of action sets.
///////////////////////////////////////////////////////////////////////////////
function GetActionSetInfo() {
	var actionSetInfo = new Array();
	var setCounter = 1;
  	while ( true ) {
		var ref = new ActionReference();
		ref.putIndex( gClassActionSet, setCounter );
		var desc = undefined;
		try { desc = executeActionGet( ref ); }
		catch( e ) { break; }
		var actionData = new ActionData();
		if ( desc.hasKey( gKeyName ) ) {
			actionData.name = desc.getString( gKeyName );
		}
		var numberChildren = 0;
		if ( desc.hasKey( gKeyNumberOfChildren ) ) {
			numberChildren = desc.getInteger( gKeyNumberOfChildren );
		}
		if ( numberChildren ) {
			actionData.children = GetActionInfo( setCounter, numberChildren );
			actionSetInfo.push( actionData );
		}
		setCounter++;
	}
	ref = null;
	$.gc();
	return actionSetInfo;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetActionInfo
// Usage: used when walking through all the actions in the action set
// Input: action set index, number of actions in this action set
// Return: true or false, true if file or folder is to be displayed
///////////////////////////////////////////////////////////////////////////////
function GetActionInfo( setIndex, numChildren ) {
	var actionInfo = new Array();
	for ( var i = 1; i <= numChildren; i++ ) {
		var ref = new ActionReference();
		ref.putIndex( gClassAction, i );
		ref.putIndex( gClassActionSet, setIndex );
		var desc = undefined;
		desc = executeActionGet( ref );
		var actionData = new ActionData();
		if ( desc.hasKey( gKeyName ) ) {
			actionData.name = desc.getString( gKeyName );
		}
		var numberChildren = 0;
		if ( desc.hasKey( gKeyNumberOfChildren ) ) {
			numberChildren = desc.getInteger( gKeyNumberOfChildren );
		}
		actionInfo.push( actionData );
		ref = null;
	}
	$.gc();
	return actionInfo;
}


///////////////////////////////////////////////////////////////////////////////
// Function: ActionData
// Usage: this could be an action set or an action
// Input: <none>
// Return: a new Object of ActionData
///////////////////////////////////////////////////////////////////////////////
function ActionData() {
	this.name = "";
	this.children = undefined;
	this.toString = function () {
		var strTemp = this.name;
		if ( undefined != this.children ) {
			for ( var i = 0; i < this.children.length; i++ ) {
				strTemp += " " + this.children[i].toString();
			}
		}
		return strTemp;
	}
}

///////////////////////////////////////////////////////////////////////////////
// Function: OpenDocs
// Usage: we want the current open documents that have a path if I do 
//        inputFiles = documents then I have a reference and if I add documents
//        it also adds them to my inputFiles I want to copy the current state
// Input: <none>
// Return: array of the current open docs with file references
///////////////////////////////////////////////////////////////////////////////
function OpenDocs() {
	var docs = new Array();
	var i = 0;
	var docIndex = 0;
	var alertNonSavedDocs = false;
	var nonSavedDocs = new Array();
	for ( var i = 0; i < app.documents.length; i++ ) {
		try {
			var temp = app.documents[ i ].fullName;
			docs[ docIndex ] = app.documents[ i ];
			docIndex++;
		}
		catch( e ) {
			if ( e.number == 8103 ) { // this document has not been saved
				alertNonSavedDocs = true;
				nonSavedDocs.push( app.documents[ i ].name );
			} else {
				throw e;
			}
		}
	}
	if ( alertNonSavedDocs ) {
		alert( strMustSaveOpen + "\r" + strFollowing + "\r( " + nonSavedDocs + " )" );
	}
	return docs;
}

///////////////////////////////////////////////////////////////////////////////
// Function: ConditionalModeChangeToRGB
// Usage: use the conditional mode change automation plug-in to convert to RGB
// Input: <none> an active document must be opened
// Return: active document is now in RGB mode
///////////////////////////////////////////////////////////////////////////////
function ConditionalModeChangeToRGB() {
	var eventModeChange = stringIDToTypeID( "8cba8cd6-cb66-11d1-bc43-0060b0a13dc4" );
	var descSource = new ActionDescriptor();
	var keySourceMode = charIDToTypeID( "SrcM" );
	var list = new ActionList();
	var keyCondition = charIDToTypeID( "Cndn" );
	var keyBitmap = charIDToTypeID( "UBtm" );
	var keyGrayscale = charIDToTypeID( "UGry" );
	var keyDuotone = charIDToTypeID( "UDtn" );
	var keyIndex = charIDToTypeID( "UInd" );
	var keyRGB = charIDToTypeID( "URGB" );
	var keyCMYK = charIDToTypeID( "UCMY" );
	var keyLab = charIDToTypeID( "ULab" );
	var keyMultichannel = charIDToTypeID( "UMlt" );
	list.putEnumerated( keyCondition, keyBitmap );
	list.putEnumerated( keyCondition, keyGrayscale );
	list.putEnumerated( keyCondition, keyDuotone );
	list.putEnumerated( keyCondition, keyIndex );
	list.putEnumerated( keyCondition, keyRGB );
	list.putEnumerated( keyCondition, keyCMYK );
	list.putEnumerated( keyCondition, keyLab );
	list.putEnumerated( keyCondition, keyMultichannel );
	descSource.putList( keySourceMode, list );
	var keyDestination = charIDToTypeID( "DstM" );
	var descDest = new ActionDescriptor();
	var keyRGB = charIDToTypeID( "RGBM" );
	descSource.putObject( keyDestination, keyRGB, descDest );
	executeAction( eventModeChange, descSource, DialogModes.NO );
	descSource = null;
	list = null;
	$.gc();
}

///////////////////////////////////////////////////////////////////////////////
// Function: FlattenDialog
// Usage: Find all the items with a 'idString' property and give access to 
//        them at the top level this way I do not have to do 
//        w.grp.grp.grp.grp and I can simply do w.cbItem manage the group 
//        changes all the time
// Input: t is the object I am flattening to
//        w is the current object I am out
// Return: <none> the input t is modified see comments in usage
///////////////////////////////////////////////////////////////////////////////
function FlattenDialog( t, w ) {
    if ( w.type == 'dialog' || w.type == 'group' ) {
        for ( i in w ) {
            try {
	            if ( w[i] != undefined && ( w[i].type == 'dialog' || w[i].type == 'group' ) && i != 'parent' && i != 'window' && i != 'indent' ) {
	                FlattenDialog( t, w[i] );
	            } else {
	                if ( w[i] != undefined && w[i].properties != undefined && w[i].properties.idString != undefined ) {
	                    // turn this off when your done debugging your dialog code
	                    // if ( t[w[i].properties.idString] != undefined ) {
	                    //    alert('Already have a a ' + w[i].properties.idString + ' property.' ); 
	                    //}
	                    t[w[i].properties.idString] = w[i];
	                }
	            }
	        }
	        catch(e) {
		    alert( e + ":" + e.line );
		    throw( e );
	        } 
        }
    }
}

///////////////////////////////////////////////////////////////////////////////
// Function: UnitsToPixels
// Usage: convert a number in the given units to pixels
// Input: value in the current units
//        units of the value to convert
//        resolution needed for certain conversions
//        docValue needed for certain conversions
// Return: value in pixels 
///////////////////////////////////////////////////////////////////////////////
function UnitsToPixels( value, units, resolution, docValue ) {
    var n = Number( value );
    if ( units.search( "inches" ) != -1 ) {
        n = value * resolution;
        return n;
    }
    if ( units.search( "cm" ) != -1 ) {
        n = value / 2.54 * resolution;
        return n;
    }
    if ( units.search( "mm" ) != -1 ) {
        n = value / 25.4 * resolution;
        return n;
    }
    if ( units.search( "points" ) != -1 ) {
        n = value * resolution / 72.72;
        return n;
    }
    if ( units.search( "picas" ) != -1 ) {
        n = value * resolution / 72;
        return n;
    }
    if ( ( units.search( "percent" ) != -1 ) && ( docValue != undefined ) ) {
        n = value * docValue / 100.0;
        return n;
    }
    return n;
}

///////////////////////////////////////////////////////////////////////////////
// Function: PixelsToUnits
// Usage: convert a value in pixels to the given units
// Input: value to convert in pixels
//        units to convert to
//        resolution to use for certain conversions
//        docValue to use for certain conversions
// Return: converted value in the given units
///////////////////////////////////////////////////////////////////////////////
function PixelsToUnits( pixels, units, resolution, docValue ) {
    var n = Number( pixels );
    if ( units.search( "inches" ) != -1 ) {
        n = pixels / resolution;
        return n;
    }
    if ( units.search( "cm" ) != -1 ) {
        n = pixels * 2.54 / resolution;
        return n;
    }
    if ( units.search( "mm" ) != -1 ) {
        n = pixels * 25.4 / resolution;
        return n;
    }
    if ( units.search( "points" ) != -1 ) {
        n = pixels / resolution * 72.72;
        return n;
    }
    if ( units.search( "picas" ) != -1 ) {
        n = pixels / resolution * 72;
        return n;
    }
    if ( ( units.search( "percent" ) != -1 ) && ( docValue != undefined ) ) {
        n = pixels / docValue * 100.0;
        return n;
    }
    return n;
}

///////////////////////////////////////////////////////////////////////////////
// Function: UnitsToUnits
// Usage: Convert from one unit to another unit
// Input: value to convert
//        fromUnits is the units the value is in
//        toUnits the units the return value is in
//        resolution to use for certain converstions
//        docValue to use for certain conversions
// Return: converted value in units given by toUnits
///////////////////////////////////////////////////////////////////////////////
function UnitsToUnits( value, fromUnits, toUnits, resolution, docValue ) {
    var p = UnitsToPixels( value, fromUnits, resolution, docValue );
    p = PixelsToUnits( p, toUnits, resolution, docValue );
    return p;
}

///////////////////////////////////////////////////////////////////////////////
// Function: ResolutionInPixelsPerInch
// Usage: Pass in text for the resolution and the units 
//        (straight from the dropdowns and edit texts
// Input: resolution as a string
//        units as a string
// Return: number in pixels per inch
///////////////////////////////////////////////////////////////////////////////
function ResolutionInPixelsPerInch( resolution, units ) {
    var n = Number( resolution );
    if ( units.search( "inch" ) == -1 ) {
        n = n * 2.54;
	}
	return n;
}

///////////////////////////////////////////////////////////////////////////////
// Function: FindAllFiles
// Usage: Find all the files in the given folder recursively
// Input: srcFolder is a string to a folder
//		  destArray is an Array of File objects
// Return: Array of File objects, same as destArray
///////////////////////////////////////////////////////////////////////////////
function FindAllFiles( srcFolderStr, destArray ) {
	var fileFolderArray = Folder( srcFolderStr ).getFiles();

	for ( var i = 0; i < fileFolderArray.length; i++ ) {
		var fileFoldObj = fileFolderArray[i];
		if ( fileFoldObj instanceof File ) {
			destArray.push( fileFoldObj );
		} else { // folder
			FindAllFiles( fileFoldObj.toString(), destArray );
		}
	}

	return destArray;
}

// Dr. Brown's 1-2-3 Process.jsx
