// (c) Copyright 2008.  Adobe Systems, Incorporated.  All rights reserved.

/*
@@@BUILDINFO@@@ Dr. Brown's Services.jsx 2.0.4
*/

/*
@@@START_XML@@@
<?xml version="1.0" encoding="UTF-8"?>
<ScriptInfo xmlns:dc="http://purl.org/dc/elements/1.1/" xml:lang="en_US">
     <dc:title>Dr. Brown's Services</dc:title>
     <dc:description>This script enables a great set of tools from the one and only, Dr. Brown.</dc:description>
</ScriptInfo>
@@@END_XML@@@
*/

// written by Tom Ruark ( needs some major clean up )
// directed by Russell Preston Brown
// 03/02/2010 14:00

// debug level: 0-2 (0:disable, 1:break on error, 2:break at beginning)
// $.level = 0;
// debugger; // launch debugger on next line


//=================================================================
// Setup/Support
// This first portion of the script sets up an object to provide
// scope for all Dr. Brown BridgeTalk related routines to prevent
// name collision with other groups' scripts, defines some common
// utility functions, and adds some Dr. Brown related commands
// to the Bridge menus.
//=================================================================


try { // Overall try catch

	var drbrownserv = new Object;

	drbrownserv.version = "2.0.4";

	drbrownserv.menuItemInfoArray = new Array ();

	//-----------------------------------------------------------------
	// This routine sets the argument menu node to be enabled.
	//-----------------------------------------------------------------
	drbrownserv.alwaysEnabled = function () {
		this.enabled = true;
	}

	// some utility routines and properties

	// given a file name and a list of extensions
	// determine if this file is in the list of extensions
	drbrownserv.isFileOneOfThese = function ( inFileName, inArrayOfFileExtensions ) {
		var lastDot = inFileName.toString().lastIndexOf( "." );
		if ( lastDot == -1 ) {
			return false;
		}
		var strLength = inFileName.toString().length;
		var extension = inFileName.toString().substr( lastDot + 1, strLength - lastDot );
		extension = extension.toLowerCase();
		for (var i = 0; i < inArrayOfFileExtensions.length; i++ ) {
			if ( extension == inArrayOfFileExtensions[i] ) {
				return true;
			}
		}
		return false;
	}
	
	// fix it so we can save jpeg and cr files to jpeg without dialogs
	drbrownserv.saveFile = function( doc, jpegQ ) {
		if ( drbrownserv.isFileOneOfThese( doc.fullName, [ "jpg", "jpeg" ] ) ) {
			doc.saveAs( doc.fullName, jpegQ );
			doc.close(SaveOptions.DONOTSAVECHANGES);
		} else { 
			if ( drbrownserv.isFileOneOfThese( doc.fullName, drbrownserv.filesForCameraRaw ) ) {
				var fileToDelete = doc.fullName;
				
				// get the file without the path
				var strFileFullName = doc.fullName.toString();
				var lastDot = strFileFullName.lastIndexOf( "." );
				if ( lastDot == -1 ) {
					lastDot = strFileFullName.length;
				}
				var fullPathNoExtension = strFileFullName.substr( 0, lastDot );
				var newFile = File( fullPathNoExtension + ".jpg" );

				var newFileArray = drbrownserv.findNewHomeForFiles( [newFile], false, false, false, false); // files array, autoMode, makeFolder, bwMode, makeCopy

				doc.saveAs( newFileArray[ 0 ], jpegQ );
				doc.close(SaveOptions.DONOTSAVECHANGES);

				fileToDelete.remove(); 
			} else {
				doc.save();
				doc.close(SaveOptions.DONOTSAVECHANGES);
			}
		}
	}

	// ubber routine that should be broken up
	drbrownserv.findNewHomeForFiles = function( infiles, autoMode, makeFolder, bwMode, makeCopy ) {
		var outfiles = new Array();
		try {
			for (var i = 0; i < infiles.length; i++) {
				var destFolder = infiles[i].parent.toString();
				if (makeFolder) {
					if (bwMode) {
						destFolder += "/Black-n-White";
					} else {
						if (autoMode) {
							destFolder += "/Auto Corrected";
						} else {
							destFolder += "/Manual Corrected";
						}
					}
					if (!Folder(destFolder).exist) {
						Folder(destFolder).create();
					}
				}
				var fileName = infiles[i].fullName.toString();
				var lastDot = fileName.lastIndexOf( "." );
				if (lastDot == -1) {
					lastDot = fileName.length;
				}
				fileName = fileName.substr( 0, lastDot );
				var lastSlash = fileName.lastIndexOf( "/" );
				fileName = fileName.substr( lastSlash + 1, fileName.length );
				var extension = infiles[i].fullName.toString().substr( lastDot, infiles[i].fullName.toString().length);
				fileName = fileName.replace(/[:\/\\*\?\"\<\>\|]/g, "_");  // '/\:*?"<>|' -> '_'
				var uniqueFileName = destFolder + "/" + fileName + extension;
				var fileNumber = 1;
				while (File(uniqueFileName).exists) {
					uniqueFileName = destFolder + "/" + fileName + "_" + fileNumber + extension;
					fileNumber++;
				}
				outfiles.push(File(uniqueFileName));

				if (makeCopy) {
					infiles[i].copy(uniqueFileName);
				}

				//// don't mess with the metadata
				//var tn = new Thumbnail(File(uniqueFileName));
				//var m = tn.metadata;
				//m.namespace = "http://ns.adobe.com/xap/1.0/";
				//m.Label = "Red";
				//// end don't mess with the metadata
				// drbrownserv.alert('a');
			}
		}
		catch(error) {
			// debugging only drbrownserv.alert(error + ":" + error.line);
		}
		return outfiles;
	}

	// A list of camera raw extensions, keep them lower case, plus jpeg
	drbrownserv.filesForCameraRaw = Array( "tif", "crw", "nef", "raf", "orf", "mrw", "dcr", "mos", "srf", "pef", "dcr", "cr2", "dng", "erf", "x3f", "raw" );


	//=================================================================
	// blackandwhiteFromBridge
	//=================================================================

	//-----------------------------------------------------------------
	//-----------------------------------------------------------------
//~ 	drbrownserv.blackandwhite = function (files) {
//~ 		try {
//~ 			if (BridgeTalk.appName != "photoshop") {
//~ 				// Bring Photoshop to the foreground.
//~ 				BridgeTalk.bringToFront ("photoshop");
//~ 		
//~ 				// Create a new BridgeTalk message for Photoshop to invoke
//~ 				// Image Processor with the selected files
//~ 				var btMessage = new BridgeTalk;
//~ 				btMessage.target = "photoshop";
//~ 				btMessage.body = "drbrownserv.blackandwhite (" + files.toSource () + ");";
//~ 				btMessage.send ();
//~ 			} else {
//~ 				drbrownserv.alert('blackandwhitefrombridge');
//~ 			}
//~ 		}
//~ 		catch (error) {
//~ 			if (error.number != 8007) // Don't report user cancelled errors.
//~ 				drbrownserv.alert (error);
//~ 		}
//~ 	}


	//-----------------------------------------------------------------
	// This routine is called when the Bridge's Dr. Brown's black and white
	// menu item is chosen.
	//-----------------------------------------------------------------
//~ 	drbrownserv.blackandwhiteFromBridge = function () {
//~ 		try {
//~ 			var files = photoshop.getBridgeFileListForAutomateCommand (false);
//~ 			
//~ 			if (files.length != 0) {
//~ 				// drbrownserv.blackandwhite (files);
//~ 				drbrownserv.miniprocessor (files, false, true, true); // files, autoMode, makeFolder, bwMode
//~ 			}
//~ 		}
//~ 		catch (error) {
//~ 			if (error.number != 8007) // Don't report user cancelled errors.
//~ 				drbrownserv.alert (error);
//~ 		}
//~ 	}
	


	//=================================================================
	// manualcorrectFromBridge
	//=================================================================

	//-----------------------------------------------------------------
	//-----------------------------------------------------------------
//~ 	drbrownserv.manualcorrect = function (files) {
//~ 		try {
//~ 			if (BridgeTalk.appName != "photoshop") {
//~ 				drbrownserv.alert('manualcorrect ERROR');
//~ 				// Bring Photoshop to the foreground.
//~ 				BridgeTalk.bringToFront ("photoshop");
//~ 		
//~ 				// Create a new BridgeTalk message for Photoshop to invoke
//~ 				// Image Processor with the selected files
//~ 				var btMessage = new BridgeTalk;
//~ 				btMessage.target = "photoshop";
//~ 				btMessage.body = "drbrownserv.manualcorrect (" + files.toSource () + ");";
//~ 				btMessage.send ();
//~ 			} else {
//~ 				drbrownserv.alert('manualcorrectFromBridge ERROR');
//~ 			}
//~ 		}
//~ 		catch (error) {
//~ 			if (error.number != 8007) // Don't report user cancelled errors.
//~ 				drbrownserv.alert (error);
//~ 		}
//~ 	}


	//-----------------------------------------------------------------
	// This routine is called when the Bridge's Dr. Brown's manual correct
	// menu item is chosen.
	//-----------------------------------------------------------------
//~ 	drbrownserv.manualcorrectFromBridge = function () {
//~ 		try {
//~ 			var files = photoshop.getBridgeFileListForAutomateCommand (false);
//~ 			
//~ 			if (files.length != 0)
//~ 				drbrownserv.miniprocessor (files, false, true, false); // files, autoMode, makeFolder, bwMode
//~ 		}
//~ 		catch (error) {
//~ 			if (error.number != 8007) // Don't report user cancelled errors.
//~ 				drbrownserv.alert (error);
//~ 		}
//~ 	}


	//=================================================================
	// autocorrectFromBridge
	//=================================================================

	//-----------------------------------------------------------------
	//-----------------------------------------------------------------
//~ 	drbrownserv.autocorrect = function (files) {
//~ 		try {
//~ 			if (BridgeTalk.appName != "photoshop") {
//~ 				drbrownserv.alert('autocorrectFromBridge BRIDGE ERROR');
//~ 				// Bring Photoshop to the foreground.
//~ 				BridgeTalk.bringToFront ("photoshop");
//~ 		
//~ 				// Create a new BridgeTalk message for Photoshop to invoke
//~ 				// Image Processor with the selected files
//~ 				var btMessage = new BridgeTalk;
//~ 				btMessage.target = "photoshop";
//~ 				btMessage.body = "drbrownserv.autocorrect (" + files.toSource () + ");";
//~ 				btMessage.send ();
//~ 			} else {
//~ 				drbrownserv.alert('autocorrectFromBridge ERROR');
//~ 			}
//~ 		}
//~ 		catch (error) {
//~ 			if (error.number != 8007) // Don't report user cancelled errors.
//~ 				drbrownserv.alert (error);
//~ 		}
//~ 	}


	//-----------------------------------------------------------------
	// This routine is called when the Bridge's Dr. Brown's auto correct
	// menu item is chosen.
	//-----------------------------------------------------------------
//~ 	drbrownserv.autocorrectFromBridge = function () {
//~ 		try {
//~ 			var files = photoshop.getBridgeFileListForAutomateCommand (false);
//~ 			
//~ 			if (files.length != 0)
//~ 				drbrownserv.miniprocessor (files, true, true, false); // files, autoMode, makeFolder, bwMode
//~ 		}
//~ 		catch (error) {
//~ 			if (error.number != 8007) // Don't report user cancelled errors.
//~ 				drbrownserv.alert (error);
//~ 		}
//~ 	}


	//=================================================================
	// CaptionMaker
	// Sets up Dr. Brown's Caption Maker JavaScript to be
	// accessed from the Bridge.
	//=================================================================

	//-----------------------------------------------------------------
	// This routine takes an array of files. If called by Photoshop,
	// it will invoke Dr. Brown's Caption Maker with the files. If called by
	// any other app, it will send a BridgeTalk message to Photoshop
	// to invoke this routine with the same arguments.
	//-----------------------------------------------------------------
 	drbrownserv.captionmaker = function (files) {
 		try {
 			if (BridgeTalk.appName != "photoshop") {
 				// Bring Photoshop to the foreground.
 				BridgeTalk.bringToFront ("photoshop");
 		
 				// Create a new BridgeTalk message for Photoshop to invoke
 				// Image Processor with the selected files
 				var btMessage = new BridgeTalk;
 				btMessage.target = "photoshop";
 				btMessage.body = "drbrownserv.captionmaker (" + files.toSource () + ");";
 				btMessage.send ();
 			} else {
 		
 				// Dr. Brown's Caption Maker script will recognize this and use it
 				var gFilesFromBridge = files;
 		
 				var strPresets = localize ("$$$/ApplicationPresetsFolder/Presets=Presets");
 				var strScripts = localize ("$$$/PSBI/Automate/ImageProcessor/Photoshop/Scripts=Scripts");
 				var strCaptionMaker = "Dr. Brown's Caption Maker.jsx";
 				
 				var cmFile = new File (app.path + "/" + strPresets + "/" + strScripts + "/" + strCaptionMaker);
 				
 				var rememberDialogModes = displayDialogs;
 				displayDialogs = DialogModes.ALL;
 						
 				if (cmFile.exists) {
 					if (cmFile.open ('r')) {
 						var script = cmFile.read ();
 						cmFile.close ();
 						eval (script);
 					} else {
 						drbrownserv.alert ( strCaptionMaker + " could not be opened." );
 					}
 				} else {
 					drbrownserv.alert ( cmFile.fsName + " could not be found." );
 				}
 		
 				displayDialogs = rememberDialogModes;
 			}
 		}
 		catch (error) {
 			if (error.number != 8007) // Don't report user cancelled errors.
 				drbrownserv.alert (error);
 		}
	}


	//-----------------------------------------------------------------
	// This routine is called when the Bridge's Dr. Brown's Caption Maker
	// menu item is chosen.
	//-----------------------------------------------------------------
 	drbrownserv.captionmakerFromBridge = function () {
 		try {
 			var files = photoshop.getBridgeFileListForAutomateCommand (false);
 			
 			if (files.length != 0)
 				drbrownserv.captionmaker (files);
 		}
 		catch (error) {
 			if (error.number != 8007) // Don't report user cancelled errors.
 				drbrownserv.alert (error);
 		}
 	}


	//=================================================================
	// Process123
	// Sets up Dr. Brown's Process 1-2-3 JavaScript to be
	// accessed from the Bridge.
	//=================================================================

	//-----------------------------------------------------------------
	// This routine takes an array of files. If called by Photoshop,
	// it will invoke Dr. Brown's Process 1-2-3 with the files. If called by
	// any other app, it will send a BridgeTalk message to Photoshop
	// to invoke this routine with the same arguments.
	//-----------------------------------------------------------------
	drbrownserv.process123 = function (files) {
		try {
			if (BridgeTalk.appName != "photoshop") {
				// Bring Photoshop to the foreground.
				BridgeTalk.bringToFront ("photoshop");
		
				// Create a new BridgeTalk message for Photoshop to invoke
				// Image Processor with the selected files
				var btMessage = new BridgeTalk;
				btMessage.target = "photoshop";
				btMessage.body = "drbrownserv.process123 (" + files.toSource () + ");";
				btMessage.send ();
			} else {
		
				// Dr. Brown's Process 1-2-3 script will recognize this and use it
				var gFilesFromBridge = files;
		
				var strPresets = localize ("$$$/ApplicationPresetsFolder/Presets=Presets");
				var strScripts = localize ("$$$/PSBI/Automate/ImageProcessor/Photoshop/Scripts=Scripts");
				var strProcess123 = "Dr. Brown's 1-2-3 Process.jsx";
				
				var cmFile = new File (app.path + "/" + strPresets + "/" + strScripts + "/" + strProcess123);
				
				var rememberDialogModes = displayDialogs;
				displayDialogs = DialogModes.ALL;
						
				if (cmFile.exists) {
					if (cmFile.open ('r')) {
						var script = cmFile.read ();
						cmFile.close ();
						eval (script);
					} else {
						drbrownserv.alert ( strProcess123 + " could not be opened." );
					}
				} else {
					drbrownserv.alert ( cmFile.fsName + " could not be found." );
				}
		
				displayDialogs = rememberDialogModes;
			}
		}
		catch (error) {
			if (error.number != 8007) // Don't report user cancelled errors.
				drbrownserv.alert (error);
		}
	}


	//-----------------------------------------------------------------
	// This routine is called when the Bridge's Dr. Brown's Caption Maker
	// menu item is chosen.
	//-----------------------------------------------------------------
	drbrownserv.process123FromBridge = function () {
		try {
			var files = photoshop.getBridgeFileListForAutomateCommand (false);
			
			if (files.length != 0)
				drbrownserv.process123 (files);
		}
		catch (error) {
			if (error.number != 8007) // Don't report user cancelled errors.
				drbrownserv.alert (error);
		}
	}


	//-----------------------------------------------------------------
	// This routine takes an array of files. If called by Photoshop,
	// it will invoke the merge routine with the files. If called by
	// any other app, it will send a BridgeTalk message to Photoshop
	// to invoke this routine with the same arguments.
	//-----------------------------------------------------------------
	drbrownserv.drBrownsStackAMatic = function (/* Array */ files) {
		try {
			if (BridgeTalk.appName != "photoshop") {
				// Bring Photoshop to the foreground.
				BridgeTalk.bringToFront ("photoshop");
			
				// Create a new BridgeTalk message for Photoshop to invoke
				// this command on the other side of the else with the selected files
				var btMessage = new BridgeTalk;
				btMessage.target = "photoshop";
				btMessage.body = "drbrownserv.drBrownsStackAMatic (" + files.toSource () + ");";
				btMessage.send();

			} else { // below is running in Photoshop

				if ( files == undefined ) return;
				if ( files.length == undefined ) return;
				if ( files.length == 0 ) return;
				
				var dialogOK = false;
				
				var stackInfo = new Object();
				stackInfo.cbCreateStack = false;
				stackInfo.ddStackModeIndex = 0;
				stackInfo.ddStackModeText = "None";
				stackInfo.cbAutoAlign = false;
				stackInfo.cb16bit = false;
				stackInfo.runningExtended = app.featureEnabled("photoshop/extended");
				var stackArrayEnum = [ "entr", "kurt", "maxx", "avrg", "medn", "minn", "rang", "skew", "stdv", "summ", "vari" ];
				var stackArrayString = [ "Entropy", "Kurtosis", "Maximum", "Mean", "Median", "Minimum", "Range", "Skewness", "Standard Deviation", "Summation", "Variance" ];
				
				if ( stackInfo.runningExtended ) {

					var dlgResource = "dialog { orientation: 'row', alignChildren: 'top', alignment: 'fill', text: 'cantdoit', \
						grpText: Group { orientation: 'column', alignChildren: 'left', \
						 cbCreateStack: Checkbox { text: 'Create Stack', properties: { idString: 'cbCreateStack' } }, \
						 pnlStackMode: Panel { text: 'Set Stack Mode:', \
						  ddStackMode: DropDownList { properties: { idString: 'ddStackMode', items: [ 'None', '-', 'Entropy', 'Kurtosis', 'Maximum', 'Mean', 'Median', 'Minimum', 'Range', 'Skewness', 'Standard Deviation', 'Summation', 'Variance' ] } }, \
						 }, \
						 cbAutoAlign: Checkbox { text: 'Auto Align', properties: { idString: 'cbAutoAlign' } }, \
						 cb16bit: Checkbox { text: 'Force 16 bit/channel mode', properties: { idString: 'cb16bit' } }, \
						 }, \
						grpButtons: Group { orientation: 'column', alignment: 'top', \
						 btnOK: Button { text: 'OK', properties: { idString: 'btnOK' } }, \
						 btnCancel: Button { text: 'Cancel', properties: { idString: 'btnCancel' } }, \
						}, \
					   }"; // end of dialog resource


					var idOK = 1;			
					var idCancel = 2;			

					var dlg = new Window( dlgResource );					

					dlg.text = "Dr. Brown's Stack-A-Matic";

					drbrownserv.flattenDialog( dlg, dlg );

					// set the defaults
					dlg.cbCreateStack.value = stackInfo.cbCreateStack;
					dlg.ddStackMode.items[ stackInfo.ddStackModeIndex ].selected = true;
					dlg.cbAutoAlign.value = stackInfo.cbAutoAlign;
					dlg.cb16bit.value = stackInfo.cb16bit;
				
					// look for last used params via Photoshop registry, getCustomOptions will throw if none exist
					try {
						var d = app.getCustomOptions( "8066830d-fc1f-4527-be0e-7830e1ecffd0" );
						drbrownserv.descriptorToObject( stackInfo, d );
						dlg.cbCreateStack.value = stackInfo.cbCreateStack;
						dlg.ddStackMode.items[ stackInfo.ddStackModeIndex ].selected = true;
						dlg.cbAutoAlign.value = stackInfo.cbAutoAlign;
						dlg.cb16bit.value = stackInfo.cb16bit;
						d = null;
					}
					catch( e ) {
						// it's ok if we don't have any options, continue with defaults
					}

					dlg.cbCreateStack.onClick = function( ) {
						dlg.cbAutoAlign.enabled = this.value;
						dlg.cb16bit.enabled = this.value;
						dlg.ddStackMode.enabled = this.value;
					}

					dlg.cbCreateStack.onClick();
				
					dlg.center();
					
					dialogOK = idOK == dlg.show();

					// save off parameters
					if ( dialogOK ) {
						stackInfo.cbCreateStack = dlg.cbCreateStack.value;
						stackInfo.ddStackModeIndex = dlg.ddStackMode.selection.index;
						stackInfo.ddStackModeText = dlg.ddStackMode.selection.text;
						stackInfo.cbAutoAlign = dlg.cbAutoAlign.value;
						stackInfo.cb16bit = dlg.cb16bit.value;
					}
				
					var d = drbrownserv.objectToDescriptor( stackInfo );
					d.putString( app.charIDToTypeID( 'Msge' ), "Dr. Brown's Stack-A-Matic options" );
					app.putCustomOptions( "8066830d-fc1f-4527-be0e-7830e1ecffd0", d );
					d = null;

				} else { // end if extended version and we pop the dialog
					
					dialogOK = true;
				
				}

				if ( dialogOK ) {

					var	firstDoc = open( files[ 0 ] );
				
					var targetDoc = firstDoc.duplicate();
					
					var bottomLayer = targetDoc.activeLayer;
				
					firstDoc.close( SaveOptions.DONOTSAVECHANGES );

					for ( var i = 1; i < files.length; i++ ) {
						try {
							var newDoc = open( files[ i ] );

							newDoc.selection.selectAll();

							newDoc.selection.copy();

							var docSplit = files[ i ].toString().split( "/" );

							var fileName = docSplit[ docSplit.length - 1 ];

							activeDocument = targetDoc;

							targetDoc.paste();

							targetDoc.activeLayer.name = decodeURI( fileName );

							newDoc.close( SaveOptions.DONOTSAVECHANGES );

						}
						
						catch(e) {
							// drbrownserv.alert( "ERROR DrBrownsStackAMatic: " + e );
						}
					} // end the for loop
				
					if ( stackInfo.cb16bit) {
						app.activeDocument.bitsPerChannel = BitsPerChannelType.SIXTEEN;
					} // end 16 bit option
				
					if ( stackInfo.cbCreateStack ) {
						
						drbrownserv.selectAdditionalLayer( bottomLayer.name );
							
						if ( stackInfo.cbAutoAlign ) {
							var alignID = charIDToTypeID( "Algn" );
							var alignDesc = new ActionDescriptor();
							var nullID = charIDToTypeID( "null" );
							var alignRef = new ActionReference();
							alignRef.putEnumerated( charIDToTypeID( "Lyr " ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) );
							alignDesc.putReference( nullID, alignRef );
							alignDesc.putEnumerated( charIDToTypeID( "Usng" ), charIDToTypeID( "ADSt" ), stringIDToTypeID( "ADSContent" ) );
							alignDesc.putEnumerated( charIDToTypeID( "Aply" ), stringIDToTypeID( "projection" ), charIDToTypeID( "Auto" ) );
							executeAction( alignID, alignDesc, DialogModes.NO );
						}

						executeAction( stringIDToTypeID( "newPlacedLayer" ), undefined, DialogModes.NO );
						
						
						if ( stackInfo.ddStackModeIndex != 0 ) { // None is index 0
							// tpr var noneid = stringIDToTypeID( "imageStackConvertSmartObject" );
							// tpr var nonedesc = new ActionDescriptor();
							// tpr executeAction( noneid, nonedesc, DialogModes.NO );
						// tpr } else {
							var isdesc4 = new ActionDescriptor();
							var isid21 = stringIDToTypeID( "imageStackPlugin" );
							var isid22 = charIDToTypeID( stackArrayEnum[ stackInfo.ddStackModeIndex - 2 ] );
							isdesc4.putClass( isid21, isid22 );
							var isid23 = charIDToTypeID( "Nm  " );
							isdesc4.putString( isid23, stackInfo.ddStackModeText );
							executeAction( stringIDToTypeID( "applyImageStackPluginRenderer" ), isdesc4, DialogModes.NO );
						}
					} // end create stack option
				
				} // end the if dialog ok
			} // end if ! photoshop and else 
		} // end try block for drBrownsStackAMatic
		
		catch (error) {
			if (error.number != 8007) // Don't report user cancelled errors.
				drbrownserv.alert (error + ":" + error.line);
		}
	} // end function drBrownsStackAMatic


	//-----------------------------------------------------------------
	// This routine is called when the Dr. Browns Stack a matic menu
	// item is chosen.
	//-----------------------------------------------------------------
	drbrownserv.drBrownsStackAMaticFromBridge = function () {
		try {
			var files = photoshop.getBridgeFileListForAutomateCommand (false);
			
			if (files.length != 0)
				drbrownserv.drBrownsStackAMatic (files);
		}
		
		catch (error) {
			if (error.number != 8007) // Don't report user cancelled errors.
				drbrownserv.alert (error); //  + ":" + error.line);
		}
	}

	//-----------------------------------------------------------------
	// This routine takes an array of files. If called by Photoshop,
	// it will invoke the merge routine with the files. If called by
	// any other app, it will send a BridgeTalk message to Photoshop
	// to invoke this routine with the same arguments.
	//-----------------------------------------------------------------
	//~ drbrownserv.drBrownsMergeAMatic = function (/* Array */ files) {
	//~ 	try {
	//~ 		if (BridgeTalk.appName != "photoshop") {
	//~ 			// Bring Photoshop to the foreground.
	//~ 			BridgeTalk.bringToFront ("photoshop");
	//~ 		
	//~ 			// Create a new BridgeTalk message for Photoshop to invoke
	//~ 			// this command on the other side of the else with the selected files
	//~ 			var btMessage = new BridgeTalk;
	//~ 			btMessage.target = "photoshop";
	//~ 			btMessage.body = "drbrownserv.drBrownsMergeAMatic (" + files.toSource () + ");";
	//~ 			btMessage.send();
//~ 
//~ 			} else { // below is running in Photoshop
//~ 
//~ 				if ( files == undefined ) return;
//~ 				if ( files.length == undefined ) return;
//~ 				if ( files.length == 0 ) return;
//~ 				
//~ 				var	firstDoc = open( files[ 0 ] );
//~ 				
//~ 				var targetDoc = firstDoc.duplicate();
//~ 					
//~ 				firstDoc.close( SaveOptions.DONOTSAVECHANGES );
//~ 
//~ 				targetDoc.activeLayer = targetDoc.layers[0];
//~ 
//~ 				for ( var i = 1; i < files.length; i++ ) {
//~ 					try {
//~ 						var newDoc = open( files[ i ] );
//~ 						
//~ 						var fullLayerCount = drbrownserv.recursiveCountLayers( newDoc );
//~ 
//~ 						if ( fullLayerCount > 1 ) {
//~ 							drbrownserv.selectAllLayers( newDoc );
//~ 						}
//~ 
//~ 						drbrownserv.duplicateActiveLayersToDoc( targetDoc );
//~ 						
//~ 						var docSplit = files[ i ].toString().split( "/" );
//~ 					
//~ 						var fileName = docSplit[ docSplit.length - 1 ];
//~ 					
//~ 						app.activeDocument = targetDoc;
//~ 						
//~ 						if ( fullLayerCount == 1 ) {
//~ 							
//~ 							targetDoc.activeLayer.name = decodeURI( fileName );
//~ 
//~ 						} else {
//~ 
//~ 							drbrownserv.groupSelectedLayers( decodeURI( fileName ) );
//~ 							
//~ 						}
//~ 					
//~ 						newDoc.close( SaveOptions.DONOTSAVECHANGES );
//~ 						
//~ 						targetDoc.activeLayer = targetDoc.layers[0];
//~ 
//~ 						/* tpr was the following
//~ 						newDoc.selection.selectAll();
//~ 						newDoc.selection.copy();
//~ 						var docSplit = files[ i ].toString().split( "/" );
//~ 						var fileName = docSplit[ docSplit.length - 1 ];
//~ 						activeDocument = targetDoc;
//~ 						targetDoc.paste();
//~ 						targetDoc.activeLayer.name = decodeURI( fileName );
//~ 						newDoc.close( SaveOptions.DONOTSAVECHANGES );
//~ 						*/ 
//~ 
//~ 					}
//~ 					
//~ 					catch(e) {
//~ 						drbrownserv.alert( "ERROR DrBrownsMergeAMatic: " + e  + ":" + e.line );
//~ 					}
//~ 				} // end the for loop
//~ 				
//~ 			} // end if ! photoshop and else 
//~ 		} // end try block for drBrownsStackAMatic
//~ 		
//~ 		catch (error) {
//~ 			if (error.number != 8007) // Don't report user cancelled errors.
//~ 				drbrownserv.alert (error + ":" + error.line);
//~ 		}
//~ 	} // end function drBrownsStackAMatic
//~ 
//~ 
	//-----------------------------------------------------------------
	// This routine is called when the Dr. Browns stack a matic menu
	// item is chosen.
	//-----------------------------------------------------------------
	drbrownserv.drBrownsMergeAMaticFromBridge = function () {
		try {
			var files = photoshop.getBridgeFileListForAutomateCommand (false);
			
			if (files.length != 0)
				drbrownserv.drBrownsMergeAMatic (files);
		}
		
		catch (error) {
			if (error.number != 8007) // Don't report user cancelled errors.
				drbrownserv.alert (error); //  + ":" + error.line);
		}
	}

	//-----------------------------------------------------------------
	// This routine takes an array of files. If called by Photoshop,
	// it will invoke the slide show routine with the files. If called by
	// any other app, it will send a BridgeTalk message to Photoshop
	// to invoke this routine with the same arguments.
	//-----------------------------------------------------------------
//~ 	drbrownserv.drBrownsSlideShow = function (/* Array */ files) {
//~ 		try {
//~ 			if (BridgeTalk.appName != "photoshop") {
//~ 				// Bring Photoshop to the foreground.
//~ 				BridgeTalk.bringToFront ("photoshop");
//~ 			
//~ 				// Create a new BridgeTalk message for Photoshop to invoke
//~ 				// this command on the other side of the else with the selected files
//~ 				var btMessage = new BridgeTalk;
//~ 				btMessage.target = "photoshop";
//~ 				btMessage.body = "drbrownserv.drBrownsSlideShow (" + files.toSource () + ");";
//~ 				btMessage.send();

//~ 			} else { // below is running in photoshop

//~ 				if ( files == undefined ) return;
//~ 				if ( files.length == undefined ) return;
//~ 				if ( files.length == 0 ) return;
//~ 				
//~ 				if ( ! app.featureEnabled("photoshop/extended") ) {
//~ 					alert("You need the Extended version of Adobe Photoshop CS3 to run this script.");
//~ 					return;
//~ 				}

//~                 // use the fit image automation plug-in to do this work for me
//~                 drbrownserv.fitImage = function ( inWidth, inHeight ) {
//~ 	                if ( inWidth == undefined || inHeight == undefined ) {
//~ 		                drbrownserv.alert( strWidthAndHeight );
//~ 		                return;
//~ 	                }
//~ 	                var desc = new ActionDescriptor();
//~ 	                var unitPixels = charIDToTypeID( '#Pxl' );
//~ 	                desc.putUnitDouble( charIDToTypeID( 'Wdth' ), unitPixels, inWidth );
//~ 	                desc.putUnitDouble( charIDToTypeID( 'Hght' ), unitPixels, inHeight );
//~ 	                var runtimeEventID = stringIDToTypeID( "3caa3434-cb67-11d1-bc43-0060b0a13dc4" );	
//~ 	                executeAction( runtimeEventID, desc, DialogModes.NO );
//~                 }

//~ 				drbrownserv.groupSelectedLayers = function( groupName ) {
//~ 					var id51 = charIDToTypeID( "Mk  " );
//~ 					var desc10 = new ActionDescriptor();
//~ 					var id52 = charIDToTypeID( "null" );
//~ 					var ref9 = new ActionReference();
//~ 					var id53 = stringIDToTypeID( "layerSection" );
//~ 					ref9.putClass( id53 );
//~ 					desc10.putReference( id52, ref9 );
//~ 					var id54 = charIDToTypeID( "From" );
//~ 					var ref10 = new ActionReference();
//~ 					var id55 = charIDToTypeID( "Lyr " );
//~ 					var id56 = charIDToTypeID( "Ordn" );
//~ 					var id57 = charIDToTypeID( "Trgt" );
//~ 					ref10.putEnumerated( id55, id56, id57 );
//~ 					desc10.putReference( id54, ref10 );
//~ 					var id58 = charIDToTypeID( "Usng" );
//~ 					var desc11 = new ActionDescriptor();
//~ 					var id59 = charIDToTypeID( "Nm  " );
//~ 					desc11.putString( id59, groupName );
//~ 					var id60 = stringIDToTypeID( "layerSection" );
//~ 					desc10.putObject( id58, id60, desc11 );
//~ 					executeAction( id51, desc10, DialogModes.NO );
//~ 				}

//~ 				drbrownserv.setFrameRate = function (frameRate) {
//~ 					var setID = charIDToTypeID( 'setd' );
//~ 					var nullID = charIDToTypeID( 'null' );
//~ 					var propID = charIDToTypeID( 'Prpr' );
//~ 					var toID = charIDToTypeID( 'T   ' );
//~ 	
//~ 					var timelineID = stringIDToTypeID( "timeline" );

//~ 					var frameRateID = stringIDToTypeID( "frameRate" );
//~ 		
//~ 					var timelineRateRef = new ActionReference();
//~ 	
//~ 					timelineRateRef.putProperty( propID, frameRateID );
//~ 					timelineRateRef.putClass( timelineID );
//~ 	
//~ 					var setRateDesc = new ActionDescriptor();
//~ 	
//~ 					setRateDesc.putReference( nullID, timelineRateRef );
//~ 					setRateDesc.putDouble( toID, frameRate );
//~ 	
//~ 					executeAction( setID, setRateDesc, DialogModes.NO );
//~ 				}

//~ 				drbrownserv.setDuration = function ( inSSTime ) {
//~ 					var setID = charIDToTypeID( 'setd' );
//~ 					var nullID = charIDToTypeID( 'null' );
//~ 					var propID = charIDToTypeID( 'Prpr' );
//~ 					var toID = charIDToTypeID( 'T   ' );
//~ 	
//~ 					var timelineID = stringIDToTypeID( "timeline" );

//~ 					var durationID = stringIDToTypeID( "duration" );
//~ 	
//~ 					var timecodeID = stringIDToTypeID( "timecode" );
//~ 	
//~ 					var hoursID = stringIDToTypeID( "hours" );
//~ 					var minutesID = stringIDToTypeID( "minutes" );
//~ 					var secondsID = stringIDToTypeID( "seconds" );
//~ 					var frameID = stringIDToTypeID( "frame" );
//~ 					var frameRateID = stringIDToTypeID( "frameRate" );
//~ 	
//~ 					var timecodeDesc = new ActionDescriptor();
//~ 	
//~ 					timecodeDesc.putInteger( hoursID, inSSTime.hour );
//~ 					timecodeDesc.putInteger( minutesID, inSSTime.min );
//~ 					timecodeDesc.putInteger( secondsID, inSSTime.sec );
//~ 					timecodeDesc.putInteger( frameID, inSSTime.frame );
//~ 					timecodeDesc.putDouble( frameRateID, inSSTime.frameRate );
//~ 	
//~ 					var timelineDurationRef = new ActionReference();
//~ 	
//~ 					timelineDurationRef.putProperty( propID, durationID );
//~ 					timelineDurationRef.putClass( timelineID );
//~ 	
//~ 					var setDurationDesc = new ActionDescriptor();
//~ 	
//~ 					setDurationDesc.putReference( nullID, timelineDurationRef );
//~ 					setDurationDesc.putObject( toID, timecodeID, timecodeDesc );
//~ 	
//~ 					executeAction( setID, setDurationDesc, DialogModes.NO );
//~ 				}

//~                 drbrownserv.setTime  = function ( inSSTime ) {
//~ 	                var setID = charIDToTypeID( 'setd' );
//~ 	                var nullID = charIDToTypeID( 'null' );
//~ 	                var propID = charIDToTypeID( 'Prpr' );
//~ 	                var toID = charIDToTypeID( 'T   ' );
//~                 	
//~ 	                var timelineID = stringIDToTypeID( "timeline" );

//~ 	                var timeID = stringIDToTypeID( "time" );
//~                 	
//~ 	                var timecodeID = stringIDToTypeID( "timecode" );
//~                 	
//~ 	                var hoursID = stringIDToTypeID( "hours" );
//~ 	                var minutesID = stringIDToTypeID( "minutes" );
//~ 	                var secondsID = stringIDToTypeID( "seconds" );
//~ 	                var frameID = stringIDToTypeID( "frame" );
//~ 	                var frameRateID = stringIDToTypeID( "frameRate" );
//~                 	
//~ 	                var timecodeDesc = new ActionDescriptor();
//~                 	
//~ 	                timecodeDesc.putInteger( hoursID, inSSTime.hour );
//~ 	                timecodeDesc.putInteger( minutesID, inSSTime.min );
//~ 	                timecodeDesc.putInteger( secondsID, inSSTime.sec );
//~ 	                timecodeDesc.putInteger( frameID, inSSTime.frame );
//~ 	                timecodeDesc.putDouble( frameRateID, inSSTime.frameRate );
//~                 	
//~ 	                var timelineTimeRef = new ActionReference();
//~                 	
//~ 	                timelineTimeRef.putProperty( propID, timeID );
//~ 	                timelineTimeRef.putClass( timelineID );
//~                 	
//~ 	                var setTimeDesc = new ActionDescriptor();
//~                 	
//~ 	                setTimeDesc.putReference( nullID, timelineTimeRef );
//~ 	                setTimeDesc.putObject( toID, timecodeID, timecodeDesc );
//~                 	
//~ 	                executeAction( setID, setTimeDesc, DialogModes.NO );
//~                 }
//~ 			
//~ 				// 0 for Linear, 1 for hold
//~ 				// we need hold mode when we don't have any time between
//~ 				// linear is default
//~                 drbrownserv.setKeyMode = function ( keyMode ) {
//~ 					var id16 = charIDToTypeID( "setd" );
//~ 					var desc4 = new ActionDescriptor();
//~ 					var id17 = charIDToTypeID( "null" );
//~ 					var ref2 = new ActionReference();
//~ 					var id18 = charIDToTypeID( "Prpr" );
//~ 					var id19 = stringIDToTypeID( "animInterpStyle" );
//~ 					ref2.putProperty( id18, id19 );
//~ 					var id20 = stringIDToTypeID( "animationKey" );
//~ 					var id21 = charIDToTypeID( "Ordn" );
//~ 					var id22 = charIDToTypeID( "Trgt" );
//~ 					ref2.putEnumerated( id20, id21, id22 );
//~ 					desc4.putReference( id17, ref2 );
//~ 					var id23 = charIDToTypeID( "T   " );
//~ 					var id24 = stringIDToTypeID( "animInterpStyle" );
//~ 					if ( keyMode == 0 ) {
//~ 						var id25 = charIDToTypeID( "Lnr " );
//~ 					} else {
//~ 						var id25 = stringIDToTypeID( "hold" );
//~ 					}
//~ 					desc4.putEnumerated( id23, id24, id25 );
//~ 					executeAction( id16, desc4, DialogModes.NO );
//~ 				}

//~                 drbrownserv.enableOpacityTrack = function () {
//~                     var id1567 = stringIDToTypeID( "enable" );
//~                     var desc522 = new ActionDescriptor();
//~                     var id1568 = charIDToTypeID( "null" );
//~                     var ref178 = new ActionReference();
//~                     var id1569 = stringIDToTypeID( "animationTrack" );
//~                     var id1570 = stringIDToTypeID( "stdTrackID" );
//~                     var id1571 = stringIDToTypeID( "opacityTrack" );
//~                     ref178.putEnumerated( id1569, id1570, id1571 );
//~                     desc522.putReference( id1568, ref178 );
//~                     executeAction( id1567, desc522, DialogModes.NO );
//~                 }
//~                 
//~                 drbrownserv.makeKeyframeOpacityTrack = function () {
//~                     var id1870 = charIDToTypeID( "Mk  " );
//~                     var desc583 = new ActionDescriptor();
//~                     var id1871 = charIDToTypeID( "null" );
//~                         var ref227 = new ActionReference();
//~                         var id1872 = stringIDToTypeID( "animationKey" );
//~                         ref227.putClass( id1872 );
//~                         var id1873 = stringIDToTypeID( "animationTrack" );
//~                         var id1874 = stringIDToTypeID( "stdTrackID" );
//~                         var id1875 = stringIDToTypeID( "opacityTrack" );
//~                         ref227.putEnumerated( id1873, id1874, id1875 );
//~                     desc583.putReference( id1871, ref227 );
//~                     executeAction( id1870, desc583, DialogModes.NO );
//~                 }
//~ 			
//~ 				drbrownserv.selectKey = function ( inSSTime ) {
//~ 					var id44 = charIDToTypeID( "slct" );
//~ 					var desc9 = new ActionDescriptor();
//~ 					var id45 = charIDToTypeID( "null" );
//~ 					var ref7 = new ActionReference();
//~ 					var id46 = stringIDToTypeID( "animationKey" );
//~ 					ref7.putClass( id46 );
//~ 					var id47 = stringIDToTypeID( "animationTrack" );
//~ 					var id48 = stringIDToTypeID( "stdTrackID" );
//~ 					var id49 = stringIDToTypeID( "opacityTrack" );
//~ 					ref7.putEnumerated( id47, id48, id49 );
//~ 					desc9.putReference( id45, ref7 );
//~ 					var id50 = charIDToTypeID( "At  " );
//~ 					var desc10 = new ActionDescriptor();
//~ 					var hoursID = stringIDToTypeID( "hours" );
//~ 					desc10.putInteger( hoursID, inSSTime.hour );
//~ 					var minutesID = stringIDToTypeID( "minutes" );
//~ 					desc10.putInteger( minutesID, inSSTime.min );
//~ 					var id51 = stringIDToTypeID( "seconds" );
//~ 					desc10.putInteger( id51, inSSTime.sec );
//~ 					var id52 = stringIDToTypeID( "frame" );
//~ 					desc10.putInteger( id52, inSSTime.frame );
//~ 					var id53 = stringIDToTypeID( "frameRate" );
//~ 					desc10.putDouble( id53, inSSTime.frameRate );
//~ 					var id54 = stringIDToTypeID( "timecode" );
//~ 					desc9.putObject( id50, id54, desc10 );
//~ 					executeAction( id44, desc9, DialogModes.NO );
//~ 				}

//~ 				// "Video and Film"
//~ 				drbrownserv.switchToWorkspace = function ( inWorkspace ) {
//~ 					var id1 = charIDToTypeID( "slct" );
//~ 					var desc1 = new ActionDescriptor();
//~ 					var id2 = charIDToTypeID( "null" );
//~ 					var ref1 = new ActionReference();
//~ 					var id3 = stringIDToTypeID( "workspace" );
//~ 					ref1.putName( id3, inWorkspace );
//~ 					desc1.putReference( id2, ref1 );
//~ 					executeAction( id1, desc1, DialogModes.NO );
//~ 				}

//~ 				// given a time t in seconds or in the form of "hh:mm:ss:fr" 
//~ 				// convert to hours, minutes, seconds and frames
//~ 				// keeping the total in seconds
//~ 				drbrownserv.ssTime = function ( t, fr ) {
//~ 					// move to the next time and update everyone
//~ 					this.increment = function ( inValue ) {
//~ 						this.total += inValue;
//~ 						this.hour = Math.floor( this.total / 60 / 60 );
//~ 						var hourInSec = this.hour * 60 * 60;
//~ 						this.min = Math.floor( ( this.total - hourInSec ) / 60 );
//~ 						var minInSec = this.min * 60;
//~ 						this.sec = Math.floor( this.total - hourInSec - minInSec  );
//~ 						this.frame = Math.round( ( this.total - hourInSec - minInSec - this.sec ) * this.frameRate );
//~ 					}

//~ 					this.toString = function () {
//~ 						// debugging version return this.total + ":" + this.hour + ":" + this.min + ":" + this.sec + ":" + this.frame + ":" + this.frameRate;
//~ 						return this.total + ":" + this.hour + ":" + this.min + ":" + this.sec + ":" + this.frame;
//~ 					}

//~ 					this.frameRate = fr;
//~ 					if ( isNaN( t ) ) {
//~ 						var a = t.split( ':' );
//~ 						a.reverse();
//~ 						this.hour =  ( a.length > 3 ) ? Math.floor( Number( a[3] ) ) : 0;
//~ 						this.min =   ( a.length > 2 ) ? Math.floor( Number( a[2] ) ) : 0;
//~ 						this.sec =   ( a.length > 1 ) ? Math.floor( Number( a[1] ) ) : 0;
//~ 						this.frame = ( a.length > 0 ) ? Math.floor( Number( a[0] ) ) : 0;
//~ 						this.total = this.hour * 60 * 60 + this.min * 60 + this.sec + this.frame / fr;
//~ 					} else {
//~ 						this.total = Number( t );
//~ 						this.increment( 0 );
//~ 					}

//~ 				} // end constructor for ssTime

//~ 				var dlgResource = "dialog { orientation: 'row', alignChildren: 'top', alignment: 'fill', text: 'Dr. Browns TBD', \
//~ 					grpText: Group { orientation: 'column', alignChildren: 'left', \
//~ 					 grpAlign1: Group { orientation: 'row', spacing: 1, \
//~ 					  stName: StaticText { text: 'File Name:' }, \
//~ 					  etDummy1: EditText { text: 'hi', visible: false }, \
//~ 					 }, \
//~ 					 grpAlign2: Group { orientation: 'row', spacing: 1,  \
//~ 					  stAuthor: StaticText { text: 'Custom Caption:' }, \
//~ 					  etDummy2: EditText { text: 'hi', visible: false }, \
//~ 					 }, \
//~ 					 grpAlign3: Group { orientation: 'row', spacing: 1,  \
//~ 					  stAuthor: StaticText { text: 'Metadata Caption:' }, \
//~ 					  ddDummy8: DropDownList { visible: false, properties: { idString: 'ddDummy8' }  }, \
//~ 					 }, \
//~ 					 grpAlign4: Group { orientation: 'row', spacing: 1,  \
//~ 					  stTime: StaticText { text: 'Duration:' }, \
//~ 					  ddDummy9: DropDownList { visible: false, properties: { idString: 'ddDummy9' }  }, \
//~ 					 }, \
//~ 					 grpAlign5: Group { orientation: 'row', spacing: 1,  \
//~ 					  stFrameRate: StaticText { text: 'Frame Rate:' }, \
//~ 					  etDummy5: EditText { text: 'hi', visible: false }, \
//~ 					 }, \
//~ 					 grpAlign6: Group { orientation: 'row', spacing: 1,  \
//~ 					  stTimeBetween: StaticText { text: 'Time Between Images:' }, \
//~ 					  etDummy6: EditText { text: 'hi', visible: false }, \
//~ 					 }, \
//~ 					}, \
//~ 					grpData: Group { orientation: 'column', alignChildren: 'fill', \
//~ 					 etName: EditText { text: '', properties: { idString: 'etName' } }, \
//~ 					 etCaption: EditText { text: '', properties: { idString: 'etCaption' } }, \
//~ 					 grpCombo: Group { orientation: 'row', \
//~ 					  grpComboLeft: Group { orientation: 'column', alignChildren: 'fill', \
//~ 					   grpComboTop: Group { orientation: 'row', spacing: 1, \
//~ 					    cbCaption: Checkbox { properties: { idString: 'cbCaption' } }, \
//~ 						ddDummy1: DropDownList { visible: false, properties: { idString: 'ddDummy1' }  }, \
//~ 					   }, \
//~ 					   grpComboBottom: Group { orientation: 'row', spacing: 1, \
//~ 					    etTime: EditText { text: '00:05:00', properties: { idString: 'etTime' } }, \
//~ 						ddDummy2: DropDownList { visible: false, properties: { idString: 'ddDummy2' }  }, \
//~ 					   }, \
//~ 					  }, \
//~ 					  grpComboRight: Group { orientation: 'column', alignChildren: 'fill', \
//~ 					   ddCaption: DropDownList { properties: { idString: 'ddCaption', items: [ 'Filename', 'Author', 'Copyright Notice', 'Headline', 'Description', 'Credit', 'Instructions', 'Color Profile', 'Color Mode', 'Document Kind', 'Document Creator', 'Date', 'Date Created', 'Date File Modified', 'City', 'State/Province', 'Keywords', 'Exposure Time', 'Model', 'Focal Length', 'Current Date' ] } }, \
//~ 					   ddTime: DropDownList { properties: { idString: 'ddTime', items: [ 'time per image', 'total time' ] } }, \
//~ 					  }, \
//~ 					 }, \
//~ 					 etFrameRate: EditText { text: '24', properties: { idString: 'etFrameRate' } }, \
//~ 					 etTimeBetween: EditText { text: '00:01:00', properties: { idString: 'etTimeBetween' } }, \
//~ 					}, \
//~ 					grpButtons: Group { orientation: 'column', alignment: 'top', \
//~ 					 btnOK: Button { text: 'OK', properties: { idString: 'btnOK' } }, \
//~ 					 btnCancel: Button { text: 'Cancel', properties: { idString: 'btnCancel' } }, \
//~ 					}, \
//~ 				   }";

//~ 				var slideShowInfo = new Object();
//~ 				slideShowInfo.valid = false;
//~ 				// look for last used params via Photoshop registry, getCustomOptions will throw if none exist
//~ 				try {
//~ 					var d = app.getCustomOptions( "1d46ec6c-772f-4020-a13d-0017d25faa99" );
//~ 					drbrownserv.descriptorToObject( slideShowInfo, d );
//~ 					slideShowInfo.valid = true;
//~ 					d = null;
//~ 				}
//~ 				catch(e) {
//~ 					// it's ok if we don't have any options, continue with defaults
//~ 				}
//~ 	
//~ 				var convertToTimeline = false;
//~ 				if ( ! slideShowInfo.valid ) {
//~ 					if ( confirm( "WARNING: This script will not run correctly unless the Adobe Photoshop CS3 Timeline panel is open.\r\rWould you like Dr. Brown to automatically open the Timeline Panel by switching to the ' Video and Film ' workspace?" ) ) {
//~ 						drbrownserv.switchToWorkspace( "Video and Film" );
//~ 						convertToTimeline = true;
//~ 					}
//~ 					slideShowInfo.valid = true;
//~ 				}

//~ 				var idOK = 1;			
//~                 var idCancel = 2;			
//~                 var nameSize = 120;
//~                 var editTextMinSize = 90;
//~ 				var globalText = false;
//~ 				var docWidth = 1024;
//~ 				var docHeight = 768;
//~ 				var imageWidth = 800;
//~ 				var imageHeight = 600;
//~ 				var textSpacing = 5;
//~ 				var textBoxWidth = imageWidth;
//~ 				var textBoxHeight = ( docHeight - imageHeight ) / 2;
//~ 				var textBoxPosition = [ UnitValue( ( docWidth - imageWidth ) / 2, "px" ), UnitValue( docHeight + textSpacing - ( docHeight - imageHeight ) / 2, "px" ) ];
//~ 				var textFontSize = 20;

//~                 var dlg = new Window( dlgResource );					

//~                 drbrownserv.flattenDialog( dlg, dlg );

//~                 dlg.text = "Dr. Brown's Slide Show";
//~                 dlg.etTime.preferredSize.width = editTextMinSize;
//~                 dlg.etFrameRate.preferredSize.width = editTextMinSize;
//~                 dlg.etTimeBetween.preferredSize.width = editTextMinSize;
//~ 				// dlg.stMessage.maximumSize.width = 80;
//~ 				// dlg.stMessage.preferredSize.height = 120;

//~ 				// set the defaults
//~ 				dlg.etName.text = 'Slide Show';
//~ 				dlg.etCaption.text = '';
//~ 				dlg.ddCaption.items[0].selected = true;
//~ 				dlg.ddTime.items[0].selected = true;
//~ 				dlg.etTime.text = '00:05:00';
//~ 				dlg.etFrameRate.text = '24';
//~ 				dlg.etTimeBetween.text = '00:01:00';
//~ 				dlg.cbCaption.value = false;
//~ 				
//~ 				if ( typeof( slideShowInfo.ddCaption ) != "undefined" ) {
//~  					dlg.etName.text = slideShowInfo.etName;
//~ 					dlg.etCaption.text = slideShowInfo.etCaption;
//~ 					dlg.ddCaption.items[slideShowInfo.ddCaption].selected = true;
//~ 					dlg.ddTime.items[slideShowInfo.ddTime].selected = true;
//~ 					dlg.etTime.text = slideShowInfo.etTime;
//~ 					dlg.etFrameRate.text = slideShowInfo.etFrameRate;
//~ 					dlg.etTimeBetween.text = slideShowInfo.etTimeBetween;
//~ 					dlg.cbCaption.value = slideShowInfo.cbCaption;
//~ 				}

//~ 				dlg.cbCaption.onClick = function( ) {
//~ 					dlg.ddCaption.enabled = this.value;
//~ 				}

//~ 				dlg.cbCaption.onClick();
//~ 				
//~                 dlg.center();

//~                 if ( idOK == dlg.show() ) {
//~ 					// new document for everything
//~ 				    var	slideDoc = app.documents.add( UnitValue( docWidth, "px" ), 
//~ 					                                  UnitValue( docHeight, "px" ), 
//~ 													  72, 
//~ 													  dlg.etName.text, 
//~ 													  NewDocumentMode.RGB, 
//~ 													  DocumentFill.BACKGROUNDCOLOR );	
//~ 					
//~ 					// this is only if there is one layer of text info
//~ 					// do i need a text layer as well
//~ 					if ( dlg.etCaption.text.length > 0 && ! dlg.cbCaption.value ) {
//~ 						var textLayer = slideDoc.artLayers.add();
//~ 						textLayer.kind = LayerKind.TEXT;
//~ 						var textOnLayer = textLayer.textItem;
//~ 						textOnLayer.kind = TextType.PARAGRAPHTEXT;
//~ 						textOnLayer.contents = dlg.etCaption.text;
//~ 						textOnLayer.size = textFontSize;
//~ 						textOnLayer.color = app.foregroundColor;
//~ 						textOnLayer.font = "TimesNewRomanPS-ItalicMT"; // "Times New Roman";
//~ 						// textOnLayer.fauxItalic = true;
//~ 						textOnLayer.position = textBoxPosition;
//~ 						textOnLayer.width = textBoxWidth;
//~ 						textOnLayer.height = textBoxHeight;
//~ 						textOnLayer.justification = Justification.CENTER;
//~ 						globalText = true;
//~ 					}
//~ 				
//~ 					var docMeta = new Array();
//~ 					
//~ 					// merge all the documents into one layered document
//~     				for ( var i = 0; i < files.length; i++ ) {
//~ 					    try {
//~     						var newDoc = open( files[ i ] );
//~ 							if ( dlg.cbCaption.value ) {
//~ 								docMeta[i] = drbrownserv.getMetaData( dlg.ddCaption.selection.text, false /*verbose*/ );
//~ 							}
//~ 						    drbrownserv.fitImage( imageWidth, imageHeight );
//~ 						    newDoc.selection.selectAll();
//~ 						    newDoc.selection.copy();
//~ 						    var docSplit = files[ i ].toString().split( "/" );
//~ 						    var fileName = docSplit[ docSplit.length - 1 ];
//~ 						    activeDocument = slideDoc;
//~ 						    var imageLayer = slideDoc.paste();
//~ 						    slideDoc.activeLayer.name = decodeURI( fileName );
//~ 						    newDoc.close( SaveOptions.DONOTSAVECHANGES );
//~ 							
//~ 							// text layer for each document layer
//~ 							// group them so the timeline stuff works on the group
//~ 							// it would be nice if we could close the group, alas, i could find no way
//~ 							if ( dlg.cbCaption.value ) {
//~ 								// var layerSetRef = slideDoc.layerSets.add();
//~ 								var textLayer = slideDoc.artLayers.add();
//~ 								textLayer.kind = LayerKind.TEXT;
//~ 								var textOnLayer = textLayer.textItem;
//~ 								textOnLayer.kind = TextType.PARAGRAPHTEXT;
//~ 								textOnLayer.contents = dlg.etCaption.text + " " + docMeta[i];
//~ 								textOnLayer.size = textFontSize;
//~ 								textOnLayer.color = app.foregroundColor;
//~ 								textOnLayer.font = "Times New Roman";
//~ 								textOnLayer.fauxItalic = true;
//~ 								textOnLayer.position = textBoxPosition;
//~ 								textOnLayer.width = textBoxWidth;
//~ 								textOnLayer.height = textBoxHeight;
//~ 								textOnLayer.justification = Justification.CENTER;
//~ 								
//~ 								// layerSetRef.name = decodeURI( fileName );
//~ 								
//~ 								// this does the trick but does not close the group
//~ 								// imageLayer.moveToEnd( layerSetRef );
//~ 								// textLayer.moveToEnd( layerSetRef );
//~ 								
//~ 								// use these routines to merge into a group and then close
//~ 								drbrownserv.selectAdditionalLayer( imageLayer.name );
//~ 								drbrownserv.groupSelectedLayers( decodeURI( fileName ) );
//~ 							}

//~ 					    }
//~ 					
//~     					catch(e) {
//~ 	    					// debugging only drbrownserv.alert( "ERROR drBrownsSlideShow: " + e + ":" + e.line);
//~ 		    			}
//~ 			    	} // for loop
//~ 				
//~ 	                var doc = activeDocument;
//~ 					
//~ 					
//~ 	                // the bottom layer is the background
//~ 	                // the next one up may or may not be a text layer
//~ 					var layerIndex = 0;
//~ 					if ( dlg.cbCaption.value ) {
//~ 						layerIndex = doc.layerSets.length - 1;
//~ 					} else {
//~ 						layerIndex = doc.artLayers.length - 2;
//~ 						if ( globalText ) {
//~ 							layerIndex--;
//~ 						}
//~ 	                }

//~ 					if ( convertToTimeline ) {
//~ 						// convert to timeline mode for the animation palette
//~ 						executeAction( stringIDToTypeID( "convertAnimation" ), new ActionDescriptor(), DialogModes.NO );
//~ 					}
//~ 				
//~ 					var timeIsTotalTime = dlg.ddTime.selection.text == 'total time';
//~ 					var frameRate = Number( dlg.etFrameRate.text );
//~ 					var currentTime = new drbrownserv.ssTime( 0, frameRate );
//~ 					var timeBetween = new drbrownserv.ssTime( dlg.etTimeBetween.text, frameRate );
//~ 					var startOfTime = new drbrownserv.ssTime( 0, frameRate );
//~ 					if ( timeIsTotalTime ) {
//~ 						var totalTime = new drbrownserv.ssTime( dlg.etTime.text, frameRate );
//~ 						var slideTime = new drbrownserv.ssTime( ( totalTime.total - timeBetween.total ) / ( layerIndex + 1 ) - timeBetween.total, frameRate );
//~ 					} else { // time is per slide time
//~ 						var slideTime = new drbrownserv.ssTime( dlg.etTime.text, frameRate );
//~ 						var totalTime = new drbrownserv.ssTime( ( timeBetween.total + slideTime.total ) * ( layerIndex + 1 ) + timeBetween.total, frameRate );
//~ 					}

//~ 					drbrownserv.setFrameRate( frameRate );
//~ 	                drbrownserv.setDuration( totalTime );
//~ 					
//~ 					var firstLayer = true;
//~ 					var firstLayerOff = true;
//~ 				
//~ 					// flow in the global text layer only under these conditions
//~ 					if ( timeBetween.total != 0 && dlg.etCaption.text.length > 0 && ! dlg.cbCaption.value ) {
//~ 						doc.activeLayer = textLayer;
//~ 						drbrownserv.enableOpacityTrack();
//~ 						drbrownserv.setTime( startOfTime );
//~ 						textLayer.opacity = 0;
//~ 						drbrownserv.setTime( timeBetween );
//~ 						textLayer.opacity = 100;
//~ 						var endOfTime = new drbrownserv.ssTime( totalTime.total - timeBetween.total, frameRate );
//~ 						drbrownserv.setTime( endOfTime );
//~ 						drbrownserv.makeKeyframeOpacityTrack();
//~ 						textLayer.opacity = 100;
//~ 						drbrownserv.setTime( totalTime );
//~ 						textLayer.opacity = 0;
//~ 						drbrownserv.setTime( startOfTime );
//~ 					}
//~ 					
//~                 	while ( layerIndex >= 0 ) {
//~ 						if ( dlg.cbCaption.value ) {
//~ 							var lay = doc.layerSets[layerIndex];
//~ 						} else {
//~ 							var lay = doc.artLayers[layerIndex];
//~ 						}
//~ 	                    doc.activeLayer = lay;
//~ 						drbrownserv.enableOpacityTrack();
//~ 						if ( timeBetween.total != 0 ) {
//~ 							drbrownserv.setTime( currentTime );
//~ 							lay.opacity = 0;
//~ 							currentTime.increment( timeBetween.total );
//~ 							drbrownserv.setTime( currentTime );
//~ 							lay.opacity = 100;
//~ 							currentTime.increment( slideTime.total );
//~ 							drbrownserv.setTime( currentTime );
//~ 							drbrownserv.makeKeyframeOpacityTrack();
//~ 							currentTime.increment( timeBetween.total );
//~ 							drbrownserv.setTime( currentTime );
//~ 							lay.opacity = 0;
//~ 							currentTime.increment( -timeBetween.total );
//~ 						} else {
//~ 							drbrownserv.setTime( startOfTime );
//~ 							if ( firstLayer ) {
//~ 								lay.opacity = 100;
//~ 							} else {
//~ 								lay.opacity = 0;
//~ 							}
//~ 							drbrownserv.selectKey( startOfTime );
//~ 							drbrownserv.setKeyMode( 1 ); // 1 for hold

//~ 							if ( ! firstLayer ) {
//~ 								drbrownserv.setTime( currentTime );
//~ 								lay.opacity = 100;
//~ 								drbrownserv.selectKey( currentTime );
//~ 								drbrownserv.setKeyMode( 1 ); // 1 for hold
//~ 							} else {
//~ 								firstLayer = false;
//~ 							}
//~ 								
//~ 							if ( layerIndex != 0 ) {
//~ 								currentTime.increment( slideTime.total );
//~ 								drbrownserv.setTime( currentTime );
//~ 								lay.opacity = 0;
//~ 								drbrownserv.selectKey( currentTime );
//~ 								drbrownserv.setKeyMode( 1 ); // 1 for hold
//~ 							}
//~ 							
//~ 						}
//~ 	                    
//~ 						layerIndex--;

//~ 	                } // while ( layerIndex >= 0 ) 

//~ 					drbrownserv.setTime( startOfTime );

//~ 					// save off parameters
//~ 					slideShowInfo.etName = dlg.etName.text;
//~ 					slideShowInfo.etCaption = dlg.etCaption.text;
//~ 					slideShowInfo.ddCaption = dlg.ddCaption.selection.index;
//~ 					slideShowInfo.ddTime = dlg.ddTime.selection.index;
//~ 					slideShowInfo.etTime = dlg.etTime.text;
//~ 					slideShowInfo.etFrameRate = dlg.etFrameRate.text;
//~ 					slideShowInfo.etTimeBetween = dlg.etTimeBetween.text;
//~ 					slideShowInfo.cbCaption = dlg.cbCaption.value;
//~ 					
//~ 					var d = drbrownserv.objectToDescriptor(slideShowInfo);
//~ 					// d.putString( app.charIDToTypeID( 'Msge' ), strMessage );
//~ 					app.putCustomOptions("1d46ec6c-772f-4020-a13d-0017d25faa99", d);
//~ 					d = null;

//~                 } // if ( idOK == dlg.show() )

//~ 			} // if not photoshop

//~ 			$.gc();
//~ 			
//~ 		} // try block
//~ 		
//~ 		catch (error) {
//~ 			drbrownserv.alert( "ERROR drBrownsSlideShow: " + error + ":" + error.line );
//~ 			if ( error.number != 8007 ) // Don't report user cancelled errors.
//~ 				drbrownserv.alert( error ); //  + ":" + error.line);
//~ 		}
//~ 	}


	//-----------------------------------------------------------------
	// This routine is called when the Dr. Browns slide show menu
	// item is chosen.
	//-----------------------------------------------------------------
//~ 	drbrownserv.drBrownsSlideShowFromBridge = function () {
//~ 		try {
//~ 			var files = photoshop.getBridgeFileListForAutomateCommand (false);
//~ 			
//~ 			if (files.length != 0)
//~ 				drbrownserv.drBrownsSlideShow (files);
//~ 		}
//~ 		
//~ 		catch (error) {
//~ 			if (error.number != 8007) // Don't report user cancelled errors.
//~ 				drbrownserv.alert (error); //  + ":" + error.line);
//~ 		}
//~ 	}

	//-----------------------------------------------------------------
	// This routine takes an array of files. If called by Photoshop,
	// it will convert each file to placed smart object on a layer. 
	// If called by any other app, it will send a BridgeTalk message
	// to Photoshop to invoke this routine with the same arguments.
	// If only one file is selected it will place until the user
	// selects cancel or done in the RAW dialog
	//-----------------------------------------------------------------
	drbrownserv.drBrownsPlaceAMatic = function (/* Array */ files, /* new doc depth */ depth) {
		try {
			if (BridgeTalk.appName != "photoshop") {
				// Bring Photoshop to the foreground.
				BridgeTalk.bringToFront ("photoshop");
			
				// Create a new BridgeTalk message for Photoshop to invoke
				// this routine on the other side of the else
				// with the selected files
				var btMessage = new BridgeTalk;
				btMessage.target = "photoshop";
				btMessage.body = "drbrownserv.drBrownsPlaceAMatic (" + files.toSource () + ", " + depth + ");";
				btMessage.send();

			} else {

				if ( files == undefined ) return;
				if ( files.length == undefined ) return;
				if ( files.length == 0 ) return;

				var PlaceFile = function( inFile ) {
					var id18 = charIDToTypeID( "Plc " );
					var desc = new ActionDescriptor();
					var id19 = charIDToTypeID( "null" );
					desc.putPath( id19, inFile );
					var id20 = charIDToTypeID( "FTcs" );
					var id21 = charIDToTypeID( "QCSt" );
					var id22 = charIDToTypeID( "Qcsa" );
					desc.putEnumerated( id20, id21, id22 ); // not sure what this does
					var id23 = charIDToTypeID( "Ofst" );
					var descObj = new ActionDescriptor();
					var id24 = charIDToTypeID( "Hrzn" );
					var id25 = charIDToTypeID( "#Pxl" );
					descObj.putUnitDouble( id24, id25, 0.000000 ); // could add that to the call
					var id26 = charIDToTypeID( "Vrtc" );
					var id27 = charIDToTypeID( "#Pxl" );
					descObj.putUnitDouble( id26, id27, 0.000000 ); // and maybe this
					var id28 = charIDToTypeID( "Ofst" );
					desc.putObject( id23, id28, descObj );
					var descResult = executeAction( id18, desc, DialogModes.NO );
					desc = null;
					descObj = null;
					descResult = null;
					$.gc();
				}

				var firstDoc = open( files[ 0 ] );

				// switch the units, we can't handle percentage units
				var startRulerUnits = preferences.rulerUnits;
				preferences.rulerUnits = Units.INCHES;

				var w = firstDoc.width;
				var h = firstDoc.height;
				var r = firstDoc.resolution;

				preferences.rulerUnits = startRulerUnits;

				firstDoc.close( SaveOptions.DONOTSAVECHANGES );
				
				var docSplit = files[ 0 ].toString().split( "/" );

				var fileName = docSplit[ docSplit.length - 1 ];

				firstDoc = documents.add( w, h, r, decodeURI( fileName ) );

				if (depth == 16) {
					// Convert the doc to 16-bit.
					app.activeDocument.bitsPerChannel = BitsPerChannelType.SIXTEEN;
				}

				firstLayer = app.activeDocument.activeLayer;


				if ( files.length == 1 ) {

					try {
						// ideally we would like to loop and have the user cancel
						// when they have placed enough of them
						// the problem is that non-camera raw files will not pop
						// a dialog and could get out of control
						// a work around would be to put a timer or counter and
						// try to stop when things get out of control
						// for now we will just place two of them
						// while (true) {
							PlaceFile( files[ 0 ] );
							PlaceFile( files[ 0 ] );
						// }
					}

					catch(error) {
						// drbrownserv.alert (error + "A:A" + error.line);
					}

				} else {
					
					for ( var i = 0; i < files.length; i++ ) {
			
						try {
							PlaceFile( files[ i ] );
						}
						
						catch(error) {
							// drbrownserv.alert (error + ":T:T:" + error.line);
						}
					}

				}

				firstLayer.remove();

				delete PlaceFile;

			}
		}
		
		catch (error) {
			if (error.number != 8007) // Don't report user cancelled errors.
				drbrownserv.alert (error); //  + ":" + error.line);
		}
	}


	//-----------------------------------------------------------------
	// This routine is called when the Bridge's PDF Presentation menu
	// item is chosen.
	//-----------------------------------------------------------------
	drbrownserv.drBrownsPlaceAMaticFromBridge8 = function () {
		try {
			var files = photoshop.getBridgeFileListForAutomateCommand (false);

			if (files.length != 0)
				drbrownserv.drBrownsPlaceAMatic (files, 8);
		}
		
		catch (error) {
			if (error.number != 8007) // Don't report user cancelled errors.
				drbrownserv.alert (error); //  + ":" + error.line);
		}

	}

	//-----------------------------------------------------------------
	// This routine is called when the Bridge's PDF Presentation menu
	// item is chosen.
	//-----------------------------------------------------------------
	drbrownserv.drBrownsPlaceAMaticFromBridge16 = function () {
		try {
			var files = photoshop.getBridgeFileListForAutomateCommand (false);

			if (files.length != 0)
				drbrownserv.drBrownsPlaceAMatic (files, 16);
		}
		
		catch (error) {
			if (error.number != 8007) // Don't report user cancelled errors.
				drbrownserv.alert (error); //  + ":" + error.line);
		}

	}

	//-----------------------------------------------------------------
	// The code below inserts menus in reverse order
	//-----------------------------------------------------------------

	//-----------------------------------------------------------------
	// The code below inserts
	//-----------------------------------------------------------------
//~ 	if (BridgeTalk.appName == "bridge") {	
//~ 		// Use temp function to keep vars out of global namespace.
//~ 		drbrownserv.tempFunction = function () {
//~ 			// Set up the info necessary for inserting this item into the Bridge's menus later.
//~ 			var menuItemInfo = new Object;
//~ 			menuItemInfo.text = "Dr. Brown's Black-n-White";
//~ 			menuItemInfo.name = 'DrBrownBlackAndWhite';
//~ 			menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
//~ 			menuItemInfo.onSelect = drbrownserv.blackandwhiteFromBridge;
//~ 			
//~ 			drbrownserv.menuItemInfoArray.push (menuItemInfo);
//~ 			}
//~ 		
//~ 		drbrownserv.tempFunction ();
//~ 		delete drbrownserv.tempFunction;
//~ 		}


	//-----------------------------------------------------------------
	// The code below inserts
	//-----------------------------------------------------------------
//~ REMOVE THE MANUAL CORRECT FROM THE MENU, KEEP THE CODE
//~ 	if (BridgeTalk.appName == "bridge") {	
//~ 		// Use temp function to keep vars out of global namespace.
//~ 		drbrownserv.tempFunction = function () {
//~ 			// Set up the info necessary for inserting this item into the Bridge's menus later.
//~ 			var menuItemInfo = new Object;
//~ 			menuItemInfo.text = "Dr. Brown's Manual Correct";
//~ 			menuItemInfo.name = 'DrBrownManualCorrect';
//~ 			menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
//~ 			menuItemInfo.onSelect = drbrownserv.manualcorrectFromBridge;
//~ 			
//~ 			drbrownserv.menuItemInfoArray.push (menuItemInfo);
//~ 			}
//~ 		
//~ 		drbrownserv.tempFunction ();
//~ 		delete drbrownserv.tempFunction;
//~ 		}
//~ REMOVE THE MANUAL CORRECT FROM THE MENU, KEEP THE CODE


	//-----------------------------------------------------------------
	// The code below inserts
	//-----------------------------------------------------------------
//~ REMOVE THE AUTO CORRECT FROM THE MENU, KEEP THE CODE
//~ 	if (BridgeTalk.appName == "bridge") {	
//~ 		// Use temp function to keep vars out of global namespace.
//~ 		drbrownserv.tempFunction = function () {
//~ 			// Set up the info necessary for inserting this item into the Bridge's menus later.
//~ 			var menuItemInfo = new Object;
//~ 			menuItemInfo.text = "Dr. Brown's Auto Correct";
//~ 			menuItemInfo.name = 'DrBrownAutoCorrect';
//~ 			menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
//~ 			menuItemInfo.onSelect = drbrownserv.autocorrectFromBridge;
//~ 			
//~ 			drbrownserv.menuItemInfoArray.push (menuItemInfo);
//~ 			}
//~ 		
//~ 		drbrownserv.tempFunction ();
//~ 		delete drbrownserv.tempFunction;
//~ 		}
//~ REMOVE THE AUTO CORRECT FROM THE MENU, KEEP THE CODE


	//-----------------------------------------------------------------
	// The code below inserts separater
	//-----------------------------------------------------------------
//~ 	if (BridgeTalk.appName == "bridge") {	
//~ 		// Use temp function to keep vars out of global namespace.
//~ 		drbrownserv.tempFunction = function () {
//~ 			// Set up the info necessary for inserting this item into the Bridge's menus later.
//~ 			var menuItemInfo = new Object;
//~ 			menuItemInfo.text = "-----";
//~ 			menuItemInfo.name = '-----';
//~ 			//menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
//~ 			//menuItemInfo.onSelect = drbrownserv.captionmakerFromBridge;
//~ 			
//~ 			drbrownserv.menuItemInfoArray.push (menuItemInfo);
//~ 			}
//~ 		
//~ 		drbrownserv.tempFunction ();
//~ 		delete drbrownserv.tempFunction;
//~ 		}


	//-----------------------------------------------------------------
	// The code below inserts the Dr. Brown's Place-A-Matic 16 bit menu item 
	// into the Bridge menus.
	//-----------------------------------------------------------------
	if (BridgeTalk.appName == "bridge") {
		// Use temp function to keep vars out of global namespace.
		drbrownserv.tempFunction = function () {
			// Set up the info necessary for inserting this item into the Bridge's menus later.
			var menuItemInfo = new Object;
			menuItemInfo.text = "Dr. Brown's Place-A-Matic 16 bit"; 
			menuItemInfo.name = "DrBrownsPlaceAMatic16";
			menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
			menuItemInfo.onSelect = drbrownserv.drBrownsPlaceAMaticFromBridge16;
		
			drbrownserv.menuItemInfoArray.push (menuItemInfo);
		}
	
		drbrownserv.tempFunction ();
		delete drbrownserv.tempFunction;
	}

	
	//-----------------------------------------------------------------
	// The code below inserts the Dr. Brown's Place-A-Matic 8 bit menu item 
	// into the Bridge menus.
	//-----------------------------------------------------------------
	if (BridgeTalk.appName == "bridge") {
		// Use temp function to keep vars out of global namespace.
		drbrownserv.tempFunction = function () {
			// Set up the info necessary for inserting this item into the Bridge's menus later.
			var menuItemInfo = new Object;
			menuItemInfo.text = "Dr. Brown's Place-A-Matic 8 bit"; 
			menuItemInfo.name = "DrBrownsPlaceAMatic8";
			menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
			menuItemInfo.onSelect = drbrownserv.drBrownsPlaceAMaticFromBridge8;
		
			drbrownserv.menuItemInfoArray.push (menuItemInfo);
		}
	
		drbrownserv.tempFunction ();
		delete drbrownserv.tempFunction;
	}

	
	//-----------------------------------------------------------------
	// The code below inserts the Dr. Brown's Slide Show menu item 
	// into the Bridge menus. This only works in CS3 or better.
	//-----------------------------------------------------------------
//~ 	if (BridgeTalk.appName == "bridge") {
//~ 		// Use temp function to keep vars out of global namespace.
//~ 		drbrownserv.tempFunction = function () {
//~ 			// Set up the info necessary for inserting this item into the Bridge's menus later.
//~ 			var menuItemInfo = new Object;
//~ 			menuItemInfo.text = "Dr. Brown's Slide Show"; 
//~ 			menuItemInfo.name = "DrBrownsSlideShow";
//~ 			menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
//~ 			menuItemInfo.onSelect = drbrownserv.drBrownsSlideShowFromBridge;
//~ 		
//~ 			drbrownserv.menuItemInfoArray.push (menuItemInfo);
//~ 		}
//~ 	
//~ 		drbrownserv.tempFunction ();
//~ 		delete drbrownserv.tempFunction;
//~ 	}

	
	//-----------------------------------------------------------------
	// The code below inserts the Dr. Brown's Merge-A-Matic menu item 
	// into the Bridge menus. This only works in CS3 or better.
	//-----------------------------------------------------------------
//~	if (BridgeTalk.appName == "bridge") {
//~		// Use temp function to keep vars out of global namespace.
//~		drbrownserv.tempFunction = function () {
//~			// Set up the info necessary for inserting this item into the Bridge's menus later.
//~			var menuItemInfo = new Object;
//~			menuItemInfo.text = "Dr. Brown's Merge-A-Matic"; 
//~			menuItemInfo.name = "DrBrownsMergeAMatic";
//~			menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
//~			menuItemInfo.onSelect = drbrownserv.drBrownsMergeAMaticFromBridge;
//~		
//~			drbrownserv.menuItemInfoArray.push (menuItemInfo);
//~		}
//~	
//~		drbrownserv.tempFunction ();
//~		delete drbrownserv.tempFunction;
//~	}

	
	//-----------------------------------------------------------------
	// The code below inserts the Dr. Brown's Stack-A-Matic menu item 
	// into the Bridge menus. This only works in CS3 or better.
	//-----------------------------------------------------------------
	if (BridgeTalk.appName == "bridge") {
		// Use temp function to keep vars out of global namespace.
		drbrownserv.tempFunction = function () {
			// Set up the info necessary for inserting this item into the Bridge's menus later.
			var menuItemInfo = new Object;
			menuItemInfo.text = "Dr. Brown's Stack-A-Matic"; 
			menuItemInfo.name = "DrBrownsStackAMatic";
			menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
			menuItemInfo.onSelect = drbrownserv.drBrownsStackAMaticFromBridge;
		
			drbrownserv.menuItemInfoArray.push (menuItemInfo);
		}
	
		drbrownserv.tempFunction ();
		delete drbrownserv.tempFunction;
	}

	
	//-----------------------------------------------------------------
	// The code below inserts separater
	//-----------------------------------------------------------------
	if (BridgeTalk.appName == "bridge") {	
		// Use temp function to keep vars out of global namespace.
		drbrownserv.tempFunction = function () {
			// Set up the info necessary for inserting this item into the Bridge's menus later.
			var menuItemInfo = new Object;
			menuItemInfo.text = "------";
			menuItemInfo.name = 'foo1';
			//menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
			//menuItemInfo.onSelect = drbrownserv.captionmakerFromBridge;
			
			drbrownserv.menuItemInfoArray.push (menuItemInfo);
			}
		
		drbrownserv.tempFunction ();
		delete drbrownserv.tempFunction;
		}

	//-----------------------------------------------------------------
	// The code below inserts the Dr. Brown's 1-2-3 Process menu item into the
	// Bridge menus.
	//-----------------------------------------------------------------
	if (BridgeTalk.appName == "bridge") {	
		// Use temp function to keep vars out of global namespace.
		drbrownserv.tempFunction = function () {
			// Set up the info necessary for inserting this item into the Bridge's menus later.
			var menuItemInfo = new Object;
			menuItemInfo.text = "Dr. Brown's 1-2-3 Process";
			menuItemInfo.name = 'Process123';
			menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
			menuItemInfo.onSelect = drbrownserv.process123FromBridge;
			
			drbrownserv.menuItemInfoArray.push (menuItemInfo);
			}
		
		drbrownserv.tempFunction ();
		delete drbrownserv.tempFunction;
		}


	//-----------------------------------------------------------------
	// The code below inserts the Dr. Brown's Caption Maker menu item into the
	// Bridge menus.
	//-----------------------------------------------------------------
 	//if (BridgeTalk.appName == "bridge") {	
	//	// Use temp function to keep vars out of global namespace.
 	//	drbrownserv.tempFunction = function () {
 	//		// Set up the info necessary for inserting this item into the Bridge's menus later.
 	//		var menuItemInfo = new Object;
 	//		menuItemInfo.text = "Dr. Brown's Caption Maker";
 	//		menuItemInfo.name = 'CaptionMaker';
 	//		menuItemInfo.onDisplay = drbrownserv.alwaysEnabled;
 	//		menuItemInfo.onSelect = drbrownserv.captionmakerFromBridge;
 	//		
 	//		drbrownserv.menuItemInfoArray.push (menuItemInfo);
 	//		}
	//	
 	//	drbrownserv.tempFunction ();
 	//	delete drbrownserv.tempFunction;
 	//	}


	//=================================================================
	// Setup Tools > Photoshop menu in Bridge.
	// Creates the menu, then sorts all the menu items we want to
	// create before actually adding them to the menu.
	//=================================================================

	if (BridgeTalk.appName == "bridge") {
	
		// Use temp function to keep vars out of global namespace.
		drbrownserv.tempFunction = function () {
			// The 'Photoshop Services' menu is installed by OLS, the 'Photoshop' menu
			// in installed either by this script, or by the Workflow Automation Scripts
			// (AdobeLibrary1.jsx) which also install menus for other apps. To get the
			// menus in the correct order, all three scripts cooperate - so make sure
			// you are aware of what's happening before changing this code.
			var psServicesMenuExists = MenuElement.find ('Tools/DrBrownsServices') != null;
		
			// Add a new Photoshop submenu in the Bridge's Tools menu.
			drBrownsSubMenu = MenuElement.create (	"menu",
													"Dr. Brown's Services " + drbrownserv.version,
													'-after submenu/VersionCue', 
													'tools/drbr');

			drBrownsSubMenu.onDisplay = drbrownserv.alwaysEnabled;
		
			// Define a function that will sort the menu items for us.
			function menuTextOrder (a, b) {
				// Pass 'a' into 'b' to get reverse sort order so that they can be
				// added at the top of the menu and still be in alphabetical order
				// (the WAS scripts install additional menu items that end up below
				// these).
				return b.text.toLocaleLowerCase ().localeCompare (a.text.toLocaleLowerCase ());
			}
		
			// Sort the menu items
			// drbrownserv.menuItemInfoArray.sort (menuTextOrder);
		
			// Add the menu items to the Photoshop menu.
			for (var index = 0; index < drbrownserv.menuItemInfoArray.length; index++) {
				var menuItemInfo = drbrownserv.menuItemInfoArray[index];

				var menuItem = MenuElement.create (	'command',
													menuItemInfo.text,
													'at the beginning of tools/drbr',
													menuItemInfo.name);
			
				menuItem.onDisplay = menuItemInfo.onDisplay;
				menuItem.onSelect = menuItemInfo.onSelect;	
			}
		
			delete drbrownserv.menuItemInfoArray;
		}
		
		drbrownserv.tempFunction ();
		delete drbrownserv.tempFunction;
	}


	//=================================================================
	// Mini Processor
	// Sets up Dr. Brown's Mini Processor JavaScript to be
	// accessed from the Bridge.
	//=================================================================


	//=================================================================
	// main routine for Mini Processor
	//=================================================================
//~ 	drbrownserv.miniprocessor = function (infiles, autoMode, makeFolder, bwMode) {
//~ 		try {
//~ 			if (BridgeTalk.appName != "photoshop") {
//~ 				BridgeTalk.bringToFront ("photoshop");

//~ 				var outfiles = drbrownserv.findNewHomeForFiles (infiles, autoMode, makeFolder, bwMode, true); // last param is for making a copy
//~ 				var btMessage = new BridgeTalk;
//~ 				btMessage.target = "photoshop";
//~ 				btMessage.body = "drbrownserv.miniprocessor (" + outfiles.toSource () + "," + autoMode + "," + makeFolder + "," + bwMode + ");";
//~ 				btMessage.send ();
//~ 			} else {

//~ 				try {

//~ 					var rememberDialogModes = app.displayDialogs;
//~ 					app.displayDialogs = DialogModes.NO;

//~ 					var jpegQ = new JPEGSaveOptions();
//~ 					jpegQ.quality = 12;

//~ 					if (bwMode) {
//~ 						try {
//~ 							for (var i = 0; i < infiles.length; i++) {
//~ 								app.open( infiles[i] );
//~ 								var d = app.activeDocument;
//~ 								
//~ 								d.flatten();

//~ 								/* all of this was the old way, in cs3 we just let photoshop do all this work
//~ 								d.changeMode( ChangeMode.LAB );
//~ 								d.activeChannels = [d.activeChannels[0]];
//~ 								d.changeMode( ChangeMode.GRAYSCALE );
//~ 								
//~ 								// set selection to current channel
//~ 								// =======================================================
//~ 								var id61 = charIDToTypeID( "setd" );
//~ 								var desc15 = new ActionDescriptor();
//~ 								var id62 = charIDToTypeID( "null" );
//~ 								var ref10 = new ActionReference();
//~ 								var id63 = charIDToTypeID( "Chnl" );
//~ 								var id64 = charIDToTypeID( "fsel" );
//~ 								ref10.putProperty( id63, id64 );
//~ 								desc15.putReference( id62, ref10 );
//~ 								var id65 = charIDToTypeID( "T   " );
//~ 								var ref11 = new ActionReference();
//~ 								var id66 = charIDToTypeID( "Chnl" );
//~ 								var id67 = charIDToTypeID( "Ordn" );
//~ 								var id68 = charIDToTypeID( "Trgt" );
//~ 								ref11.putEnumerated( id66, id67, id68 );
//~ 								desc15.putReference( id65, ref11 );
//~ 								executeAction( id61, desc15, DialogModes.NO );
//~ 								desc15 = null;
//~ 								ref10 = null;
//~ 								ref11 = null;

//~ 								d.selection.invert();
//~ 								d.changeMode( ChangeMode.RGB );
//~ 								d.artLayers.add();
//~ 								
//~ 								// make new channel at mask channel using reveal selection
//~ 								// =======================================================
//~ 								var id147 = charIDToTypeID( "Mk  " );
//~ 								var desc34 = new ActionDescriptor();
//~ 								var id148 = charIDToTypeID( "Nw  " );
//~ 								var id149 = charIDToTypeID( "Chnl" );
//~ 								desc34.putClass( id148, id149 );
//~ 								var id150 = charIDToTypeID( "At  " );
//~ 								var ref20 = new ActionReference();
//~ 								var id151 = charIDToTypeID( "Chnl" );
//~ 								var id152 = charIDToTypeID( "Chnl" );
//~ 								var id153 = charIDToTypeID( "Msk " );
//~ 								ref20.putEnumerated( id151, id152, id153 );
//~ 								desc34.putReference( id150, ref20 );
//~ 								var id154 = charIDToTypeID( "Usng" );
//~ 								var id155 = charIDToTypeID( "UsrM" );
//~ 								var id156 = charIDToTypeID( "RvlS" );
//~ 								desc34.putEnumerated( id154, id155, id156 );
//~ 								executeAction( id147, desc34, DialogModes.NO );
//~ 								desc34 = null;
//~ 								ref20 = null;

//~ 								// skipping - select current channel with make visible
//~ 								// skipping - select current channel
//~ 								d.activeLayer.blendMode = BlendMode.MULTIPLY;

//~ 								// =======================================================
//~ 								var id9 = charIDToTypeID( "slct" );
//~ 								var desc3 = new ActionDescriptor();
//~ 								var id10 = charIDToTypeID( "null" );
//~ 								var ref2 = new ActionReference();
//~ 								var id11 = charIDToTypeID( "Chnl" );
//~ 								var id12 = charIDToTypeID( "Chnl" );
//~ 								var id13 = charIDToTypeID( "RGB " );
//~ 								ref2.putEnumerated( id11, id12, id13 );
//~ 								desc3.putReference( id10, ref2 );
//~ 								executeAction( id9, desc3, DialogModes.NO );
//~ 								desc3 = null;
//~ 								ref2 = null;

//~ 								// fill using color hue 40.9 saturation 61.569 brightness 58.039 opacity 100 mode normal
//~ 								// =======================================================
//~ 								var id233 = charIDToTypeID( "Fl  " );
//~ 								var desc50 = new ActionDescriptor();
//~ 								var id234 = charIDToTypeID( "Usng" );
//~ 								var id235 = charIDToTypeID( "FlCn" );
//~ 								var id236 = charIDToTypeID( "Clr " );
//~ 								desc50.putEnumerated( id234, id235, id236 );
//~ 								var id237 = charIDToTypeID( "Clr " );
//~ 								var desc51 = new ActionDescriptor();
//~ 								var id238 = charIDToTypeID( "H   " );
//~ 								var id239 = charIDToTypeID( "#Ang" );
//~ 								desc51.putUnitDouble( id238, id239, 40.9 );
//~ 								var id240 = charIDToTypeID( "Strt" );
//~ 								desc51.putDouble( id240, 61.569 );
//~ 								var id241 = charIDToTypeID( "Brgh" );
//~ 								desc51.putDouble( id241, 58.039 );
//~ 								var id242 = charIDToTypeID( "HSBC" );
//~ 								desc50.putObject( id237, id242, desc51 );
//~ 								var id243 = charIDToTypeID( "Opct" );
//~ 								var id244 = charIDToTypeID( "#Prc" );
//~ 								desc50.putUnitDouble( id243, id244, 100.000000 );
//~ 								var id245 = charIDToTypeID( "Md  " );
//~ 								var id246 = charIDToTypeID( "BlnM" );
//~ 								var id247 = charIDToTypeID( "Nrml" );
//~ 								desc50.putEnumerated( id245, id246, id247 );
//~ 								executeAction( id233, desc50, DialogModes.NO );
//~ 								desc50 = null;
//~ 								desc51 = null;

//~ 								*/
//~ 								// if first doc then pop hue sat dialog and get settings
//~ 								if ( i == 0 ) {
//~ 									
//~ 									// there is no way to tell the difference between 'cancel' and 'ok' with no edits
//~ 									// users will need to hit the esc key to actually stop the script
//~ 									var hueSatDesc;
//~ 									try {
//~     									var id27 = charIDToTypeID( "BanW" ); // was "HStr" );
//~ 									    hueSatDesc = executeAction( id27, undefined, DialogModes.ALL );
//~ 									}
//~ 									catch( e ) {
//~ 									    hueSatDesc = undefined;
//~ 									}
//~ 								
//~ 								} else {
//~ 									executeAction( id27, hueSatDesc, DialogModes.NO );
//~ 								}

//~ 								// really, even on PSD and TIFF and PDF
//~ 								// d.flatten(); i do this abovve as well
//~ 								
//~ 								// we need the q factor or we get annoying dialogs
//~ 								// check the extension and slide it up to the max for now

//~ 								drbrownserv.saveFile( d, jpegQ );

//~ 							} // main for loop ends here

//~ 							hueSatDesc = null;
//~ 							$.gc();

//~ 						}
//~ 						catch(e) {
//~ 							// for debugging only drbrownserv.alert(e +":"+ e.line);
//~ 						}
//~ 					} else {
//~ 						var i = 0;
//~ 						if (!autoMode) {
//~ 							i = 1;
//~ 							app.open( infiles[0] );

//~                             // an ok with no adjustment throws a user canceled error, catch all errors and proceed on
//~     						// users will need to hit the esc key to actually stop the script
//~ 							var levelsDesc;
//~                             try {
//~     							var id19 = charIDToTypeID( "Lvls" );
//~ 							    levelsDesc = executeAction( id19, undefined, DialogModes.ALL );
//~ 							}
//~ 							catch( error ) {
//~ 							    levelsDesc = undefined;
//~ 							}

//~                             // an ok with no adjustment throws a user canceled error, catch all errors and proceed on
//~     						// users will need to hit the esc key to actually stop the script
//~                             var hueSatDesc;
//~ 							try {
//~     							var id27 = charIDToTypeID( "HStr" );
//~     							hueSatDesc = executeAction( id27, undefined, DialogModes.ALL );
//~     						}
//~     						catch( error ) {
//~     						    hueSatDesc = undefined;
//~     						}

//~ 							drbrownserv.saveFile( app.activeDocument, jpegQ );
//~ 						}
//~ 						for (/* nothing here on purpose see above for i init */; i < infiles.length; i++) {
//~ 							app.open( infiles[i] );
//~ 							if (autoMode) {
//~                                 
//~                                 // This is auto color
//~ 								var id3 = charIDToTypeID( "Lvls" );
//~ 								var desc2 = new ActionDescriptor();
//~ 								var id4 = stringIDToTypeID( "autoBlackWhite" );
//~ 								desc2.putBoolean( id4, true );
//~ 								var id5 = stringIDToTypeID( "autoNeutrals" );
//~ 								desc2.putBoolean( id5, true );
//~ 								executeAction( id3, desc2, DialogModes.NO );
//~ 								desc2 = null;

//~ 								app.activeDocument.activeLayer.autoContrast();

//~ 							} else {
//~ 								executeAction( id19, levelsDesc, DialogModes.NO );
//~ 								executeAction( id27, hueSatDesc, DialogModes.NO );
//~ 							}
//~ 							drbrownserv.saveFile( app.activeDocument, jpegQ );
//~ 						}	
//~ 					}
//~ 					app.displayDialogs = rememberDialogModes;
//~ 					$.gc();
//~ 				}
//~ 				catch(error) {
//~         			if (error.number != 8007) { // Don't report user cancelled errors.
//~ 		    			drbrownserv.alert(error + ":" + error.line);
//~ 		    		}
//~ 				}
//~ 			}
//~ 		}
//~ 		catch (error) {
//~ 			if (error.number != 8007) { // Don't report user cancelled errors.
//~ 				drbrownserv.alert (error + ":" + error.line);
//~ 			}
//~ 		}
//~ 	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: descriptorToObject
	// Usage: update a JavaScript Object from an ActionDescriptor
	// Input: JavaScript Object (o), current object to update (output)
	//        Photoshop ActionDescriptor (d), descriptor to pull new params for object from
	//        JavaScript Function (f), post process converter utility to convert
	// Return: Nothing, update is applied to passed in JavaScript Object (o)
	// NOTE: Only boolean, string, and number are supported, use a post processor
	//       to convert (f) other types to one of these forms.
	///////////////////////////////////////////////////////////////////////////////
	drbrownserv.descriptorToObject = function  (o, d, f) {
		var l = d.count;
		for (var i = 0; i < l; i++ ) {
			var k = d.getKey(i); // i + 1 ?
			var t = d.getType(k);
			strk = app.typeIDToStringID(k);
			switch (t) {
				case DescValueType.BOOLEANTYPE:
					o[strk] = d.getBoolean(k);
					break;
				case DescValueType.STRINGTYPE:
					o[strk] = d.getString(k);
					break;
				case DescValueType.DOUBLETYPE:
					o[strk] = d.getDouble(k);
					break;
				case DescValueType.INTEGERTYPE:
				case DescValueType.ALIASTYPE:
				case DescValueType.CLASSTYPE:
				case DescValueType.ENUMERATEDTYPE:
				case DescValueType.LISTTYPE:
				case DescValueType.OBJECTTYPE:
				case DescValueType.RAWTYPE:
				case DescValueType.REFERENCETYPE:
				case DescValueType.UNITDOUBLE:
				default:
					throw( new Error("Unsupported type in descriptorToObject " + t ) );
			}
		}
		if (undefined != f) {
			o = f(o);
		}
	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: objectToDescriptor
	// Usage: create an ActionDescriptor from a JavaScript Object
	// Input: JavaScript Object (o)
	//        Pre process converter (f)
	// Return: ActionDescriptor
	// NOTE: Only boolean, string, and number are supported, use a pre processor
	//       to convert (f) other types to one of these forms.
	///////////////////////////////////////////////////////////////////////////////
	drbrownserv.objectToDescriptor = function  (o, f) {
		if (undefined != f) {
			o = f(o);
		}
		var d = new ActionDescriptor;
		var l = o.reflect.properties.length;
		for (var i = 0; i < l; i++ ) {
			var k = o.reflect.properties[i].toString();
			if (k == "__proto__" || k == "__count__" || k == "__class__" || k == "reflect")
				continue;
			var v = o[ k ];
			k = app.stringIDToTypeID(k);
			switch ( typeof(v) ) {
				case "boolean":
					d.putBoolean(k, v);
					break;
				case "string":
					d.putString(k, v);
					break;
				case "number":
					d.putDouble(k, v);
					break;
				default:
					throw( new Error("Unsupported type in objectToDescriptor " + typeof(v) ) );
			}
		}
		return d;
	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: getMetaData
	// Usage: Pull the meta data from the correct spot using the layout 
	// in the File Browser "File Properties" "IPTC" "Camera Data (EXIF)" "Camera Raw"
	///////////////////////////////////////////////////////////////////////////////
//~ 	drbrownserv.getMetaData = function ( inString, verbose ) {
//~ 		var lString = inString.toLowerCase();
//~ 		var outTitle;
//~ 		var outData;
//~ 		// "File Properties"
//~ 		if ( 'filename' == lString ) {
//~ 			outTitle = "Filename";
//~ 			outData = app.activeDocument.name;
//~ 		} else if ( 'date created' == lString ) {
//~ 			outTitle = "Date Created";
//~ 			outData = drbrownserv.getXMP( 'xap:CreateDate' );
//~ 		} else if ( 'date file modified' == lString ) {
//~ 			outTitle = "Date File Modified";
//~ 			outData = drbrownserv.getXMP( 'xap:ModifyDate' );
//~ 		} else if ( 'document kind' == lString ) {
//~ 			outTitle = "Document Kind";
//~ 			outData = drbrownserv.getDocumentKind();
//~ 		} else if ( 'width' == lString ) {
//~ 			outTitle = "Width";
//~ 			outData = app.activeDocument.width;
//~ 		} else if ( 'height' == lString ) {
//~ 			outTitle = "Height";
//~ 			outData = app.activeDocument.height;
//~ 		} else if ( 'color mode' == lString ) {
//~ 			outTitle = "Color Mode";
//~ 			outData = ColorModeToString();
//~ 		} else if ( 'resolution' == lString ) {
//~ 			outTitle = "Resolution";
//~ 			outData = app.activeDocument.resolution;
//~ 		} else if ( 'color profile' == lString ) {
//~ 			outTitle = "Color Profile";
//~ 			try {
//~ 				outData = app.activeDocument.colorProfileName;
//~ 			}
//~ 			catch( e ) {
//~ 				outData = "Untagged";
//~ 			}
//~ 		} else if ( 'bit depth' == lString ) {
//~ 			outTitle = "Bit Depth";
//~ 			outData = app.activeDocument.bitsPerChannel;
//~ 		} else if ( 'documentid' == lString ) {
//~ 			outTitle = "DocumentID";
//~ 			outData = drbrownserv.getXMP( 'xapMM:DocumentID' );
//~ 		} else if ( 'document creator' == lString ) {
//~ 			outTitle = "Document Creator";
//~ 			outData = app.activeDocument.info.author;
//~ 		} else if ( 'copyright notice' == lString ) {
//~ 			outTitle = "Copyright Notice";
//~ 			outData = drbrownserv.getCopyrightNotice();
//~ 		// "IPTC"
//~ 		} else if ( 'description' == lString ) {
//~ 			outTitle = "Description";
//~ 			outData = app.activeDocument.info.caption;
//~ 		} else if ( 'description writer' == lString ) {
//~ 			outTitle = "Description Writer";
//~ 			outData = app.activeDocument.info.captionWriter;
//~ 		} else if ( 'headline' == lString ) {
//~ 			outTitle = "Headline";
//~ 			outData = app.activeDocument.info.headline;
//~ 		} else if ( 'instructions' == lString ) {
//~ 			outTitle = "Instructions";
//~ 			outData = app.activeDocument.info.instructions;
//~ 		} else if ( 'keywords' == lString ) {
//~ 			outTitle = "Keywords";
//~ 			outData = app.activeDocument.info.keywords;
//~ 		} else if ( 'author' == lString ) {
//~ 			outTitle = "Author";
//~ 			outData = app.activeDocument.info.author;
//~ 		} else if ( 'author title' == lString ) {
//~ 			outTitle = "Author Title";
//~ 			outData = app.activeDocument.info.authorPosition;
//~ 		} else if ( 'credit' == lString ) {
//~ 			outTitle = "Credit";
//~ 			outData = app.activeDocument.info.credit;
//~ 		} else if ( 'source' == lString ) {
//~ 			outTitle = "Source";
//~ 			outData = app.activeDocument.info.source;
//~ 		} else if ( 'categories' == lString ) {
//~ 			outTitle = "Categories";
//~ 			outData = app.activeDocument.info.category;
//~ 		} else if ( 'supplemental categories' == lString ) {
//~ 			outTitle = "Supplemental Categories";
//~ 			outData = app.activeDocument.info.supplementalCategories;
//~ 		} else if ( 'document title' == lString ) {
//~ 			outTitle = "Document Title";
//~ 			outData = app.activeDocument.info.title;
//~ 		} else if ( 'date subject created' == lString ) {
//~ 			outTitle = "Date Subject Created";
//~ 			outData = app.activeDocument.info.creationDate;
//~ 		} else if ( 'city' == lString ) {
//~ 			outTitle = "City";
//~ 			outData = app.activeDocument.info.city;
//~ 		} else if ( 'state/province' == lString ) {
//~ 			outTitle = "State/Province";
//~ 			outData = app.activeDocument.info.provinceState;
//~ 		} else if ( 'country' == lString ) {
//~ 			outTitle = "Country";
//~ 			outData = app.activeDocument.info.country;
//~ 		} else if ( 'transmission reference' == lString ) {
//~ 			outTitle = "Transmission Reference";
//~ 			outData = app.activeDocument.info.transmissionReference;
//~ 		} else if ( 'copyright' == lString ) {
//~ 			outTitle = "Copyright";
//~ 			outData = app.activeDocument.info.copyrightNotice;
//~ 		} else if ( 'copyright info url' == lString ) {
//~ 			outTitle = "Copyright Info URL";
//~ 			outData = app.activeDocument.info.ownerUrl;
//~ 		} else if ( 'urgency' == lString ) {
//~ 			outTitle = "Urgency";
//~ 			outData = UrgencyToString();
//~ 		} else if ( 'current date' == lString ) {
//~ 			outTitle = "Current Date";
//~ 			outData = new Date();
//~ 			if ( false /*gShowTime*/ ) {
//~ 				outData = outData.toLocaleString();
//~ 			} else {
//~ 				outData = outData.toLocaleDateString();
//~ 			}
//~ 		// IPTC Core
//~ 		} else if ( 'intellectual genre' == lString ) {
//~ 			outTitle = "Intellectual Genre";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:IntellectualGenre" );
//~ 		} else if ( 'location' == lString ) {
//~ 			outTitle = "Location";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:Location" );
//~ 		} else if ( 'iso country code' == lString ) {
//~ 			outTitle = "ISO Country Code";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:CountryCode" );
//~ 		} else if ( 'creator address' == lString ) {
//~ 			outTitle = "Creator Address";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:CiAdrExtadr" );
//~ 		} else if ( 'creator city' == lString ) {
//~ 			outTitle = "Creator City";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:CiAdrCity" );
//~ 		} else if ( 'creator state/province' == lString ) {
//~ 			outTitle = "Creator State/Province";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:CiAdrRegion" );
//~ 		} else if ( 'creator postal code' == lString ) {
//~ 			outTitle = "Creator Postal Code";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:CiAdrPcode" );
//~ 		} else if ( 'creator country' == lString ) {
//~ 			outTitle = "Creator Country";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:CiAdrCtry" );
//~ 		} else if ( 'creator phone' == lString ) {
//~ 			outTitle = "Creator Phone";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:CiTelWork" );
//~ 		} else if ( 'creator email' == lString ) {
//~ 			outTitle = "Creator Email";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:CiEmailWork" );
//~ 		} else if ( 'creator website' == lString ) {
//~ 			outTitle = "Creator Website";
//~ 			outData = drbrownserv.getXMP( "Iptc4xmpCore:CiUrlWork" );
//~ 		}
//~ 		
//~ 		// "EXIF"
//~ 		if ( undefined == outTitle ) {
//~ 			outData = drbrownserv.getEXIF( inString );
//~ 			if ( undefined != outData ) {
//~ 				outTitle = inString;
//~ 			}
//~ 		}
//~ 		// "XMP"
//~ 		if ( undefined == outTitle ) {
//~ 			outData = drbrownserv.getXMP( inString );
//~ 			if ( undefined != outData ) {
//~ 				outTitle = inString;
//~ 			}
//~ 		}

//~ 		outData = drbrownserv.prettyDate( outData );

//~ 		if ( verbose ) {
//~ 			outData = outTitle + ": " + outData;
//~ 		}
//~ 		return outData;
//~ 	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: getXMP
	// Usage: Search the raw XMP for the given string, sure would be nice to have
	//        an actual XML parser
	///////////////////////////////////////////////////////////////////////////////
//~ 	drbrownserv.getXMP = function ( inString ) {
//~ 		var xmp = app.activeDocument.xmpMetadata.rawData;
//~ 		var strCombined = '<' + inString + '>';
//~ 		var startMarker = xmp.indexOf( strCombined ) + strCombined.length;
//~ 		var endMarker = xmp.indexOf( '</' + inString + '>' );
//~ 		if ( -1 == endMarker ) return '';
//~ 		return xmp.substring( startMarker, endMarker );
//~ 	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: urgencyToString
	// Usage: Make a pretty string from the urgency enums
	///////////////////////////////////////////////////////////////////////////////
//~ 	drbrownserv.urgencyToString = function () {
//~ 		switch ( app.activeDocument.info.urgency ) {
//~ 			case Urgency.FOUR:
//~ 				return 'Urgency four';
//~ 			case Urgency.HIGH:
//~ 				return 'Urgency high';
//~ 			case Urgency.LOW:
//~ 				return 'Urgency low';
//~ 			case Urgency.NONE:
//~ 				return 'Urgency none';
//~ 			case Urgency.NORMAL:
//~ 				return 'Urgency normal';
//~ 			case Urgency.SEVEN:
//~ 				return 'Urgency seven';
//~ 			case Urgency.SIX:
//~ 				return 'Urgency six';
//~ 			case Urgency.THREE:
//~ 				return 'Urgency three';
//~ 			case Urgency.TWO:
//~ 				return 'Urgency two';
//~ 		}
//~ 		return '';
//~ 	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: copyRightedToString
	// Usage: Make a pretty string from the copyright enums
	///////////////////////////////////////////////////////////////////////////////
//~ 	drbrownserv.copyRightedToString = function () {
//~ 		switch ( app.activeDocument.info.copyrighted ) {
//~ 			case CopyrightedType.COPYRIGHTEDWORK:
//~ 				return 'Copyrighted Work';
//~ 			case CopyrightedType.PUBLICDOMAIN:
//~ 				return 'Public Domain';
//~ 			case CopyrightedType.UNMARKED:
//~ 				return 'Unmarked';
//~ 		}
//~ 		return '';
//~ 	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: getEXIF
	// Usage: Exif comes in pairs, "Mode" and then the string for the Mode
	///////////////////////////////////////////////////////////////////////////////
//~ 	drbrownserv.getEXIF = function ( inString ) {
//~ 		var exifData = app.activeDocument.info.exif;
//~ 		for ( var i = 0; i < exifData.length; i++ ) {
//~ 			if ( exifData[ i ][ 0 ] == inString ) {
//~ 				return exifData[ i ][ 1 ];		
//~ 			}
//~ 		}
//~ 	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: prettyDate
	// Usage: Nobody liked the formatting of the date string 
	// Input: inString = date in string format
	// Output: convert 2004:01:01 12:00:00 into a Date object
	//         or 2004-10-13T10:15:58-08:00
	//         If it is not in the above format I return what was passed in
	///////////////////////////////////////////////////////////////////////////////
//~ 	drbrownserv.prettyDate = function ( inString ) {
//~ 		var outString = inString.toString();
//~ 		var dateTime = inString.toString().split( ' ' );
//~ 		var dateSplit = ':';
//~ 		if ( 2 != dateTime.length ) {
//~ 			dateTime = inString.toString().split( 'T' );
//~ 			if ( 2 != dateTime.length ) return outString;
//~ 			dateSplit = "-";
//~ 		}
//~ 		var dateArray = dateTime[ 0 ].split( dateSplit );
//~ 		if ( 3 != dateArray.length ) return outString;
//~ 		var timeArray = dateTime[ 1 ].split( ':' );
//~ 		if ( timeArray.length < 2 ) return outString;
//~ 		var prettyDate = new Date( parseInt( dateArray[ 0 ] ), 
//~ 								   parseInt( dateArray[ 1 ] - 1 ), // month is 0 <-> 11
//~ 								   parseInt( dateArray[ 2 ] ),
//~ 								   parseInt( timeArray[ 0 ] ), 
//~ 								   parseInt( timeArray[ 1 ] ), 
//~ 								   parseInt( timeArray[ 2 ] ) );
//~ 		if ( false /*gShowTime*/ ) {
//~ 			outString = prettyDate.toLocaleString();
//~ 		} else {
//~ 			outString = prettyDate.toLocaleDateString();
//~ 		}
//~ 		var addComma = outString.split( " " + dateArray[ 2 ] + " " );
//~ 		addComma[ 1 ] = ", " + addComma[ 1 ];
//~ 		outString = addComma.join( " " + dateArray[ 2 ] );
//~ 		return outString;
//~ 	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: getCopyrightNotice
	// Usage: Search the XMP for the copyright notice and return
	// It looks like this in xmp
	//         <dc:rights>
	//            <rdf:Alt>
	//               <rdf:li xml:lang="x-default">Russell Brown copyright notice</rdf:li>
	//            </rdf:Alt>
	//         </dc:rights>
	///////////////////////////////////////////////////////////////////////////////
//~ 	drbrownserv.getCopyrightNotice = function () {
//~ 		// debugger;
//~ 		var copyrightNotice = drbrownserv.getXMP( 'dc:rights' );
//~ 		if ( copyrightNotice.length ) {

//~ 			var strCombined = '<rdf:Alt>';
//~ 			var startMarker = copyrightNotice.indexOf( strCombined ) + strCombined.length;
//~ 			var endMarker = copyrightNotice.indexOf( '</rdf:Alt>' );
//~ 			if ( -1 == endMarker ) return '';
//~ 			copyrightNotice = copyrightNotice.substring( startMarker, endMarker );

//~ 			var strCombined = '<rdf:li xml:lang="x-default">';
//~ 			var startMarker = copyrightNotice.indexOf( strCombined ) + strCombined.length;
//~ 			var endMarker = copyrightNotice.indexOf( '</rdf:li>' );

//~ 			if ( -1 == endMarker ) return '';
//~ 			copyrightNotice = copyrightNotice.substring( startMarker, endMarker );
//~ 		} else {
//~ 			copyrightNotice = '';
//~ 		}
//~ 		return copyrightNotice;
//~ 	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: getDocumentKind
	// Usage: Search the XMP for the document kind and return
	///////////////////////////////////////////////////////////////////////////////
//~ 	drbrownserv.getDocumentKind = function () {
//~ 		var documentKind = drbrownserv.getXMP( 'dc:format' );
//~ 		if ( documentKind.length ) {
//~ 			documentKind = documentKind.split( '/' );
//~ 			if ( 2 == documentKind.length ) {
//~ 				documentKind = documentKind[ 1 ];
//~ 			} else {
//~ 				documentKind = '';
//~ 			}
//~ 		}
//~ 		return documentKind;
//~ 	}

	///////////////////////////////////////////////////////////////////////////////
	// Function: flattenDialog
	// Usage: find all the idString and make them properties on t
	///////////////////////////////////////////////////////////////////////////////
	drbrownserv.flattenDialog = function ( t, w ) {
		if ( w.type == 'dialog' || w.type == 'group' || w.type == 'panel' ) {
			for ( i in w ) {
				try {
					if ( w[i] != undefined && ( w[i].type == 'dialog' || w[i].type == 'group' || w[i].type == 'panel' ) && i != 'parent' && i != 'indent' && i != 'window'  ) {
						drbrownserv.flattenDialog( t, w[i] );
					} else {
						if ( w[i] != undefined && w[i].properties != undefined && w[i].properties.idString != undefined ) {
							// turn this off when your done debugging your dialog code
							// if ( t[w[i].properties.idString] != undefined ) {
							//    drbrownserv.alert('Already have a a ' + w[i].properties.idString + ' property.' ); 
							//}
							t[w[i].properties.idString] = w[i];
						}
					}
				}
				catch(e) {
					drbrownserv.alert(e + ":" + e.line);
				} 
			}
		}
	}
	
	drbrownserv.selectAdditionalLayer = function( layerName ) {
		var id44 = charIDToTypeID( "slct" );
		var desc9 = new ActionDescriptor();
		var id45 = charIDToTypeID( "null" );
		var ref8 = new ActionReference();
		var id46 = charIDToTypeID( "Lyr " );
		ref8.putName( id46, layerName );
		desc9.putReference( id45, ref8 );
		var id47 = stringIDToTypeID( "selectionModifier" );
		var id48 = stringIDToTypeID( "selectionModifierType" );
		var id49 = stringIDToTypeID( "addToSelectionContinuous" );
		desc9.putEnumerated( id47, id48, id49 );
		var id50 = charIDToTypeID( "MkVs" );
		desc9.putBoolean( id50, false );
		executeAction( id44, desc9, DialogModes.NO );
	}

	drbrownserv.selectAllLayers = function( targetDoc ) {
		app.activeDocument = targetDoc;
		targetDoc.activeLayer = targetDoc.layers[0];
		var id268 = charIDToTypeID( "slct" );
		var desc65 = new ActionDescriptor();
		var id269 = charIDToTypeID( "null" );
		var ref59 = new ActionReference();
		var id270 = charIDToTypeID( "Lyr " );
		// ref59.putName( id270, "Layer 1" );
		if ( targetDoc.layers[targetDoc.layers.length-1].isBackgroundLayer ) {
			ref59.putName( id270, localize( "$$$/LayersPalette/Base=Background" ) );
		} else {
			ref59.putIndex( id270, 1 );
		}
		desc65.putReference( id269, ref59 );
		var id271 = stringIDToTypeID( "selectionModifier" );
		var id272 = stringIDToTypeID( "selectionModifierType" );
		var id273 = stringIDToTypeID( "addToSelectionContinuous" );
		desc65.putEnumerated( id271, id272, id273 );
		var id274 = charIDToTypeID( "MkVs" );
		desc65.putBoolean( id274, false );
		executeAction( id268, desc65, DialogModes.NO );
	}

	drbrownserv.duplicateActiveLayersToDoc = function( targetDoc ) {
		var id287 = charIDToTypeID( "Dplc" );
		var desc69 = new ActionDescriptor();
		var id288 = charIDToTypeID( "null" );
		var ref63 = new ActionReference();
		var id289 = charIDToTypeID( "Lyr " );
		var id290 = charIDToTypeID( "Ordn" );
		var id291 = charIDToTypeID( "Trgt" );
		ref63.putEnumerated( id289, id290, id291 );
		desc69.putReference( id288, ref63 );
		var id292 = charIDToTypeID( "T   " );
		var ref64 = new ActionReference();
		var id293 = charIDToTypeID( "Dcmn" );
		ref64.putName( id293, targetDoc.name );
		desc69.putReference( id292, ref64 );
		var id294 = charIDToTypeID( "Vrsn" );
		desc69.putInteger( id294, 2 );
		executeAction( id287, desc69, DialogModes.NO );
	}

	drbrownserv.recursiveCountLayers = function( objToCount, currentCount ) {
		if ( undefined == currentCount ) currentCount = 0;
		try {
			currentCount += objToCount.layers.length;
			for ( var i = 0; i < objToCount.layers.length; i++ ) {
				if ( objToCount.layers[i].typename == "LayerSet" ) {
					currentCount = drbrownserv.recursiveCountLayers( objToCount.layers[i], currentCount );
				}
			}
		}
		catch( e ) { 
			// debugging alert ("recursiveCountLayers " + e + ":" + e.line);
		}
		return currentCount;
	}

	drbrownserv.groupSelectedLayers = function( groupName ) {
		var id63 = charIDToTypeID( "Mk  " );
		var desc13 = new ActionDescriptor();
		var id64 = charIDToTypeID( "null" );
		var ref10 = new ActionReference();
		var id65 = stringIDToTypeID( "layerSection" );
		ref10.putClass( id65 );
		desc13.putReference( id64, ref10 );
		var id66 = charIDToTypeID( "From" );
		var ref11 = new ActionReference();
		var id67 = charIDToTypeID( "Lyr " );
		var id68 = charIDToTypeID( "Ordn" );
		var id69 = charIDToTypeID( "Trgt" );
		ref11.putEnumerated( id67, id68, id69 );
		desc13.putReference( id66, ref11 );
		var id70 = charIDToTypeID( "Usng" );
		var desc14 = new ActionDescriptor();
		var id71 = charIDToTypeID( "Nm  " );
		desc14.putString( id71, groupName );
		var id72 = stringIDToTypeID( "layerSection" );
		desc13.putObject( id70, id72, desc14 );
		executeAction( id63, desc13, DialogModes.NO );
	}

	// make sure the string is not really long and trim it accordingly
	drbrownserv.alert = function( inString ) {
		if ( inString.length > 200 ) {
			var s = inString.substring( 0, 100 );
			var e = inString.substring( inString.length - 100 );
			var a = s + "\n...\n" + e;
			alert( a );
		} else {
			alert( inString );
		}
	}

		

} // Overall try catch

catch (error) {
	// Debugging
	drbrownserv.alert (error + ":" + error.line);
}

// End of Dr. Brown's Services.jsx
